type token =
  | TUnknown of (Ast_c.info)
  | TCommentSpace of (Ast_c.info)
  | TCommentNewline of (Ast_c.info)
  | TComment of (Ast_c.info)
  | TInt of ((string * (Ast_c.sign * Ast_c.base)) * Ast_c.info)
  | TFloat of ((string * Ast_c.floatType) * Ast_c.info)
  | TChar of ((string * Ast_c.isWchar) * Ast_c.info)
  | TString of ((string * Ast_c.isWchar) * Ast_c.info)
  | TQuote of ((string * Ast_c.isWchar) * Ast_c.info)
  | TPct of (Ast_c.info)
  | TFormat of (string * Ast_c.info)
  | TSubString of (string * Ast_c.info)
  | TDecimal of ((string * string (*n*) * string (*p*)) * Ast_c.info)
  | TIdent of (string * Ast_c.info)
  | TKRParam of (string * Ast_c.info)
  | Tconstructorname of (string * Ast_c.info)
  | TypedefIdent of (string * Ast_c.info)
  | TOPar of (Ast_c.info)
  | TCPar of (Ast_c.info)
  | TOBrace of (Ast_c.info)
  | TCBrace of (Ast_c.info)
  | TOCro of (Ast_c.info)
  | TCCro of (Ast_c.info)
  | TDot of (Ast_c.info)
  | TComma of (Ast_c.info)
  | TPtrOp of (Ast_c.info)
  | TInc of (Ast_c.info)
  | TDec of (Ast_c.info)
  | TAssign of (Ast_c.assignOp)
  | TEq of (Ast_c.info)
  | TWhy of (Ast_c.info)
  | TTilde of (Ast_c.info)
  | TBang of (Ast_c.info)
  | TEllipsis of (Ast_c.info)
  | TDotDot of (Ast_c.info)
  | TPtVirg of (Ast_c.info)
  | TOrLog of (Ast_c.info)
  | TAndLog of (Ast_c.info)
  | TOr of (Ast_c.info)
  | TXor of (Ast_c.info)
  | TAnd of (Ast_c.info)
  | TEqEq of (Ast_c.info)
  | TNotEq of (Ast_c.info)
  | TInf of (Ast_c.info)
  | TSup of (Ast_c.info)
  | TInfEq of (Ast_c.info)
  | TSupEq of (Ast_c.info)
  | TShl of (Ast_c.info)
  | TShr of (Ast_c.info)
  | TPlus of (Ast_c.info)
  | TMinus of (Ast_c.info)
  | TMul of (Ast_c.info)
  | TDiv of (Ast_c.info)
  | TMod of (Ast_c.info)
  | TMax of (Ast_c.info)
  | TMin of (Ast_c.info)
  | Tchar of (Ast_c.info)
  | Tshort of (Ast_c.info)
  | Tint of (Ast_c.info)
  | Tdouble of (Ast_c.info)
  | Tfloat of (Ast_c.info)
  | Tcomplex of (Ast_c.info)
  | Tlong of (Ast_c.info)
  | Tunsigned of (Ast_c.info)
  | Tsigned of (Ast_c.info)
  | Tvoid of (Ast_c.info)
  | Tsize_t of (Ast_c.info)
  | Tssize_t of (Ast_c.info)
  | Tptrdiff_t of (Ast_c.info)
  | TautoType of (Ast_c.info)
  | Tauto of (Ast_c.info)
  | Tregister of (Ast_c.info)
  | Textern of (Ast_c.info)
  | Tstatic of (Ast_c.info)
  | Ttypedef of (Ast_c.info)
  | Tconst of (Ast_c.info)
  | Tvolatile of (Ast_c.info)
  | Tstruct of (Ast_c.info)
  | Tunion of (Ast_c.info)
  | Tenum of (Ast_c.info)
  | Tdecimal of (Ast_c.info)
  | Texec of (Ast_c.info)
  | Tbreak of (Ast_c.info)
  | Telse of (Ast_c.info)
  | Tswitch of (Ast_c.info)
  | Tcase of (Ast_c.info)
  | Tcontinue of (Ast_c.info)
  | Tfor of (Ast_c.info)
  | Tdo of (Ast_c.info)
  | Tif of (Ast_c.info)
  | Twhile of (Ast_c.info)
  | Treturn of (Ast_c.info)
  | Tgoto of (Ast_c.info)
  | Tdefault of (Ast_c.info)
  | Tsizeof of (Ast_c.info)
  | Tnew of (Ast_c.info)
  | Tdelete of (Ast_c.info)
  | Tdefined of (Ast_c.info)
  | TOParCplusplusInit of (Ast_c.info)
  | Tnamespace of (Ast_c.info)
  | Trestrict of (Ast_c.info)
  | Tasm of (Ast_c.info)
  | Tattribute of (Ast_c.info)
  | TMacroGccEndAttr of (Ast_c.info)
  | TattributeNoarg of (Ast_c.info)
  | Tinline of (Ast_c.info)
  | Ttypeof of (Ast_c.info)
  | TDefine of (Ast_c.info)
  | TDefParamVariadic of ((string * Ast_c.info))
  | TCppEscapedNewline of (Ast_c.info)
  | TCppConcatOp of (Ast_c.info)
  | TOParDefine of (Ast_c.info)
  | TOBraceDefineInit of (Ast_c.info)
  | TIdentDefine of ((string * Ast_c.info))
  | TDefEOL of (Ast_c.info)
  | TInclude of ((string * string * bool ref * Ast_c.info))
  | TIncludeStart of ((Ast_c.info * bool ref))
  | TIncludeFilename of ((string * Ast_c.info))
  | TIfdef of ((Ast_c.ifdef_guard * (int * int) option ref * Ast_c.info))
  | TIfdefelif of ((Ast_c.ifdef_guard * (int * int) option ref * Ast_c.info))
  | TIfdefelse of (((int * int) option ref * Ast_c.info))
  | TEndif of (((int * int) option ref * Ast_c.info))
  | TIfdefBool of ((bool * (int * int) option ref * Ast_c.info))
  | TIfdefMisc of ((bool * (int * int) option ref * Ast_c.info))
  | TIfdefVersion of ((bool * (int * int) option ref * Ast_c.info))
  | TUifdef of (Ast_c.info)
  | TUelseif of (Ast_c.info)
  | TUendif of (Ast_c.info)
  | TUndef of (Ast_c.info)
  | TPrePragma of (Ast_c.info*Ast_c.info*string*Ast_c.info*Ast_c.info*(string*Ast_c.info)list)
  | TPragma of (Ast_c.info)
  | TPragmaString of (string * Ast_c.info)
  | TCppDirectiveOther of (Ast_c.info)
  | TMacroAttr of ((string * Ast_c.info))
  | TMacroAttrArgs of ((string * Ast_c.info))
  | TMacroEndAttr of ((string * Ast_c.info))
  | TMacroEndAttrArgs of ((string * Ast_c.info))
  | TMacroStmt of ((string * Ast_c.info))
  | TMacroIdStmt of ((string * Ast_c.info))
  | TMacroIdentBuilder of ((string * Ast_c.info))
  | TMacroString of ((string * Ast_c.info))
  | TMacroDecl of ((string * Ast_c.info))
  | TMacroDeclConst of (Ast_c.info)
  | TMacroIterator of ((string * Ast_c.info))
  | TCommentSkipTagStart of (Ast_c.info)
  | TCommentSkipTagEnd of (Ast_c.info)
  | TCParEOL of (Ast_c.info)
  | TAction of (Ast_c.info)
  | TCommentMisc of (Ast_c.info)
  | TCommentCpp of ((Token_c.cppcommentkind * Ast_c.info))
  | EOF of (Ast_c.info)
  | TTODO of (Ast_c.info)

open Parsing;;
let _ = parse_error;;
# 2 "parsing_c/parser_c.mly"
(* Yoann Padioleau
 *
 * Copyright (C) 2002, 2006, 2007, 2008, 2009 Yoann Padioleau
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License (GPL)
 * version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * file license.txt for more details.
 *)

(**
 * This grammar has been inspired by:
 * http://www.lysator.liu.se/c/ANSI-C-grammar-y.html
 *)

open Common

open Ast_c

module LP = Lexer_parser
open Lexer_parser (* for the fields *)

open Semantic_c (* Semantic exn *)
module T = Token_c

(*****************************************************************************)
(* Wrappers *)
(*****************************************************************************)
let warning s v =
  if !Flag_parsing_c.verbose_parsing
  then Common.warning ("PARSING: " ^ s) v
  else v

let computed_warning s v = (*do not construct string unless it will be shown*)
  if !Flag_parsing_c.verbose_parsing
  then Common.warning ("PARSING: " ^ (s())) v
  else v

let pr2, pr2_once = Common.mk_pr2_wrappers Flag_parsing_c.verbose_parsing

(*****************************************************************************)
(* Parse helpers functions *)
(*****************************************************************************)

(*-------------------------------------------------------------------------- *)
(* Type related *)
(*-------------------------------------------------------------------------- *)

type shortLong      = Short  | Long | LongLong

type decl = {
  storageD: storagebis wrap;
  typeD: ((sign option) * (shortLong option) * (typeCbis option)) wrap;
  qualifD: typeQualifierbis wrap;
  inlineD: bool             wrap;
  (* note: have a full_info: parse_info list; to remember ordering
   * between storage, qualifier, type ? well this info is already in
   * the Ast_c.info, just have to sort them to get good order *)
}

let nullDecl = {
  storageD = NoSto, [];
  typeD = (None, None, None), [];
  qualifD = nullQualif;
  inlineD = false, [];
}
let fake_pi = Common.fake_parse_info

let addStorageD  = function
  | ((x,ii), ({storageD = (NoSto,[])} as v)) -> { v with storageD = (x, [ii]) }
  | ((x,ii), ({storageD = (y, ii2)} as v)) ->
      if x = y then warning "duplicate storage classes" v
      else warning "multiple storage classes, keeping the second" v

let addInlineD  = function
  | ((true,ii), ({inlineD = (false,[])} as v)) -> { v with inlineD=(true,[ii])}
  | ((true,ii), ({inlineD = (true, ii2)} as v)) -> warning "duplicate inline" v
  | _ -> raise (Impossible 86)


let addTypeD     = function
  | ((Left3 Signed,ii)   ,({typeD = ((Some Signed,  b,c),ii2)} as v)) ->
      warning "duplicate 'signed'"   v
  | ((Left3 UnSigned,ii) ,({typeD = ((Some UnSigned,b,c),ii2)} as v)) ->
      warning "duplicate 'unsigned'" v
  | ((Left3 _,ii),        ({typeD = ((Some _,b,c),ii2)} as _v)) ->
      raise (Semantic ("both signed and unsigned specified", fake_pi))
  | ((Left3 x,ii),        ({typeD = ((None,b,c),ii2)} as v))   ->
      {v with typeD = (Some x,b,c),ii @ ii2}

  | ((Middle3 Short,ii),  ({typeD = ((a,Some Short,c),ii2)} as v)) ->
      warning "duplicate 'short'" v


  (* gccext: long long allowed *)
  | ((Middle3 Long,ii),   ({typeD = ((a,Some Long ,c),ii2)} as v)) ->
      { v with typeD = (a, Some LongLong, c),ii @ ii2 }
  | ((Middle3 Long,ii),   ({typeD = ((a,Some LongLong ,c),ii2)} as v)) ->
      warning "triplicate 'long'" v


  | ((Middle3 _,ii),      ({typeD = ((a,Some _,c),ii2)} as _v)) ->
      raise (Semantic ("both long and short specified", fake_pi))
  | ((Middle3 x,ii),      ({typeD = ((a,None,c),ii2)} as v))  ->
      {v with typeD = (a, Some x,c),ii @ ii2}

  | ((Right3 t,ii),       ({typeD = ((a,b,Some x),ii2)} as v)) ->
      let mktype t ii = (({const=false;volatile=false;},[]),(t,ii)) in
      computed_warning
	(fun _ ->
	  Printf.sprintf
	    "two or more data types: dropping %s, keeping typeD %s\n"
	    (Pretty_print_c.string_of_fullType (mktype t ii))
	    (Pretty_print_c.string_of_fullType (mktype x ii2)))
	v
  | ((Right3 t,ii),       ({typeD = ((a,b,None),ii2)} as v))   ->
      {v with typeD = (a,b, Some t),ii @ ii2}


let addQualif = function
  | (({const=true},ii),   ({const=true},ii2 as x)) ->   warning "duplicate 'const'" x
  | (({volatile=true},ii),({volatile=true},ii2 as x))-> warning "duplicate 'volatile'" x
  | (({const=true},ii),   (v,ii2)) -> {v with const=true},ii::ii2
  | (({volatile=true},ii),(v,ii2)) -> {v with volatile=true},ii2@[ii]
  | _ ->
      internal_error "there is no noconst or novolatile keyword"

let addQualifD (qu, ({qualifD = v} as x)) =
  { x with qualifD = (addQualif (qu, v)) }


(*-------------------------------------------------------------------------- *)
(* Declaration/Function related *)
(*-------------------------------------------------------------------------- *)


(* stdC: type section, basic integer types (and ritchie)
 * To understand the code, just look at the result (right part of the PM)
 * and go back.
 *)
let (fixDeclSpecForDecl: decl -> (fullType * (storage wrap)))  = function
 {storageD = (st,iist);
  qualifD = (qu,iiq);
  typeD = (ty,iit);
  inlineD = (inline,iinl);
  } ->
   let ty',iit' =
   (match ty with
 | (None,None,None)       ->
     (* generate fake_info, otherwise type_annotater can crash in
      * offset.
      *)
     warning "type defaults to 'int'" (defaultInt, [fakeInfo fake_pi])
 | (None, None, Some t)   -> (t, iit)

 | (Some sign,   None, (None| Some (BaseType (IntType (Si (_,CInt))))))  ->
     BaseType(IntType (Si (sign, CInt))), iit
 | ((None|Some Signed),Some x,(None|Some(BaseType(IntType (Si (_,CInt)))))) ->
     BaseType(IntType (Si (Signed, [Short,CShort; Long, CLong; LongLong, CLongLong] +> List.assoc x))), iit
 | (Some UnSigned, Some x, (None| Some (BaseType (IntType (Si (_,CInt))))))->
     BaseType(IntType (Si (UnSigned, [Short,CShort; Long, CLong; LongLong, CLongLong] +> List.assoc x))), iit
 | (Some sign,   None, (Some (BaseType (IntType CChar))))   ->
     BaseType(IntType (Si (sign, CChar2))), iit
 | (None, Some Long,(Some(BaseType(FloatType CDouble))))    ->
     BaseType (FloatType (CLongDouble)), iit
 | (None, Some Long,(Some(BaseType(FloatType CDoubleComplex))))    ->
     BaseType (FloatType (CLongDoubleComplex)), iit

 | (Some _,_, Some _) ->
     (*mine*)
     raise (Semantic ("signed, unsigned valid only for char and int", fake_pi))
 | (_,Some _,(Some(BaseType(FloatType (CFloat))))) ->
     raise (Semantic ("long or short specified with floating type", fake_pi))
 | (_,Some Short,(Some(BaseType(FloatType CDouble)))) ->
     raise (Semantic ("the only valid combination is long double", fake_pi))
 | (_,Some Short,(Some(BaseType(FloatType CDoubleComplex)))) ->
     raise (Semantic ("the only valid combination is long double complex", fake_pi))

 | (_, Some _, Some _) ->
     (* mine *)
     raise (Semantic ("long, short valid only for int or float", fake_pi))

     (* if do short uint i, then gcc say parse error, strange ? it is
      * not a parse error, it is just that we don't allow with typedef
      * either short/long or signed/unsigned. In fact, with
      * parse_typedef_fix2 (with et() and dt()) now I say too parse
      * error so this code is executed only when do short struct
      * {....} and never with a typedef cos now we parse short uint i
      * as short ident ident => parse error (cos after first short i
      * pass in dt() mode) *)

   )
   in
   ((qu, iiq),
   (ty', iit'))
     ,((st, inline),iist @ iinl)


let fixDeclSpecForParam = function ({storageD = (st,iist)} as r) ->
  let (qu_ty,_st) = fixDeclSpecForDecl r in
  match st with
  | (Sto Register) -> (qu_ty, true), iist
  | NoSto -> (qu_ty, false), iist
  | _ ->
      raise
        (Semantic ("storage class specified for parameter of function",
                  fake_pi))

let fixDeclSpecForArg = function ({storageD = (st,iist)} as r) ->
  let (qu_ty,_st) = fixDeclSpecForDecl r in
  (qu_ty, st = Sto Register), iist

let fixDeclSpecForMacro = function ({storageD = (st,iist)} as r) ->
  let (qu_ty,_st) = fixDeclSpecForDecl r in
  match st with
  | NoSto -> qu_ty
  | _ ->
      raise
        (Semantic ("storage class specified for macro type decl",
                  fake_pi))


let fixDeclSpecForFuncDef x =
  let (returnType,storage) = fixDeclSpecForDecl x in
  (match fst (unwrap storage) with
  | StoTypedef ->
      raise (Semantic ("function definition declared 'typedef'", fake_pi))
  | _ -> (returnType, storage)
  )


(* parameter: (this is the context where we give parameter only when
 * in func DEFINITION not in funct DECLARATION) We must have a name.
 * This function ensure that we give only parameterTypeDecl with well
 * formed Classic constructor todo?: do we accept other declaration
 * in ? so I must add them to the compound of the deffunc. I don't
 * have to handle typedef pb here cos C forbid to do VF f { ... }
 * with VF a typedef of func cos here we don't see the name of the
 * argument (in the typedef)
 *)
let (fixOldCDecl: fullType -> fullType) = fun ty ->
  match Ast_c.unwrap_typeC ty with
  | FunctionType (fullt, (params, (b, iib))) ->

      (* stdC: If the prototype declaration declares a parameter for a
       * function that you are defining (it is part of a function
       * definition), then you must write a name within the declarator.
       * Otherwise, you can omit the name. *)
      (match params with
      | [{p_namei = None; p_type = ty2},_] ->
          (match Ast_c.unwrap_typeC ty2 with
          | BaseType Void ->
              ty
          | _ ->
              pr2_once ("SEMANTIC:parameter name omitted, but I continue");
              ty
          )

      | params ->
          (params +> List.iter (fun (param,_) ->
            match param with
            | {p_namei = None} ->
              (* if majuscule, then certainly macro-parameter *)
                pr2_once ("SEMANTIC:parameter name omitted, but I continue");
	    | _ -> ()
          ));
          ty
      )

        (* todo? can we declare prototype in the decl or structdef,
           ... => length <> but good kan meme *)
  | _ ->
      (* gcc say parse error but don't see why *)
      raise (Semantic ("seems this is not a function", fake_pi))


let fixFunc (typ, compound, old_style_opt) =
  let (cp,iicp) = compound in

  let ((name, ty,   (st,iist),  attrs), endattrs) = typ in

  let (qu, tybis) = ty in

  match Ast_c.unwrap_typeC ty with
  | FunctionType (fullt, (params,abool)) ->
      let iifunc = Ast_c.get_ii_typeC_take_care tybis in

      let iistart = Ast_c.fakeInfo () in
      assert (qu = nullQualif);

      (match params with
      | [{p_namei= None; p_type = ty2}, _] ->
          (match Ast_c.unwrap_typeC ty2 with
          | BaseType Void ->  ()
          | _ ->
                (* failwith "internal error: fixOldCDecl not good" *)
              ()
          )
      | params ->
          params +> List.iter (function
          | ({p_namei = Some s}, _) -> ()
	  | _ -> ()
                (* failwith "internal error: fixOldCDecl not good" *)
          )
      );
      (* bugfix: cf tests_c/function_pointer4.c.
       * Apparemment en C on peut syntaxiquement ecrire ca:
       *
       *   void a(int)(int x);
       * mais apres gcc gueule au niveau semantique avec:
       *   xxx.c:1: error: 'a' declared as function returning a function
       * Je ne faisais pas cette verif. Sur du code comme
       *   void METH(foo)(int x) { ...} , le parser croit (a tort) que foo
       * est un typedef, et donc c'est parsé comme l'exemple precedent,
       * ce qui ensuite confuse l'unparser qui n'est pas habitué
       * a avoir dans le returnType un FunctionType et qui donc
       * pr_elem les ii dans le mauvais sens ce qui genere au final
       * une exception. Hence this fix to at least detect the error
       * at parsing time (not unparsing time).
       *)
      (match Ast_c.unwrap_typeC fullt with
      | FunctionType _ ->
          let s = Ast_c.str_of_name name in
          let iis = Ast_c.info_of_name name in
          pr2 (spf "WEIRD: %s declared as function returning a function." s);
          pr2 (spf "This is probably because of a macro. Extend standard.h");
          raise (Semantic (spf "error: %s " s, Ast_c.parse_info_of_info iis))
      | _ -> ()
      );

      (* it must be nullQualif,cos parser construct only this*)
      {f_name = name;
       f_type = (fullt, (params, abool));
       f_storage = st;
       f_body =
	if !Flag_parsing_c.parsing_header_for_types
	then []
	else cp;
       f_attr = attrs;
       f_endattr = endattrs;
       f_old_c_style = old_style_opt;
      },
      (iifunc @ iicp @ [iistart] @ iist)
  | _ ->
      raise
        (Semantic
            ("you are trying to do a function definition but you don't give " ^
             "any parameter", fake_pi))


(*-------------------------------------------------------------------------- *)
(* parse_typedef_fix2 *)
(*-------------------------------------------------------------------------- *)

let dt s () =
  if !Flag_parsing_c.debug_etdt then pr2 ("<" ^ s);
  LP.disable_typedef ()

let et s () =
  if !Flag_parsing_c.debug_etdt then pr2 (">" ^ s);
  LP.enable_typedef ()


let fix_add_params_ident x =
  let (s, ty, st, _attrs) = x in
  match Ast_c.unwrap_typeC ty with
  | FunctionType (fullt, (params, bool)) ->

      (match params with
      | [{p_namei=None; p_type=ty2}, _] ->
          (match Ast_c.unwrap_typeC ty2 with
          | BaseType Void -> ()
          | _ ->
              (* failwith "internal error: fixOldCDecl not good" *)
              ()
          )
      | params ->
          params +> List.iter (function
          | ({p_namei= Some name}, _) ->
              LP.add_ident (Ast_c.str_of_name s)
	  | _ ->
              ()
                (* failwith "internal error: fixOldCDecl not good" *)
          )
      )
  | _ -> ()

(*-------------------------------------------------------------------------- *)
(* shortcuts *)
(*-------------------------------------------------------------------------- *)

let mk_e e ii = Ast_c.mk_e e ii

let mk_string_wrap (s,info) = (s, [info])

(*-------------------------------------------------------------------------- *)
(* support for functions with no return type *)
(*-------------------------------------------------------------------------- *)

let args_are_params l =
  match l with
    [Right (ArgAction(ActMisc [x])), ii] when Ast_c.is_fake x -> true
  | _ -> List.for_all (function Right (ArgType x), ii -> true | _ -> false) l
let args_to_params l pb =
  let pi =
    match pb with Some pb -> Ast_c.parse_info_of_info pb | None -> fake_pi in
  match l with
    [(Right (ArgAction(ActMisc [x])), ii)] when Ast_c.is_fake x -> []
  | l ->
      List.map
	(function
	    Right (ArgType x), ii -> x, ii
	  | x ->
	      raise
		(Semantic
		   ("function with no return type must have types in param list",
		    pi)))
	l

(* For fake info added at the end of a conditional or iteration, to have the
correct position information *)
let postfakeInfo pii  =
  let (max,min) =  Lib_parsing_c.max_min_ii_by_pos pii in
  let max_pi = Ast_c.get_info (fun x -> x) max in
  let vp = ({str="";charpos=max_pi.Common.charpos;line=max_pi.Common.line;
	      column=max_pi.Common.column;file=max_pi.Common.file},
	    String.length max_pi.Common.str) in
  { pinfo = FakeTok ("",vp);
    cocci_tag = ref Ast_c.emptyAnnot;
    annots_tag = Token_annot.empty;
    comments_tag = ref Ast_c.emptyComments;
    danger = ref Ast_c.NoDanger;
  }

# 597 "parsing_c/parser_c.ml"
let yytransl_const = [|
    0|]

let yytransl_block = [|
  257 (* TUnknown *);
  258 (* TCommentSpace *);
  259 (* TCommentNewline *);
  260 (* TComment *);
  261 (* TInt *);
  262 (* TFloat *);
  263 (* TChar *);
  264 (* TString *);
  265 (* TQuote *);
  266 (* TPct *);
  267 (* TFormat *);
  268 (* TSubString *);
  269 (* TDecimal *);
  270 (* TIdent *);
  271 (* TKRParam *);
  272 (* Tconstructorname *);
  273 (* TypedefIdent *);
  274 (* TOPar *);
  275 (* TCPar *);
  276 (* TOBrace *);
  277 (* TCBrace *);
  278 (* TOCro *);
  279 (* TCCro *);
  280 (* TDot *);
  281 (* TComma *);
  282 (* TPtrOp *);
  283 (* TInc *);
  284 (* TDec *);
  285 (* TAssign *);
  286 (* TEq *);
  287 (* TWhy *);
  288 (* TTilde *);
  289 (* TBang *);
  290 (* TEllipsis *);
  291 (* TDotDot *);
  292 (* TPtVirg *);
  293 (* TOrLog *);
  294 (* TAndLog *);
  295 (* TOr *);
  296 (* TXor *);
  297 (* TAnd *);
  298 (* TEqEq *);
  299 (* TNotEq *);
  300 (* TInf *);
  301 (* TSup *);
  302 (* TInfEq *);
  303 (* TSupEq *);
  304 (* TShl *);
  305 (* TShr *);
  306 (* TPlus *);
  307 (* TMinus *);
  308 (* TMul *);
  309 (* TDiv *);
  310 (* TMod *);
  311 (* TMax *);
  312 (* TMin *);
  313 (* Tchar *);
  314 (* Tshort *);
  315 (* Tint *);
  316 (* Tdouble *);
  317 (* Tfloat *);
  318 (* Tcomplex *);
  319 (* Tlong *);
  320 (* Tunsigned *);
  321 (* Tsigned *);
  322 (* Tvoid *);
  323 (* Tsize_t *);
  324 (* Tssize_t *);
  325 (* Tptrdiff_t *);
  326 (* TautoType *);
  327 (* Tauto *);
  328 (* Tregister *);
  329 (* Textern *);
  330 (* Tstatic *);
  331 (* Ttypedef *);
  332 (* Tconst *);
  333 (* Tvolatile *);
  334 (* Tstruct *);
  335 (* Tunion *);
  336 (* Tenum *);
  337 (* Tdecimal *);
  338 (* Texec *);
  339 (* Tbreak *);
  340 (* Telse *);
  341 (* Tswitch *);
  342 (* Tcase *);
  343 (* Tcontinue *);
  344 (* Tfor *);
  345 (* Tdo *);
  346 (* Tif *);
  347 (* Twhile *);
  348 (* Treturn *);
  349 (* Tgoto *);
  350 (* Tdefault *);
  351 (* Tsizeof *);
  352 (* Tnew *);
  353 (* Tdelete *);
  354 (* Tdefined *);
  355 (* TOParCplusplusInit *);
  356 (* Tnamespace *);
  357 (* Trestrict *);
  358 (* Tasm *);
  359 (* Tattribute *);
  360 (* TMacroGccEndAttr *);
  361 (* TattributeNoarg *);
  362 (* Tinline *);
  363 (* Ttypeof *);
  364 (* TDefine *);
  365 (* TDefParamVariadic *);
  366 (* TCppEscapedNewline *);
  367 (* TCppConcatOp *);
  368 (* TOParDefine *);
  369 (* TOBraceDefineInit *);
  370 (* TIdentDefine *);
  371 (* TDefEOL *);
  372 (* TInclude *);
  373 (* TIncludeStart *);
  374 (* TIncludeFilename *);
  375 (* TIfdef *);
  376 (* TIfdefelif *);
  377 (* TIfdefelse *);
  378 (* TEndif *);
  379 (* TIfdefBool *);
  380 (* TIfdefMisc *);
  381 (* TIfdefVersion *);
  382 (* TUifdef *);
  383 (* TUelseif *);
  384 (* TUendif *);
  385 (* TUndef *);
  386 (* TPrePragma *);
  387 (* TPragma *);
  388 (* TPragmaString *);
  389 (* TCppDirectiveOther *);
  390 (* TMacroAttr *);
  391 (* TMacroAttrArgs *);
  392 (* TMacroEndAttr *);
  393 (* TMacroEndAttrArgs *);
  394 (* TMacroStmt *);
  395 (* TMacroIdStmt *);
  396 (* TMacroIdentBuilder *);
  397 (* TMacroString *);
  398 (* TMacroDecl *);
  399 (* TMacroDeclConst *);
  400 (* TMacroIterator *);
  401 (* TCommentSkipTagStart *);
  402 (* TCommentSkipTagEnd *);
  403 (* TCParEOL *);
  404 (* TAction *);
  405 (* TCommentMisc *);
  406 (* TCommentCpp *);
    0 (* EOF *);
  407 (* TTODO *);
    0|]

let yylhs = "\255\255\
\001\000\008\000\008\000\008\000\010\000\010\000\010\000\011\000\
\011\000\012\000\012\000\014\000\014\000\014\000\014\000\013\000\
\013\000\013\000\015\000\015\000\004\000\004\000\017\000\017\000\
\017\000\018\000\018\000\020\000\020\000\020\000\020\000\020\000\
\020\000\020\000\020\000\020\000\020\000\020\000\020\000\020\000\
\020\000\020\000\020\000\020\000\020\000\020\000\020\000\020\000\
\022\000\022\000\019\000\019\000\019\000\019\000\019\000\019\000\
\019\000\019\000\019\000\019\000\019\000\019\000\027\000\027\000\
\027\000\027\000\027\000\027\000\026\000\026\000\026\000\026\000\
\026\000\026\000\026\000\025\000\025\000\025\000\025\000\025\000\
\025\000\025\000\025\000\025\000\025\000\030\000\030\000\030\000\
\030\000\030\000\030\000\030\000\030\000\030\000\030\000\030\000\
\033\000\033\000\037\000\037\000\038\000\039\000\039\000\039\000\
\042\000\042\000\042\000\041\000\043\000\046\000\023\000\024\000\
\003\000\047\000\047\000\047\000\047\000\047\000\047\000\047\000\
\047\000\047\000\047\000\047\000\048\000\048\000\048\000\048\000\
\055\000\055\000\057\000\057\000\057\000\036\000\059\000\059\000\
\061\000\061\000\061\000\062\000\062\000\062\000\062\000\062\000\
\049\000\049\000\049\000\050\000\050\000\050\000\050\000\050\000\
\007\000\007\000\007\000\007\000\007\000\007\000\007\000\007\000\
\051\000\051\000\051\000\051\000\051\000\051\000\034\000\034\000\
\052\000\052\000\068\000\070\000\070\000\070\000\070\000\070\000\
\054\000\054\000\054\000\054\000\072\000\072\000\072\000\072\000\
\073\000\073\000\071\000\074\000\074\000\074\000\074\000\074\000\
\074\000\074\000\074\000\074\000\074\000\074\000\074\000\074\000\
\074\000\074\000\074\000\074\000\074\000\074\000\074\000\074\000\
\074\000\074\000\074\000\074\000\074\000\074\000\074\000\074\000\
\074\000\074\000\074\000\074\000\074\000\074\000\074\000\074\000\
\074\000\075\000\075\000\075\000\075\000\075\000\075\000\075\000\
\075\000\075\000\075\000\075\000\075\000\075\000\075\000\075\000\
\075\000\075\000\075\000\075\000\075\000\075\000\075\000\029\000\
\078\000\078\000\078\000\079\000\079\000\081\000\081\000\080\000\
\083\000\085\000\085\000\086\000\086\000\086\000\086\000\088\000\
\088\000\087\000\087\000\087\000\087\000\087\000\087\000\090\000\
\091\000\095\000\095\000\095\000\096\000\096\000\096\000\096\000\
\096\000\096\000\096\000\096\000\096\000\094\000\094\000\098\000\
\098\000\098\000\098\000\040\000\040\000\040\000\040\000\102\000\
\100\000\100\000\101\000\104\000\104\000\104\000\104\000\104\000\
\104\000\105\000\089\000\089\000\089\000\089\000\005\000\005\000\
\106\000\107\000\107\000\107\000\107\000\110\000\110\000\110\000\
\114\000\114\000\114\000\114\000\114\000\114\000\114\000\114\000\
\114\000\114\000\116\000\116\000\116\000\116\000\116\000\116\000\
\116\000\116\000\116\000\116\000\113\000\113\000\113\000\113\000\
\115\000\115\000\056\000\099\000\117\000\117\000\117\000\119\000\
\119\000\119\000\119\000\119\000\119\000\111\000\120\000\121\000\
\118\000\118\000\118\000\122\000\122\000\112\000\112\000\112\000\
\031\000\031\000\125\000\125\000\125\000\125\000\125\000\127\000\
\127\000\127\000\032\000\032\000\128\000\128\000\128\000\133\000\
\133\000\133\000\133\000\134\000\134\000\134\000\134\000\134\000\
\134\000\135\000\135\000\137\000\137\000\137\000\138\000\138\000\
\076\000\129\000\141\000\139\000\140\000\131\000\131\000\077\000\
\077\000\077\000\146\000\146\000\147\000\063\000\149\000\149\000\
\150\000\150\000\148\000\148\000\148\000\151\000\152\000\152\000\
\154\000\154\000\153\000\153\000\006\000\006\000\006\000\006\000\
\006\000\006\000\156\000\156\000\155\000\155\000\155\000\155\000\
\155\000\155\000\155\000\155\000\155\000\155\000\155\000\155\000\
\158\000\158\000\158\000\158\000\158\000\066\000\066\000\160\000\
\160\000\159\000\161\000\163\000\162\000\064\000\064\000\064\000\
\064\000\064\000\064\000\064\000\164\000\164\000\164\000\164\000\
\009\000\009\000\002\000\002\000\002\000\002\000\002\000\002\000\
\002\000\002\000\058\000\060\000\143\000\145\000\123\000\124\000\
\130\000\132\000\092\000\093\000\082\000\084\000\035\000\035\000\
\067\000\067\000\069\000\069\000\028\000\028\000\053\000\053\000\
\142\000\142\000\136\000\136\000\136\000\144\000\144\000\144\000\
\109\000\109\000\109\000\097\000\097\000\044\000\044\000\045\000\
\045\000\016\000\016\000\016\000\126\000\126\000\165\000\165\000\
\103\000\166\000\166\000\167\000\168\000\168\000\168\000\168\000\
\065\000\108\000\108\000\157\000\157\000\021\000\021\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000"

let yylen = "\002\000\
\002\000\000\000\002\000\006\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\003\000\
\002\000\004\000\001\000\003\000\001\000\003\000\001\000\003\000\
\003\000\001\000\005\000\001\000\003\000\003\000\003\000\003\000\
\003\000\003\000\003\000\003\000\003\000\003\000\003\000\003\000\
\003\000\003\000\003\000\003\000\003\000\003\000\003\000\003\000\
\001\000\004\000\001\000\002\000\002\000\002\000\002\000\004\000\
\002\000\005\000\002\000\004\000\002\000\004\000\004\000\003\000\
\004\000\003\000\001\000\004\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\004\000\004\000\003\000\003\000\
\003\000\002\000\002\000\005\000\007\000\001\000\001\000\001\000\
\001\000\003\000\001\000\001\000\003\000\001\000\002\000\003\000\
\000\000\002\000\002\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\002\000\005\000\
\006\000\004\000\001\000\004\000\003\000\004\000\006\000\003\000\
\001\000\001\000\002\000\003\000\002\000\003\000\000\000\001\000\
\001\000\001\000\002\000\001\000\001\000\001\000\001\000\001\000\
\001\000\002\000\002\000\005\000\007\000\005\000\009\000\011\000\
\005\000\007\000\006\000\007\000\006\000\007\000\005\000\004\000\
\002\000\001\000\001\000\001\000\002\000\003\000\001\000\001\000\
\002\000\001\000\002\000\001\000\004\000\007\000\001\000\000\000\
\000\000\004\000\003\000\002\000\000\000\003\000\003\000\004\000\
\000\000\003\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\002\000\002\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\006\000\004\000\001\000\001\000\004\000\004\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\004\000\004\000\
\001\000\002\000\001\000\001\000\002\000\002\000\003\000\001\000\
\001\000\001\000\003\000\003\000\004\000\003\000\004\000\001\000\
\001\000\001\000\001\000\002\000\003\000\002\000\003\000\003\000\
\004\000\002\000\003\000\003\000\004\000\001\000\003\000\001\000\
\002\000\002\000\001\000\001\000\002\000\002\000\001\000\001\000\
\001\000\002\000\001\000\001\000\001\000\001\000\002\000\002\000\
\002\000\001\000\001\000\001\000\002\000\002\000\001\000\002\000\
\001\000\003\000\003\000\007\000\008\000\002\000\001\000\000\000\
\001\000\001\000\001\000\001\000\001\000\002\000\002\000\002\000\
\002\000\002\000\001\000\001\000\001\000\001\000\001\000\002\000\
\002\000\002\000\002\000\002\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\003\000\004\000\001\000\
\002\000\003\000\004\000\004\000\005\000\001\000\001\000\001\000\
\001\000\002\000\002\000\004\000\005\000\001\000\004\000\002\000\
\001\000\003\000\001\000\004\000\002\000\003\000\003\000\002\000\
\003\000\005\000\001\000\000\000\005\000\004\000\002\000\001\000\
\001\000\002\000\002\000\001\000\001\000\005\000\005\000\001\000\
\001\000\004\000\003\000\001\000\002\000\003\000\001\000\002\000\
\001\000\001\000\001\000\001\000\001\000\001\000\000\000\005\000\
\006\000\002\000\001\000\003\000\001\000\001\000\001\000\002\000\
\001\000\002\000\002\000\003\000\003\000\001\000\002\000\001\000\
\003\000\004\000\001\000\002\000\002\000\004\000\007\000\003\000\
\004\000\001\000\001\000\002\000\001\000\001\000\001\000\001\000\
\002\000\002\000\001\000\005\000\006\000\004\000\005\000\000\000\
\001\000\001\000\001\000\001\000\001\000\003\000\001\000\003\000\
\003\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\006\000\005\000\004\000\002\000\
\001\000\001\000\005\000\001\000\001\000\001\000\001\000\005\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\002\000\002\000\001\000\002\000\
\001\000\002\000\001\000\003\000\001\000\003\000\001\000\003\000\
\001\000\002\000\001\000\004\000\003\000\001\000\004\000\003\000\
\001\000\004\000\003\000\001\000\003\000\001\000\002\000\000\000\
\002\000\000\000\001\000\003\000\001\000\002\000\001\000\002\000\
\001\000\001\000\004\000\004\000\001\000\001\000\002\000\002\000\
\001\000\001\000\000\000\001\000\000\000\001\000\000\000\002\000\
\002\000\002\000\002\000\002\000\002\000\002\000"

let yydefred = "\000\000\
\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\032\002\000\000\008\000\000\000\245\000\225\001\227\000\236\000\
\228\000\000\000\000\000\009\000\237\000\239\000\238\000\226\000\
\233\000\234\000\235\000\244\000\087\001\088\001\086\001\085\001\
\090\001\249\000\250\000\000\000\000\000\000\000\000\000\000\000\
\251\000\000\000\000\000\000\000\000\000\000\000\000\000\202\001\
\204\001\203\001\205\001\210\001\211\001\212\001\000\000\000\000\
\178\001\254\000\000\000\226\001\033\002\221\001\220\001\000\000\
\000\000\218\001\217\001\223\001\248\000\240\000\241\000\000\000\
\000\000\252\000\253\000\000\000\091\001\000\000\000\000\092\001\
\000\000\145\001\000\000\146\001\158\001\000\000\166\001\168\001\
\206\001\207\001\209\001\208\001\222\001\087\000\088\000\091\000\
\000\000\000\000\092\000\000\000\013\000\000\000\227\001\000\000\
\000\000\073\000\074\000\145\000\075\000\069\000\071\000\072\000\
\070\000\015\000\000\000\163\000\000\000\000\000\162\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\018\002\000\000\
\000\000\123\000\000\000\000\000\000\000\034\002\000\000\118\000\
\086\000\000\000\000\000\021\000\023\000\000\000\000\000\028\000\
\000\000\000\000\000\000\076\000\000\000\115\000\113\000\114\000\
\116\000\117\000\000\000\000\000\000\000\022\002\021\002\000\000\
\000\000\000\000\011\000\036\002\000\000\000\000\000\000\050\001\
\000\000\037\002\038\002\000\000\001\000\003\000\235\001\000\000\
\232\000\231\000\015\002\130\001\000\000\131\001\005\000\006\000\
\229\001\007\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\089\001\072\001\000\000\000\000\173\001\000\000\000\000\
\000\000\000\000\216\001\000\000\000\000\000\000\000\000\000\000\
\074\001\071\001\073\001\000\000\009\001\008\001\010\001\026\002\
\000\000\000\000\000\000\000\000\000\000\000\000\103\001\000\000\
\001\002\167\001\000\000\062\001\070\001\233\001\000\000\000\000\
\161\001\163\001\159\001\000\000\000\000\000\000\000\000\100\000\
\000\000\000\000\000\000\000\000\000\000\052\000\000\000\053\000\
\000\000\000\000\110\000\049\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\014\000\161\000\000\000\055\000\
\000\000\000\000\000\000\000\000\000\000\067\000\000\000\059\000\
\000\000\061\000\000\000\000\000\000\000\017\000\000\000\000\000\
\000\000\000\000\000\000\000\000\147\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\082\000\083\000\054\000\167\000\168\000\239\001\
\000\000\119\000\000\000\000\000\000\000\141\000\143\000\000\000\
\140\000\138\000\000\000\136\000\000\000\142\000\144\000\146\000\
\024\002\023\002\047\001\048\001\049\001\000\000\000\000\000\000\
\000\000\057\001\000\000\056\001\000\000\032\001\236\001\169\001\
\000\000\000\000\040\001\000\000\004\002\016\002\000\000\157\001\
\000\000\254\001\000\000\000\000\002\000\000\000\000\000\237\001\
\001\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\176\001\
\000\000\000\000\036\001\000\000\102\000\000\000\245\001\103\000\
\104\000\108\000\000\000\000\000\105\000\106\000\247\001\107\000\
\109\000\000\000\082\001\084\001\081\001\083\001\080\001\000\000\
\000\000\000\000\106\001\000\000\016\001\000\000\000\000\051\001\
\052\001\005\001\000\000\058\001\000\000\059\001\102\001\000\000\
\000\000\000\000\000\000\133\001\000\000\136\001\000\000\137\001\
\000\000\000\000\147\001\132\001\249\001\000\000\000\000\165\001\
\160\001\162\001\164\001\101\000\099\000\090\000\098\000\019\000\
\000\000\093\000\096\000\000\000\222\000\223\000\225\000\224\000\
\000\000\219\000\214\000\215\000\212\000\213\000\218\000\195\000\
\196\000\198\000\197\000\216\000\217\000\000\000\206\000\205\000\
\210\000\211\000\209\000\199\000\200\000\204\000\203\000\202\000\
\201\000\208\000\207\000\188\000\189\000\190\000\191\000\192\000\
\194\000\193\000\221\000\220\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\130\000\
\128\000\129\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\193\001\
\194\001\196\001\197\001\195\001\000\000\011\002\000\000\000\000\
\022\000\125\000\024\000\025\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\029\000\030\000\033\000\
\032\000\031\000\112\000\000\000\079\000\000\000\000\000\080\000\
\081\000\240\001\000\000\000\000\000\000\228\001\134\000\139\000\
\026\001\000\000\022\001\000\000\000\000\000\000\000\000\000\000\
\002\000\170\001\000\000\000\000\000\000\000\000\043\001\033\001\
\034\001\000\000\000\000\000\000\000\000\243\000\000\000\000\000\
\000\000\000\000\241\001\000\000\000\000\000\001\247\000\246\000\
\000\000\000\000\000\000\000\000\000\000\231\001\000\000\000\000\
\000\000\115\001\000\000\000\000\113\001\000\000\013\002\186\001\
\185\001\174\001\180\001\177\001\007\002\255\000\000\000\037\001\
\038\001\009\002\000\000\000\000\215\001\011\001\000\000\000\000\
\017\001\000\000\012\001\014\001\000\000\053\001\054\001\007\001\
\000\000\000\000\104\001\003\002\000\000\000\000\110\001\094\001\
\000\000\000\000\000\000\000\000\000\000\148\001\000\000\000\000\
\000\000\251\001\000\000\000\000\234\001\126\001\250\001\107\001\
\000\000\000\000\000\000\000\000\000\000\124\000\180\000\000\000\
\000\000\126\000\000\000\000\000\000\000\000\000\000\000\000\000\
\064\000\000\000\066\000\000\000\000\000\000\000\060\000\062\000\
\000\000\000\000\020\002\000\000\019\002\122\000\018\000\000\000\
\199\001\160\000\000\000\000\000\000\000\000\000\050\000\078\000\
\077\000\000\000\021\001\023\001\027\001\024\001\000\000\028\001\
\000\000\000\000\031\001\005\002\042\001\000\000\000\002\000\000\
\230\001\152\001\156\001\000\000\219\001\000\000\000\000\175\000\
\000\000\243\001\242\001\224\001\238\001\000\000\000\000\000\000\
\000\000\000\000\120\001\000\000\000\000\000\000\232\001\000\000\
\117\001\000\000\014\002\246\001\214\001\000\000\248\001\000\000\
\000\000\013\001\015\001\000\000\000\000\000\000\002\002\095\001\
\000\000\112\001\000\000\125\001\000\000\000\000\144\001\139\001\
\000\000\000\000\000\000\149\001\141\001\020\000\000\000\179\000\
\000\000\000\000\000\000\000\000\150\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\153\000\063\000\065\000\000\000\
\068\000\120\000\000\000\000\000\012\002\000\000\159\000\027\000\
\084\000\000\000\025\001\029\001\004\000\153\001\255\001\242\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\121\001\
\000\000\119\001\114\001\000\000\000\000\118\001\213\001\108\001\
\000\000\000\000\000\000\000\000\098\001\000\000\000\000\000\000\
\000\000\000\000\253\001\000\000\138\001\142\001\186\000\000\000\
\000\000\000\000\178\000\127\000\155\000\000\000\157\000\000\000\
\000\000\000\000\121\000\000\000\198\001\000\000\000\000\000\000\
\187\000\000\000\000\000\244\001\000\000\000\000\175\001\000\000\
\028\002\188\001\116\001\109\001\000\000\099\001\100\001\111\001\
\060\001\000\000\135\001\134\001\252\001\000\000\182\000\183\000\
\156\000\158\000\154\000\149\000\000\000\000\000\000\000\085\000\
\173\000\000\000\000\000\122\001\101\001\061\001\184\000\000\000\
\000\000\200\001\201\001\000\000\000\000\151\000\000\000\000\000\
\174\000\152\000"

let yydgoto = "\008\000\
\009\000\061\000\193\002\143\000\172\000\079\001\144\000\010\000\
\182\000\105\002\183\001\145\000\171\000\147\000\201\001\021\002\
\148\000\149\000\150\000\151\000\030\002\152\000\153\000\052\002\
\154\000\155\000\021\001\142\001\065\000\156\000\107\002\084\002\
\249\000\157\000\118\001\158\000\250\000\197\001\143\001\150\001\
\145\001\151\001\152\001\146\001\153\001\012\003\159\000\160\000\
\161\000\162\000\163\000\119\001\154\001\245\001\001\002\002\002\
\082\001\164\000\083\001\063\002\084\001\085\001\067\000\087\001\
\165\000\194\002\090\002\091\002\225\002\226\002\098\003\020\003\
\164\002\246\001\069\000\070\000\071\000\072\000\073\000\074\000\
\075\000\201\000\122\001\094\002\191\001\226\000\227\000\228\000\
\171\001\166\001\131\002\097\001\104\001\105\001\066\002\099\001\
\106\001\107\001\147\001\080\002\081\002\109\001\137\002\176\000\
\177\000\100\001\077\000\229\000\230\000\078\000\177\001\144\002\
\202\000\080\000\081\000\217\000\231\000\232\000\139\002\233\000\
\140\002\163\001\108\002\241\002\109\002\110\002\111\002\082\000\
\083\000\240\000\186\001\158\002\084\000\187\001\188\001\153\002\
\154\002\155\002\156\002\013\003\189\001\190\001\196\000\113\001\
\218\002\114\001\115\001\085\000\245\000\246\000\086\000\087\000\
\234\000\088\000\135\001\138\001\106\003\022\002\195\002\093\003\
\090\000\091\000\092\000\093\000\189\000\166\000\167\000\168\000"

let yysindex = "\021\004\
\000\000\052\013\152\020\147\024\059\032\234\000\138\000\000\000\
\000\000\226\012\000\000\068\255\000\000\000\000\000\000\000\000\
\000\000\032\255\049\255\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\197\255\197\255\075\000\120\255\134\255\
\000\000\137\255\231\255\157\031\018\000\093\255\237\255\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\193\255\090\000\
\000\000\000\000\093\000\000\000\000\000\000\000\000\000\029\000\
\236\031\000\000\000\000\000\000\000\000\000\000\000\000\157\031\
\157\031\000\000\000\000\017\011\000\000\233\255\239\255\000\000\
\157\031\000\000\116\001\000\000\000\000\255\030\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\016\000\000\000\122\000\000\000\205\022\000\000\147\024\
\147\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\075\255\000\000\004\001\147\024\000\000\007\001\
\152\020\020\001\033\001\147\024\040\255\019\001\147\024\065\033\
\255\022\087\255\064\255\231\255\052\001\241\000\000\000\064\001\
\079\001\000\000\106\001\000\000\148\001\000\000\210\255\000\000\
\000\000\000\000\050\001\000\000\000\000\139\255\039\008\000\000\
\059\032\054\002\147\024\000\000\038\255\000\000\000\000\000\000\
\000\000\000\000\132\001\013\019\137\001\000\000\000\000\159\000\
\122\000\150\001\000\000\000\000\059\032\059\032\059\032\000\000\
\136\000\000\000\000\000\188\001\000\000\000\000\000\000\035\029\
\000\000\000\000\000\000\000\000\197\255\000\000\000\000\000\000\
\000\000\000\000\185\001\098\255\147\024\187\001\038\255\203\001\
\238\001\000\000\000\000\122\021\081\016\000\000\141\001\131\001\
\115\015\226\015\000\000\236\031\236\031\236\031\236\031\236\031\
\000\000\000\000\000\000\148\000\000\000\000\000\000\000\000\000\
\157\001\115\255\125\000\072\002\232\001\020\000\000\000\063\255\
\000\000\000\000\028\002\000\000\000\000\000\000\027\002\083\027\
\000\000\000\000\000\000\017\011\078\031\196\255\032\002\000\000\
\048\002\016\000\042\002\176\000\039\002\000\000\059\032\000\000\
\031\034\147\024\000\000\000\000\002\001\011\021\231\001\147\024\
\147\024\150\001\122\000\147\024\000\000\000\000\153\019\000\000\
\059\032\041\002\050\002\115\015\052\002\000\000\063\002\000\000\
\081\255\000\000\038\255\076\002\238\001\000\000\080\002\115\015\
\226\015\253\000\183\013\147\024\000\000\153\019\147\024\147\024\
\147\024\147\024\147\024\147\024\147\024\147\024\147\024\147\024\
\147\024\147\024\147\024\147\024\147\024\147\024\147\024\147\024\
\147\024\147\024\147\024\147\024\147\024\051\002\038\014\147\024\
\098\255\098\255\000\000\000\000\000\000\000\000\000\000\000\000\
\038\255\000\000\000\000\147\024\061\002\000\000\000\000\073\002\
\000\000\000\000\089\002\000\000\013\019\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\023\002\050\023\119\001\
\193\029\000\000\165\001\000\000\087\002\000\000\000\000\000\000\
\093\002\094\002\000\000\049\002\000\000\000\000\098\255\000\000\
\095\002\000\000\097\002\179\000\000\000\037\255\111\002\000\000\
\000\000\112\002\123\002\125\002\152\020\065\255\253\000\104\022\
\000\000\210\255\000\000\013\019\000\000\047\002\030\002\000\000\
\131\001\040\002\000\000\255\001\000\000\255\000\000\000\000\000\
\000\000\000\000\049\002\008\002\000\000\000\000\000\000\000\000\
\000\000\044\255\000\000\000\000\000\000\000\000\000\000\140\002\
\066\255\000\000\000\000\125\000\000\000\100\023\035\029\000\000\
\000\000\000\000\072\002\000\000\008\026\000\000\000\000\226\015\
\151\023\226\015\083\027\000\000\148\002\000\000\153\002\000\000\
\168\001\146\002\000\000\000\000\000\000\083\027\157\001\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\071\002\000\000\000\000\051\002\000\000\000\000\000\000\000\000\
\166\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\081\255\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\158\002\031\034\022\001\147\024\
\153\019\154\022\154\022\181\002\074\001\083\001\150\001\000\000\
\000\000\000\000\051\002\149\014\004\015\085\001\147\024\147\024\
\182\002\191\002\038\255\112\002\147\024\098\001\115\001\000\000\
\000\000\000\000\000\000\000\000\144\001\000\000\037\020\145\001\
\000\000\000\000\000\000\000\000\150\001\176\002\204\008\034\004\
\154\005\126\003\001\004\184\005\184\005\220\002\220\002\220\002\
\220\002\255\002\255\002\093\003\093\003\000\000\000\000\000\000\
\000\000\000\000\000\000\201\023\000\000\191\001\060\000\000\000\
\000\000\000\000\078\001\153\019\153\019\000\000\000\000\000\000\
\000\000\193\002\000\000\192\002\165\001\093\002\252\023\035\029\
\000\000\000\000\114\029\010\002\197\255\112\255\000\000\000\000\
\000\000\095\002\186\002\195\002\147\024\000\000\147\024\095\030\
\021\001\184\002\000\000\185\002\206\002\000\000\000\000\000\000\
\135\002\038\255\212\002\193\001\122\000\000\000\147\024\122\255\
\197\002\000\000\209\002\003\022\000\000\040\001\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\226\015\000\000\
\000\000\000\000\023\000\226\015\000\000\000\000\038\255\217\002\
\000\000\213\002\000\000\000\000\093\002\000\000\000\000\000\000\
\148\000\086\255\000\000\000\000\008\026\212\001\000\000\000\000\
\003\022\214\001\146\002\226\015\226\015\000\000\197\255\201\002\
\108\000\000\000\205\002\147\024\000\000\000\000\000\000\000\000\
\233\002\229\002\236\002\031\034\139\000\000\000\000\000\152\020\
\216\002\000\000\046\024\097\024\147\024\037\020\037\020\229\002\
\000\000\219\001\000\000\224\001\090\033\228\000\000\000\000\000\
\218\002\237\002\000\000\245\001\000\000\000\000\000\000\253\000\
\000\000\000\000\037\020\037\020\147\024\053\022\000\000\000\000\
\000\000\153\019\000\000\000\000\000\000\000\000\232\002\000\000\
\093\002\176\030\000\000\000\000\000\000\195\002\000\000\186\002\
\000\000\000\000\000\000\239\002\000\000\234\002\075\255\000\000\
\235\002\000\000\000\000\000\000\000\000\241\002\010\003\038\255\
\129\018\156\000\000\000\104\022\104\022\009\003\000\000\209\002\
\000\000\104\022\000\000\000\000\000\000\251\002\000\000\013\003\
\038\255\000\000\000\000\097\255\226\015\151\023\000\000\000\000\
\209\002\000\000\206\255\000\000\025\002\070\002\000\000\000\000\
\204\006\254\002\147\024\000\000\000\000\000\000\166\002\000\000\
\147\024\021\003\025\003\031\034\000\000\153\019\037\020\078\002\
\037\020\086\002\103\002\240\002\000\000\000\000\000\000\052\002\
\000\000\000\000\004\003\152\020\000\000\114\001\000\000\000\000\
\000\000\209\002\000\000\000\000\000\000\000\000\000\000\000\000\
\147\024\022\003\021\001\147\024\218\002\027\003\219\002\000\000\
\147\024\000\000\000\000\019\003\039\003\000\000\000\000\000\000\
\045\003\226\015\151\023\104\002\000\000\039\003\029\003\151\023\
\035\003\036\003\000\000\204\006\000\000\000\000\000\000\038\001\
\139\000\139\000\000\000\000\000\000\000\037\020\000\000\037\020\
\040\003\037\020\000\000\247\002\000\000\037\020\037\020\062\003\
\000\000\065\003\078\003\000\000\127\002\004\003\000\000\069\003\
\000\000\000\000\000\000\000\000\138\002\000\000\000\000\000\000\
\000\000\057\003\000\000\000\000\000\000\139\000\000\000\000\000\
\000\000\000\000\000\000\000\000\155\001\228\002\114\001\000\000\
\000\000\077\003\040\003\000\000\000\000\000\000\000\000\152\020\
\152\020\000\000\000\000\147\024\225\002\000\000\086\003\152\020\
\000\000\000\000"

let yyrindex = "\000\000\
\000\000\253\002\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\253\002\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\213\003\112\005\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\180\001\234\001\000\000\000\000\000\000\
\000\000\000\000\000\000\091\007\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\195\024\000\000\000\000\000\000\000\000\000\000\000\000\232\024\
\234\024\000\000\000\000\070\003\000\000\000\000\251\026\000\000\
\022\025\000\000\000\000\000\000\000\000\253\002\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\253\006\102\003\000\000\239\032\000\000\138\032\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\101\003\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\128\007\000\000\000\000\000\000\000\000\
\000\000\022\033\000\000\000\000\000\000\055\010\081\002\000\000\
\000\000\245\008\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\055\255\000\000\000\000\000\000\037\028\
\103\004\140\004\000\000\000\000\055\003\217\012\219\012\000\000\
\034\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\187\024\000\000\000\000\000\000\
\000\000\000\000\243\005\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\249\254\000\000\000\000\000\000\
\000\000\048\255\000\000\083\025\120\025\129\025\160\025\191\025\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\117\028\000\000\028\026\100\001\000\000\000\000\000\000\177\000\
\000\000\000\000\000\000\000\000\000\000\000\000\123\006\121\003\
\000\000\000\000\000\000\070\003\253\002\000\000\000\000\000\000\
\000\000\102\003\000\000\000\000\000\000\000\000\000\000\000\000\
\114\003\000\000\000\000\000\000\000\000\253\002\000\000\000\000\
\000\000\115\003\255\007\000\000\000\000\000\000\253\002\000\000\
\000\000\000\000\079\003\000\000\031\009\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\149\002\172\002\000\000\000\000\000\000\253\002\000\000\000\000\
\117\003\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\126\008\000\000\205\027\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\138\255\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\016\030\000\000\039\000\
\000\000\000\000\049\000\000\000\000\000\000\000\000\000\000\000\
\000\000\135\003\000\000\173\002\000\000\000\000\000\000\000\000\
\136\003\000\000\163\001\000\000\000\000\137\003\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\172\002\000\000\
\221\016\050\003\105\017\253\002\245\017\042\255\000\000\000\000\
\071\003\000\000\000\000\189\002\000\000\000\000\000\000\000\000\
\000\000\000\000\056\255\048\255\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\197\028\000\000\149\026\000\000\000\000\000\000\000\000\
\000\000\000\000\113\001\000\000\000\000\000\000\000\000\149\002\
\000\000\149\002\121\003\000\000\000\000\000\000\000\000\000\000\
\070\003\000\000\000\000\000\000\000\000\163\003\076\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\241\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\171\033\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\114\003\000\000\000\000\
\253\002\000\000\000\000\000\000\000\000\000\000\149\003\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\152\003\000\000\208\002\229\011\
\199\011\083\007\212\006\125\011\173\011\216\007\223\010\005\011\
\054\011\085\008\175\010\022\010\141\010\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\219\255\248\255\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\071\000\000\000\000\000\000\000\
\000\000\000\000\000\000\016\030\072\255\043\255\000\000\000\000\
\000\000\136\003\167\003\000\000\000\000\000\000\000\000\253\002\
\132\000\170\003\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\085\034\000\000\000\000\000\000\
\000\000\000\000\136\003\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\149\002\000\000\
\000\000\000\000\070\003\048\255\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\233\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\149\002\149\002\000\000\248\000\000\000\
\070\003\000\000\207\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\114\003\229\033\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\158\009\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\031\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\253\002\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\212\000\000\000\000\000\
\088\255\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\249\254\000\000\000\000\000\000\167\003\000\000\000\000\136\003\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\250\000\149\002\000\000\000\000\000\000\
\136\003\000\000\070\003\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\171\033\000\000\
\000\000\000\000\000\000\114\003\000\000\253\002\000\000\000\000\
\000\000\000\000\000\000\086\012\000\000\000\000\000\000\196\009\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\136\003\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\132\000\000\000\075\003\000\000\000\000\000\000\
\000\000\000\000\000\000\081\003\000\000\000\000\000\000\000\000\
\000\000\149\002\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\229\033\229\033\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\082\003\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\229\033\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\083\003\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000"

let yygindex = "\000\000\
\000\000\000\000\255\255\008\000\216\255\001\000\186\004\169\254\
\197\004\226\255\002\000\186\255\253\255\166\255\000\000\073\003\
\013\001\184\000\101\001\159\008\000\000\145\255\067\001\137\254\
\000\000\000\000\020\002\151\255\251\000\000\000\207\253\253\253\
\208\003\127\255\046\004\183\255\000\000\000\000\000\000\089\255\
\000\000\251\253\000\000\067\003\061\003\149\255\000\000\000\000\
\035\255\000\000\000\000\023\255\224\254\041\254\235\254\013\000\
\000\000\000\000\000\000\000\000\080\255\067\255\102\255\024\000\
\201\255\118\001\000\000\115\002\000\000\159\001\071\001\058\254\
\199\001\000\000\000\000\000\000\000\000\049\003\221\002\000\000\
\000\000\085\004\189\003\207\002\189\255\116\255\050\255\000\000\
\000\000\000\000\091\002\021\000\189\254\217\254\131\255\203\254\
\000\000\000\000\017\000\076\003\090\003\147\002\244\255\000\000\
\147\255\000\000\000\000\107\254\000\000\000\000\179\253\127\253\
\012\000\143\001\026\001\204\003\000\000\130\254\000\000\000\000\
\083\002\000\000\111\254\159\253\135\255\000\000\119\002\000\000\
\000\000\242\003\054\003\098\002\000\000\000\000\000\000\000\000\
\071\253\000\000\085\002\235\001\085\003\000\000\100\004\185\003\
\101\002\228\253\000\000\000\000\000\000\123\254\000\000\000\000\
\000\000\000\000\064\002\181\003\000\000\129\002\003\000\195\001\
\018\253\197\001\039\253\000\000\000\000\157\004\158\004\000\000"

let yytablesize = 9101
let yytable = "\146\000\
\015\002\142\000\062\000\064\000\089\000\223\000\178\000\195\000\
\225\000\086\001\005\001\170\000\242\000\079\000\066\000\132\001\
\026\002\024\001\076\000\164\001\224\000\079\000\066\000\188\000\
\190\000\068\000\076\000\072\001\253\000\088\002\167\002\145\002\
\184\000\055\001\014\001\152\002\096\001\074\002\018\001\141\002\
\250\001\144\001\069\002\069\001\070\001\070\001\138\002\002\003\
\019\001\010\002\133\001\098\001\239\000\011\001\215\002\094\003\
\101\000\070\002\240\002\026\001\254\002\018\001\123\002\091\001\
\092\001\093\001\008\002\018\001\124\002\072\001\020\001\089\002\
\008\002\080\001\039\001\135\000\095\003\027\002\214\002\075\003\
\039\001\027\001\098\002\127\002\162\002\183\000\241\000\170\001\
\011\000\116\001\041\001\012\001\175\001\185\000\169\000\001\003\
\041\001\079\000\243\000\132\002\169\000\114\000\244\000\238\002\
\025\001\112\001\171\000\192\001\144\001\252\000\186\000\011\001\
\062\001\244\002\101\000\175\001\001\001\146\000\247\002\007\001\
\144\001\013\001\171\000\144\001\069\003\169\000\175\001\133\002\
\169\000\076\002\185\001\010\001\220\000\095\001\064\001\191\000\
\020\000\197\000\192\000\176\002\028\001\099\002\128\002\142\002\
\094\003\146\002\117\003\198\000\042\003\223\000\133\000\144\001\
\160\001\072\001\199\000\223\000\184\001\018\001\137\000\114\000\
\146\000\176\001\078\001\123\001\064\002\095\003\089\000\039\001\
\040\001\162\001\006\002\192\001\195\001\223\000\067\003\079\000\
\081\001\071\001\071\001\139\000\076\000\072\003\014\002\194\000\
\253\002\024\002\086\001\047\003\224\000\018\001\125\002\133\000\
\013\001\110\003\008\002\066\003\064\001\133\000\114\003\058\002\
\108\001\146\000\039\001\129\001\016\003\216\002\205\000\089\000\
\133\000\096\001\009\002\112\002\130\001\054\002\204\001\103\000\
\079\000\131\001\041\001\107\003\139\000\134\001\133\000\078\002\
\059\002\133\000\139\000\170\002\112\003\246\002\056\002\057\002\
\003\002\086\001\036\001\175\001\061\003\139\000\079\002\133\000\
\182\001\210\002\089\000\068\002\058\002\037\001\194\001\167\001\
\200\000\078\002\080\001\139\000\137\000\070\003\139\000\173\000\
\079\000\193\001\205\002\010\003\208\002\244\000\078\002\184\001\
\113\002\247\001\252\002\146\000\131\000\000\002\138\002\253\001\
\254\001\079\000\251\001\255\001\112\001\079\002\244\000\064\001\
\069\002\247\000\079\000\248\000\171\002\172\002\136\002\244\000\
\209\002\186\002\146\000\204\000\000\002\223\000\096\003\026\002\
\077\002\080\001\103\000\043\000\173\001\003\001\210\000\046\000\
\029\002\079\000\207\000\132\000\055\001\132\000\244\000\174\001\
\047\000\018\001\130\002\213\000\083\003\013\001\013\001\223\000\
\211\000\251\002\225\000\019\001\055\000\185\001\056\000\055\002\
\057\000\019\001\058\000\059\000\223\000\133\000\224\000\077\002\
\185\001\146\000\201\002\078\001\036\001\135\000\136\000\089\000\
\191\000\020\001\216\000\192\000\144\001\144\001\193\000\020\001\
\079\000\081\001\206\000\004\001\105\001\076\000\223\000\208\000\
\064\001\105\001\131\000\013\001\145\002\071\003\209\000\105\001\
\006\001\108\001\223\000\005\003\006\003\151\002\235\000\072\002\
\231\002\146\000\022\001\097\002\003\001\236\000\132\000\164\001\
\146\000\224\000\078\001\076\003\009\003\064\001\089\000\160\002\
\194\000\072\001\119\003\120\003\169\002\044\003\183\000\079\000\
\081\001\132\000\165\001\173\000\076\000\248\002\176\000\165\002\
\183\002\094\001\178\002\180\002\176\000\095\001\135\000\136\000\
\017\003\169\000\018\003\019\001\019\003\220\000\176\000\173\000\
\173\000\173\000\255\000\255\000\064\001\241\000\105\001\135\003\
\221\000\145\002\056\003\182\001\170\002\089\000\145\002\108\001\
\167\001\020\001\203\000\222\000\221\000\057\003\182\001\078\002\
\089\000\017\001\202\001\019\001\199\002\086\002\173\000\222\000\
\036\001\093\001\184\001\087\002\254\000\000\001\213\000\213\000\
\213\000\213\000\213\000\132\000\093\001\184\001\218\000\219\000\
\124\001\020\001\004\001\207\002\068\003\141\001\149\001\237\000\
\072\001\120\000\121\000\016\001\123\000\004\001\172\000\140\001\
\251\000\219\002\173\000\220\002\172\000\216\000\216\000\216\000\
\216\000\216\000\140\001\135\000\136\000\146\000\172\000\000\002\
\112\001\173\000\033\003\234\002\036\001\072\001\054\003\004\001\
\084\003\096\001\133\000\003\001\079\000\223\000\132\000\223\000\
\160\001\244\000\016\002\173\000\096\001\017\002\182\002\065\003\
\143\001\118\002\097\001\146\000\188\002\002\001\003\001\119\002\
\006\001\141\000\143\001\143\001\222\002\097\001\018\002\139\000\
\141\001\109\003\011\000\248\001\249\001\008\001\135\000\136\000\
\168\002\004\001\223\002\132\001\141\001\149\001\036\001\141\001\
\025\002\245\002\009\001\027\002\028\002\015\001\140\001\106\002\
\146\000\146\000\000\002\000\002\118\003\103\002\036\001\104\002\
\213\002\030\001\223\000\224\000\019\002\242\002\223\000\079\000\
\079\000\235\002\031\001\141\001\244\000\244\000\133\001\013\001\
\026\000\032\001\020\000\241\000\038\001\046\000\140\001\140\001\
\108\001\072\002\224\002\108\001\174\002\003\001\047\000\143\001\
\033\001\224\000\036\001\079\000\066\000\175\002\072\001\181\002\
\076\000\020\002\055\000\036\001\056\000\119\002\057\000\248\001\
\202\002\004\001\058\003\059\003\189\002\004\001\004\001\072\001\
\062\003\004\001\119\002\034\001\004\001\112\001\006\001\143\001\
\143\001\191\000\006\001\006\001\192\000\190\002\006\001\238\000\
\094\001\006\001\007\003\124\002\095\001\194\001\004\001\004\001\
\004\001\004\001\004\001\004\001\004\001\004\001\004\001\004\001\
\004\001\004\001\004\001\004\001\004\001\004\001\004\001\004\001\
\004\001\004\001\191\002\196\002\146\000\035\001\021\003\074\001\
\192\002\119\002\146\000\146\000\088\001\173\000\036\001\003\001\
\004\001\194\000\024\003\026\003\027\003\169\000\183\000\155\001\
\173\000\220\000\071\002\155\001\149\001\143\002\149\001\146\000\
\146\000\128\001\223\000\004\001\128\001\151\002\146\000\128\001\
\000\002\101\001\150\002\224\000\193\000\104\003\117\001\048\000\
\221\000\200\002\004\001\233\002\013\001\079\000\004\001\119\002\
\194\001\192\002\244\000\222\000\120\001\079\000\066\000\006\001\
\050\003\175\000\076\000\006\001\004\001\146\000\000\003\129\001\
\003\003\049\000\050\000\089\000\124\002\030\003\124\002\004\001\
\130\001\128\001\031\003\119\002\079\000\131\001\004\001\129\001\
\119\002\134\001\129\001\121\001\006\001\129\001\003\001\136\001\
\187\000\187\000\161\001\006\001\132\000\223\000\137\001\036\003\
\151\002\241\000\004\001\172\001\003\001\036\001\003\001\132\000\
\141\001\141\001\146\000\146\000\000\002\146\000\133\000\169\000\
\080\003\136\003\137\003\076\002\065\002\215\000\003\001\095\001\
\146\000\079\000\092\003\106\002\135\000\136\000\244\000\129\001\
\094\001\065\002\196\001\073\003\095\001\178\001\238\000\135\000\
\136\000\124\002\221\000\139\000\224\002\174\000\044\001\200\001\
\198\001\203\001\004\002\101\003\169\000\222\000\169\000\221\000\
\076\002\252\001\076\002\005\002\095\001\051\002\095\001\063\001\
\106\002\007\002\222\000\064\001\194\001\065\001\245\000\066\001\
\067\001\068\001\146\000\003\001\146\000\008\002\146\000\221\000\
\074\003\221\000\146\000\146\000\004\001\011\002\124\002\060\002\
\086\003\013\002\222\000\026\000\222\000\026\000\036\001\026\000\
\088\003\026\000\073\002\061\002\004\001\062\002\036\001\103\001\
\221\000\214\000\026\000\026\000\026\000\175\000\075\002\083\002\
\133\000\089\003\111\003\222\000\040\003\106\002\085\002\036\001\
\124\002\092\002\093\002\149\001\146\000\146\000\141\003\142\003\
\149\001\175\000\175\000\175\000\146\000\095\002\146\003\096\002\
\114\002\131\003\140\001\034\000\035\000\139\000\132\000\036\001\
\004\001\110\001\116\002\148\001\133\003\133\000\126\002\133\000\
\149\001\149\001\124\002\106\002\106\002\148\002\157\002\008\002\
\175\000\106\002\149\002\004\001\041\000\008\002\043\000\022\001\
\215\000\215\000\215\000\215\000\215\000\161\002\135\000\136\000\
\026\000\004\001\139\000\004\001\139\000\163\002\010\002\035\001\
\169\001\166\002\003\001\026\000\010\002\035\001\173\002\011\001\
\184\002\174\000\101\000\004\001\175\000\058\000\059\000\006\002\
\004\001\185\002\197\002\203\002\230\000\006\002\204\002\217\002\
\026\000\026\000\089\002\175\000\228\002\174\000\174\000\174\000\
\229\002\230\002\048\000\026\000\048\000\232\002\048\000\236\002\
\048\000\237\002\249\002\129\002\008\003\175\000\048\000\150\002\
\003\001\048\000\048\000\048\000\048\000\004\001\014\003\114\000\
\198\002\015\003\022\003\049\003\174\000\034\003\043\003\035\003\
\004\001\048\003\052\003\051\003\214\000\214\000\214\000\214\000\
\214\000\149\001\143\002\053\001\054\001\055\001\056\001\057\001\
\058\001\059\001\060\001\061\001\168\001\001\000\002\000\003\000\
\004\000\005\000\006\000\007\000\053\003\060\003\063\003\064\003\
\174\000\077\003\081\003\028\003\029\003\046\000\082\003\091\003\
\133\000\004\001\004\001\105\003\099\003\102\003\047\000\174\000\
\055\001\056\001\057\001\058\001\059\001\060\001\061\001\048\000\
\038\003\039\003\055\000\239\002\056\000\097\003\057\000\108\003\
\113\003\174\000\048\000\090\003\044\001\139\000\115\003\116\003\
\044\001\044\001\125\003\123\003\044\001\103\003\149\001\143\002\
\004\001\004\001\128\003\129\003\143\002\130\003\004\001\048\000\
\048\000\044\001\044\001\132\003\134\003\051\000\140\003\044\001\
\144\003\245\000\048\000\245\000\245\000\245\000\010\000\245\000\
\145\003\027\002\044\001\245\000\245\000\245\000\097\000\004\001\
\245\000\245\000\245\000\245\000\245\000\245\000\245\000\245\000\
\245\000\245\000\245\000\245\000\245\000\245\000\245\000\245\000\
\245\000\245\000\245\000\245\000\245\000\245\000\245\000\135\002\
\164\000\187\000\064\001\035\002\085\003\151\001\087\003\175\000\
\057\001\058\001\059\001\060\001\061\001\177\000\165\000\031\002\
\097\003\030\001\175\000\170\000\124\001\004\001\044\001\155\001\
\156\001\157\001\158\001\159\001\181\001\044\001\046\001\047\001\
\048\001\049\001\050\001\051\001\052\001\053\001\054\001\055\001\
\056\001\057\001\058\001\059\001\060\001\061\001\245\000\150\001\
\166\000\179\001\030\002\123\001\169\000\190\001\044\001\044\001\
\179\000\245\000\044\001\029\002\191\001\189\001\063\000\100\002\
\032\003\199\001\073\001\121\003\227\002\122\003\117\002\124\003\
\122\002\100\003\143\003\126\003\127\003\079\003\245\000\245\000\
\029\001\012\002\187\002\134\002\250\002\212\002\120\002\255\002\
\179\001\245\000\230\000\174\000\243\002\230\000\230\000\230\000\
\147\002\230\000\230\000\230\000\121\002\230\000\174\000\011\003\
\016\000\230\000\230\000\230\000\004\003\078\003\230\000\230\000\
\230\000\230\000\230\000\230\000\230\000\230\000\230\000\230\000\
\230\000\230\000\230\000\230\000\230\000\230\000\230\000\230\000\
\230\000\230\000\230\000\230\000\230\000\230\000\230\000\230\000\
\230\000\230\000\159\002\230\000\230\000\230\000\230\000\230\000\
\230\000\230\000\230\000\230\000\230\000\230\000\230\000\230\000\
\230\000\230\000\230\000\230\000\230\000\230\000\111\001\082\002\
\055\003\187\000\047\001\048\001\049\001\050\001\051\001\052\001\
\053\001\054\001\055\001\056\001\057\001\058\001\059\001\060\001\
\061\001\230\000\046\003\230\000\230\000\115\002\230\000\230\000\
\037\003\139\003\138\003\230\000\089\001\090\001\000\000\230\000\
\044\001\045\001\046\001\047\001\048\001\049\001\050\001\051\001\
\052\001\053\001\054\001\055\001\056\001\057\001\058\001\059\001\
\060\001\061\001\230\000\230\000\230\000\230\000\000\000\000\000\
\230\000\000\000\000\000\000\000\000\000\000\000\000\000\230\000\
\000\000\187\000\000\000\010\000\010\000\010\000\010\000\229\000\
\000\000\000\000\000\000\187\000\010\000\000\000\000\000\010\000\
\010\000\010\000\010\000\010\000\010\000\010\000\010\000\010\000\
\010\000\010\000\010\000\010\000\010\000\010\000\000\000\010\000\
\010\000\010\000\010\000\010\000\010\000\010\000\010\000\010\000\
\010\000\010\000\010\000\010\000\010\000\010\000\010\000\010\000\
\010\000\010\000\010\000\010\000\010\000\010\000\010\000\010\000\
\010\000\010\000\010\000\010\000\000\000\010\000\010\000\010\000\
\010\000\010\000\010\000\010\000\010\000\010\000\010\000\010\000\
\010\000\010\000\010\000\010\000\010\000\010\000\010\000\010\000\
\000\000\000\000\010\000\000\000\000\000\000\000\000\000\000\000\
\010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\010\000\000\000\010\000\010\000\010\000\010\000\000\000\
\010\000\010\000\010\000\000\000\000\000\000\000\000\000\000\000\
\000\000\010\000\000\000\010\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\010\000\
\000\000\010\000\000\000\010\000\010\000\010\000\010\000\010\000\
\000\000\000\000\154\001\000\000\010\000\016\000\016\000\016\000\
\016\000\010\000\000\000\000\000\000\000\000\000\016\000\000\000\
\000\000\016\000\016\000\016\000\016\000\016\000\016\000\016\000\
\016\000\016\000\016\000\016\000\016\000\016\000\016\000\016\000\
\000\000\016\000\016\000\016\000\016\000\016\000\016\000\016\000\
\016\000\016\000\016\000\016\000\016\000\016\000\016\000\016\000\
\016\000\016\000\016\000\016\000\016\000\016\000\016\000\016\000\
\016\000\016\000\016\000\016\000\016\000\016\000\000\000\016\000\
\016\000\016\000\016\000\016\000\016\000\016\000\016\000\016\000\
\016\000\016\000\016\000\016\000\016\000\016\000\016\000\016\000\
\016\000\016\000\000\000\000\000\016\000\000\000\000\000\000\000\
\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\016\000\000\000\016\000\016\000\016\000\
\016\000\000\000\016\000\016\000\016\000\000\000\000\000\000\000\
\000\000\000\000\000\000\016\000\000\000\016\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\016\000\000\000\016\000\000\000\016\000\016\000\016\000\
\016\000\016\000\127\001\000\000\000\000\229\000\016\000\000\000\
\229\000\229\000\229\000\016\000\229\000\229\000\229\000\000\000\
\229\000\000\000\000\000\000\000\229\000\229\000\229\000\000\000\
\000\000\229\000\229\000\229\000\229\000\229\000\229\000\229\000\
\229\000\229\000\229\000\229\000\229\000\229\000\229\000\229\000\
\229\000\229\000\229\000\229\000\229\000\229\000\229\000\229\000\
\229\000\229\000\229\000\229\000\229\000\000\000\229\000\229\000\
\229\000\229\000\229\000\229\000\229\000\229\000\229\000\229\000\
\229\000\229\000\229\000\229\000\229\000\229\000\229\000\229\000\
\229\000\045\001\046\001\047\001\048\001\049\001\050\001\051\001\
\052\001\053\001\054\001\055\001\056\001\057\001\058\001\059\001\
\060\001\061\001\000\000\044\000\229\000\000\000\229\000\229\000\
\000\000\229\000\229\000\000\000\000\000\000\000\229\000\000\000\
\000\000\000\000\229\000\049\001\050\001\051\001\052\001\053\001\
\054\001\055\001\056\001\057\001\058\001\059\001\060\001\061\001\
\000\000\000\000\000\000\000\000\000\000\229\000\229\000\229\000\
\229\000\000\000\000\000\229\000\089\000\000\000\000\000\000\000\
\154\001\000\000\229\000\154\001\154\001\154\001\000\000\154\001\
\154\001\154\001\000\000\154\001\000\000\000\000\000\000\154\001\
\154\001\154\001\000\000\000\000\154\001\154\001\154\001\154\001\
\154\001\154\001\154\001\154\001\154\001\154\001\154\001\154\001\
\154\001\154\001\154\001\154\001\154\001\154\001\154\001\154\001\
\154\001\154\001\154\001\154\001\154\001\154\001\154\001\154\001\
\000\000\154\001\154\001\154\001\154\001\154\001\154\001\154\001\
\154\001\154\001\154\001\154\001\154\001\154\001\154\001\154\001\
\154\001\154\001\154\001\154\001\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\046\000\000\000\000\000\000\000\000\000\154\001\
\000\000\154\001\154\001\000\000\154\001\154\001\000\000\000\000\
\000\000\154\001\000\000\000\000\000\000\154\001\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\154\001\154\001\154\001\154\001\000\000\000\000\154\001\094\000\
\000\000\000\000\000\000\000\000\000\000\154\001\000\000\000\000\
\127\001\000\000\000\000\127\001\127\001\127\001\000\000\127\001\
\127\001\127\001\000\000\127\001\000\000\000\000\000\000\127\001\
\127\001\127\001\000\000\000\000\127\001\127\001\127\001\127\001\
\127\001\127\001\127\001\127\001\127\001\127\001\127\001\127\001\
\127\001\127\001\127\001\127\001\127\001\127\001\127\001\127\001\
\127\001\127\001\127\001\127\001\127\001\127\001\127\001\127\001\
\000\000\127\001\127\001\127\001\127\001\127\001\127\001\127\001\
\127\001\127\001\127\001\127\001\127\001\127\001\127\001\127\001\
\127\001\127\001\127\001\127\001\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\038\000\
\000\000\169\000\000\000\000\000\000\000\220\000\000\000\127\001\
\000\000\127\001\127\001\000\000\127\001\127\001\044\000\000\000\
\044\000\127\001\044\000\000\000\044\000\127\001\150\002\000\000\
\000\000\000\000\044\000\000\000\221\000\044\000\044\000\044\000\
\044\000\044\000\044\000\044\000\044\000\000\000\012\000\222\000\
\127\001\127\001\127\001\127\001\167\000\000\000\127\001\000\000\
\000\000\000\000\000\000\000\000\000\000\127\001\089\000\089\000\
\000\000\089\000\089\000\089\000\089\000\089\000\089\000\089\000\
\089\000\089\000\089\000\089\000\000\000\000\000\089\000\089\000\
\089\000\089\000\089\000\089\000\089\000\089\000\089\000\089\000\
\089\000\089\000\089\000\089\000\089\000\089\000\089\000\089\000\
\089\000\089\000\089\000\089\000\089\000\000\000\000\000\046\000\
\000\000\000\000\133\000\044\000\000\000\000\000\000\000\000\000\
\047\000\000\000\000\000\000\000\000\000\000\000\044\000\000\000\
\000\000\000\000\000\000\000\000\055\000\000\000\056\000\000\000\
\057\000\000\000\000\000\000\000\036\000\000\000\000\000\139\000\
\000\000\000\000\000\000\044\000\044\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\089\000\046\000\044\000\046\000\
\068\001\046\000\000\000\046\000\068\001\068\001\000\000\089\000\
\068\001\046\000\000\000\068\001\046\000\046\000\046\000\046\000\
\046\000\046\000\046\000\000\000\000\000\095\000\068\001\000\000\
\000\000\000\000\000\000\068\001\089\000\089\000\000\000\168\000\
\000\000\167\000\000\000\000\000\000\000\000\000\068\001\089\000\
\000\000\094\000\094\000\000\000\094\000\094\000\094\000\094\000\
\094\000\094\000\094\000\094\000\094\000\094\000\094\000\000\000\
\000\000\094\000\094\000\094\000\094\000\094\000\094\000\094\000\
\094\000\094\000\094\000\094\000\094\000\094\000\094\000\094\000\
\094\000\094\000\094\000\094\000\094\000\094\000\094\000\094\000\
\000\000\000\000\046\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\068\001\000\000\000\000\046\000\000\000\000\000\
\000\000\068\001\000\000\000\000\000\000\068\001\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\046\000\046\000\000\000\000\000\000\000\000\000\
\000\000\000\000\068\001\068\001\000\000\046\000\068\001\094\000\
\000\000\000\000\038\000\000\000\038\000\068\001\038\000\000\000\
\038\000\000\000\094\000\000\000\051\000\000\000\038\000\000\000\
\000\000\038\000\038\000\038\000\038\000\038\000\038\000\038\000\
\038\000\038\000\038\000\038\000\038\000\038\000\038\000\094\000\
\094\000\000\000\000\000\000\000\168\000\000\000\000\000\000\000\
\012\000\012\000\094\000\012\000\012\000\012\000\012\000\012\000\
\012\000\012\000\012\000\012\000\012\000\012\000\057\000\000\000\
\012\000\012\000\012\000\012\000\012\000\012\000\012\000\012\000\
\012\000\012\000\012\000\012\000\012\000\012\000\012\000\012\000\
\012\000\012\000\012\000\012\000\012\000\012\000\012\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\038\000\
\000\000\000\000\000\000\000\000\000\000\041\001\000\000\000\000\
\000\000\000\000\038\000\042\001\043\001\044\001\045\001\046\001\
\047\001\048\001\049\001\050\001\051\001\052\001\053\001\054\001\
\055\001\056\001\057\001\058\001\059\001\060\001\061\001\038\000\
\038\000\000\000\000\000\000\000\000\000\000\000\012\000\036\000\
\000\000\036\000\038\000\036\000\000\000\036\000\000\000\000\000\
\000\000\012\000\000\000\036\000\000\000\000\000\036\000\036\000\
\036\000\036\000\036\000\036\000\036\000\036\000\036\000\036\000\
\036\000\036\000\036\000\036\000\036\000\036\000\012\000\012\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\095\000\
\095\000\012\000\095\000\095\000\095\000\095\000\095\000\095\000\
\095\000\095\000\095\000\095\000\095\000\056\000\000\000\095\000\
\095\000\095\000\095\000\095\000\095\000\095\000\095\000\095\000\
\095\000\095\000\095\000\095\000\095\000\095\000\095\000\095\000\
\095\000\095\000\095\000\095\000\095\000\095\000\000\000\000\000\
\000\000\000\000\000\000\000\000\036\000\000\000\000\000\000\000\
\000\000\000\000\000\000\058\000\000\000\000\000\000\000\036\000\
\031\002\032\002\033\002\034\002\035\002\036\002\037\002\038\002\
\039\002\040\002\041\002\042\002\043\002\044\002\045\002\046\002\
\047\002\048\002\049\002\050\002\036\000\036\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\095\000\000\000\036\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\095\000\043\001\044\001\045\001\046\001\047\001\048\001\049\001\
\050\001\051\001\052\001\053\001\054\001\055\001\056\001\057\001\
\058\001\059\001\060\001\061\001\000\000\095\000\095\000\051\000\
\000\000\051\000\000\000\051\000\000\000\051\000\000\000\000\000\
\095\000\051\000\051\000\051\000\000\000\034\000\051\000\051\000\
\051\000\051\000\051\000\051\000\051\000\051\000\051\000\051\000\
\051\000\051\000\051\000\051\000\051\000\051\000\051\000\051\000\
\051\000\051\000\051\000\051\000\051\000\000\000\000\000\000\000\
\000\000\057\000\000\000\057\000\000\000\057\000\049\000\057\000\
\000\000\000\000\000\000\057\000\057\000\057\000\000\000\000\000\
\057\000\057\000\057\000\057\000\057\000\057\000\057\000\057\000\
\057\000\057\000\057\000\057\000\057\000\057\000\057\000\057\000\
\057\000\057\000\057\000\057\000\057\000\057\000\057\000\000\000\
\000\000\000\000\000\000\000\000\051\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\051\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\051\000\051\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\057\000\051\000\
\000\000\000\000\000\000\000\000\035\000\000\000\000\000\000\000\
\000\000\057\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\057\000\057\000\
\000\000\000\000\000\000\000\000\000\000\000\000\037\000\000\000\
\056\000\057\000\056\000\000\000\056\000\000\000\056\000\000\000\
\000\000\000\000\056\000\056\000\056\000\000\000\000\000\056\000\
\056\000\056\000\056\000\056\000\056\000\056\000\056\000\056\000\
\056\000\056\000\056\000\056\000\056\000\056\000\056\000\056\000\
\056\000\056\000\056\000\056\000\056\000\056\000\058\000\000\000\
\058\000\000\000\058\000\000\000\058\000\000\000\039\000\000\000\
\058\000\058\000\058\000\000\000\000\000\058\000\058\000\058\000\
\058\000\058\000\058\000\058\000\058\000\058\000\058\000\058\000\
\058\000\058\000\058\000\058\000\058\000\058\000\058\000\058\000\
\058\000\058\000\058\000\058\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\040\000\056\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\056\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\056\000\056\000\000\000\
\034\000\000\000\034\000\058\000\034\000\000\000\034\000\000\000\
\056\000\000\000\000\000\000\000\034\000\041\000\058\000\034\000\
\034\000\034\000\034\000\034\000\034\000\034\000\034\000\034\000\
\034\000\034\000\034\000\034\000\034\000\034\000\034\000\034\000\
\034\000\049\000\000\000\058\000\058\000\049\000\000\000\049\000\
\000\000\000\000\000\000\000\000\000\000\049\000\058\000\000\000\
\000\000\049\000\049\000\049\000\049\000\049\000\049\000\049\000\
\049\000\049\000\049\000\049\000\049\000\049\000\049\000\049\000\
\049\000\049\000\049\000\049\000\049\000\049\000\049\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\042\000\034\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\034\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\034\000\034\000\035\000\
\000\000\035\000\000\000\035\000\000\000\035\000\000\000\000\000\
\034\000\049\000\000\000\035\000\043\000\000\000\035\000\035\000\
\035\000\035\000\035\000\035\000\035\000\035\000\035\000\035\000\
\035\000\035\000\035\000\035\000\035\000\035\000\035\000\035\000\
\000\000\037\000\000\000\037\000\000\000\037\000\045\000\037\000\
\000\000\049\000\000\000\000\000\000\000\037\000\000\000\000\000\
\037\000\037\000\037\000\037\000\037\000\037\000\037\000\037\000\
\037\000\037\000\037\000\037\000\037\000\037\000\037\000\037\000\
\000\000\000\000\000\000\000\000\047\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\039\000\000\000\039\000\035\000\039\000\000\000\039\000\
\000\000\000\000\000\000\000\000\000\000\039\000\000\000\035\000\
\039\000\039\000\039\000\039\000\039\000\039\000\039\000\039\000\
\039\000\039\000\039\000\039\000\039\000\039\000\000\000\000\000\
\000\000\000\000\000\000\000\000\035\000\035\000\037\000\040\000\
\000\000\040\000\000\000\040\000\000\000\040\000\169\000\035\000\
\000\000\037\000\220\000\040\000\000\000\000\000\040\000\040\000\
\040\000\040\000\040\000\040\000\040\000\040\000\040\000\040\000\
\040\000\040\000\040\000\040\000\000\000\000\000\037\000\037\000\
\000\000\221\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\037\000\000\000\000\000\222\000\000\000\039\000\000\000\
\041\000\000\000\041\000\000\000\041\000\000\000\041\000\000\000\
\000\000\039\000\000\000\000\000\041\000\148\000\000\000\041\000\
\041\000\041\000\041\000\041\000\041\000\041\000\041\000\041\000\
\041\000\041\000\041\000\041\000\041\000\000\000\039\000\039\000\
\000\000\000\000\000\000\000\000\040\000\000\000\000\000\000\000\
\000\000\039\000\000\000\000\000\000\000\000\000\000\000\040\000\
\132\000\000\000\000\000\000\000\000\000\000\000\000\000\133\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\040\000\040\000\000\000\042\000\
\000\000\042\000\000\000\042\000\000\000\042\000\000\000\040\000\
\135\000\136\000\000\000\042\000\139\000\041\000\042\000\042\000\
\042\000\042\000\042\000\042\000\042\000\042\000\042\000\042\000\
\041\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\041\000\041\000\043\000\
\000\000\043\000\000\000\043\000\000\000\043\000\000\000\000\000\
\041\000\000\000\000\000\043\000\000\000\000\000\043\000\043\000\
\043\000\043\000\043\000\043\000\043\000\043\000\043\000\043\000\
\045\001\045\000\046\001\045\000\000\000\045\000\000\000\045\000\
\000\000\181\000\000\000\000\000\042\000\045\000\000\000\000\000\
\045\000\045\000\045\000\045\000\045\000\045\000\000\000\042\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\047\000\
\000\000\047\000\000\000\047\000\000\000\047\000\000\000\000\000\
\000\000\000\000\000\000\047\000\042\000\042\000\047\000\047\000\
\047\000\047\000\047\000\000\000\000\000\000\000\000\000\042\000\
\000\000\000\000\000\000\000\000\043\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\043\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\045\000\000\000\
\000\000\000\000\000\000\060\000\043\000\043\000\000\000\000\000\
\000\000\045\000\000\000\000\000\000\000\000\000\000\000\043\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\047\000\000\000\045\000\045\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\047\000\
\000\000\045\000\148\000\148\000\148\000\148\000\148\000\000\000\
\000\000\000\000\148\000\148\000\000\000\148\000\148\000\148\000\
\000\000\148\000\148\000\000\000\047\000\047\000\000\000\000\000\
\148\000\148\000\000\000\000\000\000\000\148\000\148\000\047\000\
\000\000\148\000\000\000\148\000\000\000\000\000\148\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\148\000\
\148\000\148\000\000\000\000\000\000\000\000\000\148\000\148\000\
\148\000\148\000\148\000\148\000\148\000\148\000\148\000\148\000\
\148\000\148\000\148\000\148\000\148\000\148\000\148\000\148\000\
\148\000\148\000\148\000\148\000\148\000\148\000\148\000\148\000\
\148\000\000\000\148\000\148\000\148\000\148\000\148\000\148\000\
\148\000\148\000\148\000\148\000\148\000\148\000\148\000\148\000\
\000\000\000\000\148\000\148\000\148\000\148\000\000\000\148\000\
\148\000\148\000\000\000\000\000\148\000\000\000\000\000\000\000\
\148\000\000\000\148\000\000\000\148\000\148\000\148\000\148\000\
\148\000\148\000\148\000\148\000\000\000\148\000\148\000\000\000\
\148\000\000\000\148\000\148\000\148\000\148\000\148\000\148\000\
\148\000\148\000\148\000\148\000\000\000\148\000\045\001\000\000\
\046\001\000\000\045\001\045\001\046\001\046\001\045\001\000\000\
\046\001\012\000\013\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\045\001\045\001\046\001\046\001\000\000\
\000\000\045\001\000\000\046\001\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\045\001\000\000\046\001\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\015\000\016\000\017\000\018\000\019\000\000\000\
\021\000\022\000\023\000\024\000\025\000\026\000\027\000\028\000\
\029\000\030\000\031\000\032\000\033\000\034\000\035\000\036\000\
\037\000\038\000\039\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\045\001\011\000\046\001\012\000\013\000\180\000\041\000\045\001\
\043\000\046\001\000\000\044\000\045\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\014\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\045\001\045\001\046\001\046\001\045\001\000\000\046\001\058\000\
\059\000\000\000\000\000\000\000\015\000\016\000\017\000\018\000\
\019\000\020\000\021\000\022\000\023\000\024\000\025\000\026\000\
\027\000\028\000\029\000\030\000\031\000\032\000\033\000\034\000\
\035\000\036\000\037\000\038\000\039\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\040\000\
\041\000\042\000\043\000\000\000\000\000\044\000\045\000\046\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\047\000\000\000\048\000\049\000\050\000\051\000\052\000\053\000\
\054\000\000\000\000\000\000\000\055\000\000\000\056\000\000\000\
\057\000\058\000\059\000\094\000\095\000\096\000\097\000\098\000\
\000\000\000\000\000\000\099\000\169\000\139\001\000\000\013\000\
\102\000\023\002\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\104\000\105\000\000\000\000\000\000\000\106\000\107\000\
\000\000\000\000\000\000\000\000\109\000\000\000\000\000\110\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\111\000\112\000\113\000\000\000\000\000\000\000\000\000\015\000\
\016\000\017\000\018\000\019\000\000\000\021\000\022\000\023\000\
\024\000\025\000\026\000\027\000\028\000\029\000\030\000\031\000\
\032\000\033\000\034\000\035\000\036\000\037\000\038\000\039\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\127\000\128\000\129\000\
\130\000\000\000\000\000\041\000\000\000\043\000\000\000\000\000\
\044\000\045\000\000\000\000\000\000\000\133\000\000\000\000\000\
\000\000\000\000\094\000\095\000\096\000\097\000\098\000\000\000\
\000\000\000\000\099\000\169\000\139\001\000\000\013\000\102\000\
\053\002\000\000\000\000\000\000\058\000\059\000\000\000\000\000\
\104\000\105\000\139\000\140\000\000\000\106\000\107\000\000\000\
\000\000\000\000\140\001\109\000\000\000\000\000\110\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\111\000\
\112\000\113\000\000\000\000\000\000\000\000\000\015\000\016\000\
\017\000\018\000\019\000\000\000\021\000\022\000\023\000\024\000\
\025\000\026\000\027\000\028\000\029\000\030\000\031\000\032\000\
\033\000\034\000\035\000\036\000\037\000\038\000\039\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\127\000\128\000\129\000\130\000\
\000\000\000\000\041\000\000\000\043\000\000\000\000\000\044\000\
\045\000\000\000\000\000\000\000\133\000\000\000\000\000\000\000\
\000\000\094\000\095\000\096\000\097\000\098\000\000\000\000\000\
\000\000\099\000\169\000\139\001\000\000\013\000\102\000\177\002\
\000\000\000\000\000\000\058\000\059\000\000\000\000\000\104\000\
\105\000\139\000\140\000\000\000\106\000\107\000\000\000\000\000\
\000\000\140\001\109\000\000\000\000\000\110\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\111\000\112\000\
\113\000\000\000\000\000\000\000\000\000\015\000\016\000\017\000\
\018\000\019\000\000\000\021\000\022\000\023\000\024\000\025\000\
\026\000\027\000\028\000\029\000\030\000\031\000\032\000\033\000\
\034\000\035\000\036\000\037\000\038\000\039\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\127\000\128\000\129\000\130\000\000\000\
\000\000\041\000\000\000\043\000\000\000\000\000\044\000\045\000\
\000\000\000\000\000\000\133\000\000\000\000\000\000\000\000\000\
\094\000\095\000\096\000\097\000\098\000\000\000\000\000\000\000\
\099\000\169\000\139\001\000\000\013\000\102\000\179\002\000\000\
\000\000\000\000\058\000\059\000\000\000\000\000\104\000\105\000\
\139\000\140\000\000\000\106\000\107\000\000\000\000\000\000\000\
\140\001\109\000\000\000\000\000\110\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\111\000\112\000\113\000\
\000\000\000\000\000\000\000\000\015\000\016\000\017\000\018\000\
\019\000\000\000\021\000\022\000\023\000\024\000\025\000\026\000\
\027\000\028\000\029\000\030\000\031\000\032\000\033\000\034\000\
\035\000\036\000\037\000\038\000\039\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\127\000\128\000\129\000\130\000\000\000\000\000\
\041\000\000\000\043\000\000\000\000\000\044\000\045\000\000\000\
\000\000\000\000\133\000\000\000\000\000\000\000\000\000\094\000\
\095\000\096\000\097\000\098\000\000\000\000\000\000\000\099\000\
\169\000\139\001\000\000\013\000\102\000\000\000\000\000\000\000\
\000\000\058\000\059\000\000\000\000\000\104\000\105\000\139\000\
\140\000\000\000\106\000\107\000\000\000\000\000\000\000\140\001\
\109\000\000\000\000\000\110\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\111\000\112\000\113\000\000\000\
\000\000\000\000\000\000\015\000\016\000\017\000\018\000\019\000\
\000\000\021\000\022\000\023\000\024\000\025\000\026\000\027\000\
\028\000\029\000\030\000\031\000\032\000\033\000\034\000\035\000\
\036\000\037\000\038\000\039\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\127\000\128\000\129\000\130\000\000\000\000\000\041\000\
\000\000\043\000\000\000\000\000\044\000\045\000\000\000\000\000\
\000\000\133\000\000\000\000\000\000\000\000\000\094\000\095\000\
\096\000\097\000\098\000\000\000\000\000\000\000\099\000\169\000\
\139\001\000\000\013\000\102\000\000\000\000\000\000\000\000\000\
\058\000\059\000\000\000\000\000\104\000\105\000\139\000\140\000\
\000\000\106\000\107\000\000\000\000\000\000\000\140\001\109\000\
\000\000\000\000\110\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\111\000\112\000\113\000\000\000\000\000\
\000\000\000\000\015\000\016\000\017\000\018\000\019\000\000\000\
\021\000\022\000\023\000\024\000\025\000\026\000\027\000\028\000\
\029\000\030\000\031\000\032\000\033\000\034\000\035\000\036\000\
\037\000\038\000\039\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\127\000\128\000\129\000\130\000\000\000\000\000\041\000\000\000\
\043\000\000\000\000\000\044\000\045\000\000\000\000\000\000\000\
\133\000\000\000\000\000\000\000\000\000\094\000\095\000\096\000\
\097\000\098\000\000\000\000\000\000\000\099\000\100\000\000\000\
\012\000\075\001\102\000\000\000\103\000\000\000\000\000\058\000\
\059\000\000\000\000\000\104\000\105\000\139\000\140\000\000\000\
\106\000\107\000\000\000\000\000\108\000\148\001\109\000\000\000\
\000\000\110\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\111\000\112\000\113\000\000\000\000\000\000\000\
\000\000\015\000\016\000\017\000\018\000\019\000\114\000\021\000\
\022\000\023\000\024\000\025\000\026\000\027\000\028\000\029\000\
\030\000\031\000\032\000\033\000\034\000\035\000\036\000\037\000\
\038\000\039\000\115\000\116\000\000\000\117\000\118\000\119\000\
\120\000\125\001\122\000\123\000\124\000\125\000\126\000\127\000\
\128\000\129\000\130\000\000\000\000\000\041\000\126\001\043\000\
\132\000\000\000\044\000\045\000\046\000\000\000\000\000\133\000\
\127\001\128\001\000\000\000\000\000\000\047\000\000\000\048\000\
\049\000\050\000\051\000\052\000\053\000\054\000\134\000\000\000\
\000\000\055\000\000\000\056\000\000\000\057\000\058\000\059\000\
\135\000\136\000\137\000\138\000\139\000\140\000\000\000\000\000\
\141\000\141\000\141\000\141\000\141\000\141\000\000\000\000\000\
\000\000\141\000\141\000\000\000\141\000\141\000\141\000\000\000\
\141\000\000\000\000\000\000\000\000\000\000\000\000\000\141\000\
\141\000\000\000\000\000\000\000\141\000\141\000\000\000\000\000\
\141\000\000\000\141\000\000\000\000\000\141\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\141\000\141\000\
\141\000\000\000\000\000\000\000\000\000\141\000\141\000\141\000\
\141\000\141\000\141\000\141\000\141\000\141\000\141\000\141\000\
\141\000\141\000\141\000\141\000\141\000\141\000\141\000\141\000\
\141\000\141\000\141\000\141\000\141\000\141\000\141\000\141\000\
\000\000\141\000\141\000\141\000\141\000\141\000\141\000\141\000\
\141\000\141\000\141\000\141\000\141\000\141\000\141\000\000\000\
\000\000\141\000\141\000\141\000\141\000\000\000\141\000\141\000\
\141\000\000\000\000\000\141\000\000\000\000\000\000\000\182\001\
\000\000\141\000\000\000\141\000\141\000\141\000\141\000\141\000\
\141\000\141\000\141\000\000\000\000\000\141\000\000\000\141\000\
\000\000\141\000\141\000\141\000\141\000\141\000\141\000\141\000\
\141\000\141\000\141\000\000\000\141\000\140\000\140\000\140\000\
\140\000\140\000\000\000\000\000\000\000\140\000\140\000\000\000\
\140\000\140\000\140\000\000\000\140\000\000\000\000\000\000\000\
\000\000\000\000\000\000\140\000\140\000\000\000\000\000\000\000\
\140\000\140\000\000\000\000\000\140\000\000\000\140\000\000\000\
\000\000\140\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\140\000\140\000\140\000\000\000\000\000\000\000\
\000\000\140\000\140\000\140\000\140\000\140\000\140\000\140\000\
\140\000\140\000\140\000\140\000\140\000\140\000\140\000\140\000\
\140\000\140\000\140\000\140\000\140\000\140\000\140\000\140\000\
\140\000\140\000\140\000\140\000\000\000\140\000\140\000\140\000\
\140\000\140\000\140\000\140\000\140\000\140\000\140\000\140\000\
\140\000\140\000\140\000\000\000\000\000\140\000\140\000\140\000\
\140\000\000\000\140\000\140\000\140\000\000\000\000\000\140\000\
\000\000\000\000\000\000\183\001\000\000\140\000\000\000\140\000\
\140\000\140\000\140\000\140\000\140\000\140\000\140\000\000\000\
\000\000\140\000\000\000\140\000\000\000\140\000\140\000\140\000\
\140\000\140\000\140\000\140\000\140\000\140\000\140\000\000\000\
\140\000\142\000\142\000\142\000\142\000\142\000\000\000\000\000\
\000\000\142\000\142\000\000\000\142\000\142\000\142\000\000\000\
\142\000\000\000\000\000\000\000\000\000\000\000\000\000\142\000\
\142\000\000\000\000\000\000\000\142\000\142\000\000\000\000\000\
\142\000\000\000\142\000\000\000\000\000\142\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\142\000\142\000\
\142\000\000\000\000\000\000\000\000\000\142\000\142\000\142\000\
\142\000\142\000\142\000\142\000\142\000\142\000\142\000\142\000\
\142\000\142\000\142\000\142\000\142\000\142\000\142\000\142\000\
\142\000\142\000\142\000\142\000\142\000\142\000\142\000\142\000\
\000\000\142\000\142\000\142\000\142\000\142\000\142\000\142\000\
\142\000\142\000\142\000\142\000\142\000\142\000\142\000\000\000\
\000\000\142\000\142\000\142\000\142\000\000\000\142\000\142\000\
\142\000\000\000\000\000\142\000\000\000\000\000\000\000\187\001\
\000\000\142\000\000\000\142\000\142\000\142\000\142\000\142\000\
\142\000\142\000\142\000\000\000\000\000\142\000\000\000\142\000\
\000\000\142\000\142\000\142\000\142\000\142\000\142\000\142\000\
\142\000\142\000\142\000\000\000\142\000\094\000\095\000\096\000\
\097\000\098\000\000\000\000\000\000\000\099\000\100\000\000\000\
\012\000\075\001\102\000\000\000\103\000\000\000\000\000\000\000\
\000\000\000\000\000\000\104\000\105\000\000\000\000\000\000\000\
\106\000\107\000\000\000\000\000\108\000\000\000\109\000\000\000\
\000\000\110\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\111\000\112\000\113\000\000\000\000\000\000\000\
\000\000\015\000\016\000\017\000\018\000\019\000\114\000\021\000\
\022\000\023\000\024\000\025\000\026\000\027\000\028\000\029\000\
\030\000\031\000\032\000\033\000\034\000\035\000\036\000\037\000\
\038\000\039\000\115\000\116\000\000\000\117\000\118\000\119\000\
\120\000\125\001\122\000\123\000\124\000\125\000\126\000\127\000\
\128\000\129\000\130\000\000\000\000\000\041\000\126\001\043\000\
\132\000\000\000\044\000\045\000\046\000\000\000\000\000\133\000\
\000\000\128\001\000\000\000\000\000\000\047\000\000\000\048\000\
\049\000\050\000\051\000\052\000\053\000\054\000\134\000\000\000\
\000\000\055\000\000\000\056\000\000\000\057\000\058\000\059\000\
\135\000\136\000\137\000\138\000\139\000\140\000\000\000\000\000\
\141\000\094\000\095\000\096\000\097\000\098\000\000\000\000\000\
\000\000\099\000\100\000\000\000\012\000\075\001\102\000\000\000\
\103\000\000\000\000\000\000\000\000\000\000\000\000\000\104\000\
\105\000\000\000\000\000\000\000\106\000\107\000\000\000\000\000\
\108\000\000\000\109\000\000\000\000\000\110\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\111\000\112\000\
\113\000\000\000\000\000\000\000\000\000\015\000\016\000\017\000\
\018\000\019\000\114\000\021\000\022\000\023\000\024\000\025\000\
\026\000\027\000\028\000\029\000\030\000\031\000\032\000\033\000\
\034\000\035\000\036\000\037\000\038\000\039\000\115\000\116\000\
\000\000\117\000\076\001\119\000\120\000\121\000\122\000\123\000\
\124\000\125\000\077\001\127\000\128\000\129\000\130\000\000\000\
\000\000\041\000\131\000\043\000\132\000\000\000\044\000\045\000\
\046\000\000\000\000\000\133\000\000\000\000\000\000\000\000\000\
\000\000\047\000\000\000\048\000\049\000\050\000\051\000\052\000\
\053\000\054\000\134\000\000\000\000\000\055\000\000\000\056\000\
\000\000\057\000\058\000\059\000\135\000\136\000\137\000\138\000\
\139\000\140\000\000\000\000\000\141\000\094\000\095\000\096\000\
\097\000\098\000\000\000\000\000\000\000\099\000\100\000\000\000\
\000\000\075\001\102\000\000\000\103\000\000\000\000\000\000\000\
\000\000\000\000\000\000\104\000\105\000\000\000\000\000\000\000\
\106\000\107\000\000\000\000\000\108\000\000\000\109\000\000\000\
\000\000\110\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\111\000\112\000\113\000\000\000\000\000\000\000\
\000\000\015\000\016\000\017\000\018\000\019\000\114\000\021\000\
\022\000\023\000\024\000\025\000\026\000\027\000\028\000\029\000\
\030\000\031\000\032\000\033\000\034\000\035\000\036\000\037\000\
\038\000\039\000\115\000\116\000\000\000\117\000\118\000\119\000\
\120\000\121\000\122\000\123\000\124\000\125\000\126\000\127\000\
\128\000\129\000\130\000\000\000\000\000\041\000\131\000\043\000\
\132\000\000\000\044\000\045\000\000\000\000\000\000\000\133\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\134\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\058\000\059\000\
\135\000\136\000\137\000\138\000\139\000\140\000\000\000\000\000\
\141\000\094\000\095\000\096\000\097\000\098\000\000\000\000\000\
\000\000\099\000\100\000\000\000\000\000\101\000\102\000\000\000\
\103\000\000\000\000\000\000\000\000\000\000\000\000\000\104\000\
\105\000\000\000\000\000\000\000\106\000\107\000\000\000\000\000\
\108\000\000\000\109\000\000\000\000\000\110\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\111\000\112\000\
\113\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\114\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\115\000\116\000\
\000\000\117\000\118\000\119\000\120\000\121\000\122\000\123\000\
\124\000\125\000\126\000\127\000\128\000\129\000\130\000\000\000\
\000\000\000\000\131\000\000\000\132\000\000\000\000\000\000\000\
\000\000\000\000\000\000\133\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\048\000\094\000\095\000\096\000\097\000\
\098\000\000\000\134\000\000\000\099\000\100\000\000\000\000\000\
\101\000\102\000\000\000\103\000\135\000\136\000\137\000\138\000\
\139\000\140\000\104\000\105\000\141\000\000\000\000\000\106\000\
\107\000\000\000\000\000\108\000\000\000\109\000\000\000\000\000\
\110\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\111\000\112\000\113\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\114\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\115\000\116\000\000\000\117\000\118\000\119\000\120\000\
\121\000\122\000\123\000\124\000\125\000\126\000\127\000\128\000\
\129\000\130\000\000\000\000\000\000\000\131\000\000\000\132\000\
\000\000\000\000\000\000\000\000\000\000\000\000\133\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\094\000\
\095\000\096\000\097\000\098\000\000\000\134\000\000\000\099\000\
\169\000\000\000\000\000\013\000\102\000\000\000\000\000\135\000\
\136\000\137\000\138\000\139\000\140\000\104\000\105\000\141\000\
\000\000\000\000\106\000\107\000\000\000\000\000\108\000\000\000\
\109\000\000\000\000\000\110\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\111\000\112\000\113\000\000\000\
\000\000\000\000\000\000\015\000\016\000\017\000\018\000\019\000\
\000\000\021\000\022\000\023\000\024\000\025\000\026\000\027\000\
\028\000\029\000\030\000\031\000\032\000\033\000\034\000\035\000\
\036\000\037\000\038\000\039\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\127\000\128\000\129\000\130\000\000\000\000\000\041\000\
\000\000\043\000\132\000\000\000\044\000\045\000\000\000\000\000\
\000\000\133\000\000\000\000\000\000\000\000\000\094\000\095\000\
\096\000\097\000\098\000\000\000\000\000\000\000\099\000\169\000\
\000\000\000\000\013\000\102\000\000\000\000\000\000\000\000\000\
\058\000\059\000\135\000\136\000\104\000\105\000\139\000\140\000\
\000\000\106\000\107\000\000\000\000\000\000\000\000\000\109\000\
\000\000\000\000\110\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\111\000\112\000\113\000\000\000\000\000\
\000\000\000\000\015\000\016\000\017\000\018\000\019\000\000\000\
\021\000\022\000\023\000\024\000\025\000\026\000\027\000\028\000\
\000\000\000\000\000\000\000\000\000\000\034\000\035\000\036\000\
\037\000\038\000\039\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\127\000\128\000\129\000\130\000\000\000\000\000\041\000\000\000\
\043\000\000\000\000\000\000\000\045\000\000\000\000\000\000\000\
\133\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\058\000\
\059\000\000\000\000\000\000\000\000\000\139\000\140\000\094\000\
\095\000\096\000\097\000\098\000\000\000\000\000\000\000\099\000\
\101\002\000\000\000\000\192\000\102\000\000\000\102\002\239\002\
\103\002\000\000\104\002\000\000\000\000\104\000\105\000\000\000\
\000\000\000\000\106\000\107\000\000\000\000\000\000\000\000\000\
\109\000\000\000\000\000\110\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\111\000\112\000\113\000\000\000\
\000\000\094\000\095\000\096\000\097\000\098\000\000\000\000\000\
\194\000\099\000\101\002\000\000\000\000\192\000\102\000\000\000\
\102\002\041\003\103\002\000\000\104\002\000\000\000\000\104\000\
\105\000\000\000\000\000\000\000\106\000\107\000\000\000\000\000\
\000\000\000\000\109\000\000\000\000\000\110\000\000\000\000\000\
\000\000\127\000\128\000\129\000\130\000\000\000\111\000\112\000\
\113\000\000\000\000\000\000\000\094\000\095\000\096\000\097\000\
\098\000\133\000\194\000\000\000\099\000\101\002\000\000\000\000\
\192\000\102\000\000\000\102\002\000\000\103\002\000\000\104\002\
\000\000\000\000\104\000\105\000\000\000\000\000\000\000\106\000\
\107\000\000\000\000\000\000\000\000\000\109\000\139\000\140\000\
\110\000\000\000\000\000\127\000\128\000\129\000\130\000\000\000\
\000\000\111\000\112\000\113\000\000\000\000\000\094\000\095\000\
\096\000\097\000\098\000\133\000\000\000\194\000\099\000\169\000\
\000\000\000\000\000\000\102\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\104\000\105\000\000\000\000\000\
\000\000\106\000\107\000\000\000\000\000\108\000\000\000\109\000\
\139\000\140\000\110\000\000\000\000\000\000\000\127\000\128\000\
\129\000\130\000\000\000\111\000\112\000\113\000\000\000\000\000\
\000\000\094\000\095\000\096\000\097\000\098\000\133\000\000\000\
\000\000\099\000\169\000\000\000\000\000\000\000\102\000\000\000\
\103\000\000\000\000\000\000\000\000\000\000\000\000\000\104\000\
\105\000\000\000\000\000\000\000\106\000\107\000\000\000\000\000\
\000\000\000\000\109\000\139\000\140\000\110\000\000\000\000\000\
\127\000\128\000\129\000\130\000\000\000\000\000\111\000\112\000\
\113\000\132\000\000\000\094\000\095\000\096\000\097\000\098\000\
\133\000\000\000\000\000\099\000\169\000\000\000\000\000\000\000\
\102\000\000\000\000\000\000\000\023\001\000\000\000\000\000\000\
\000\000\104\000\105\000\000\000\000\000\000\000\106\000\107\000\
\000\000\135\000\136\000\000\000\109\000\139\000\140\000\110\000\
\000\000\000\000\000\000\127\000\128\000\129\000\130\000\000\000\
\111\000\112\000\113\000\000\000\000\000\000\000\094\000\095\000\
\096\000\097\000\098\000\133\000\000\000\000\000\099\000\169\000\
\000\000\000\000\000\000\102\000\000\000\000\000\000\000\000\000\
\067\002\000\000\000\000\000\000\104\000\105\000\000\000\000\000\
\000\000\106\000\107\000\000\000\000\000\000\000\000\000\109\000\
\139\000\140\000\110\000\000\000\000\000\127\000\128\000\129\000\
\130\000\000\000\000\000\111\000\112\000\113\000\000\000\000\000\
\094\000\095\000\096\000\097\000\098\000\133\000\000\000\000\000\
\099\000\169\000\000\000\000\000\000\000\102\000\000\000\000\000\
\000\000\000\000\129\002\000\000\000\000\000\000\104\000\105\000\
\000\000\000\000\000\000\106\000\107\000\000\000\000\000\000\000\
\000\000\109\000\139\000\140\000\110\000\000\000\000\000\000\000\
\127\000\128\000\129\000\130\000\000\000\111\000\112\000\113\000\
\000\000\000\000\000\000\094\000\095\000\096\000\097\000\098\000\
\133\000\000\000\000\000\099\000\169\000\000\000\000\000\000\000\
\102\000\000\000\102\002\000\000\000\000\000\000\000\000\000\000\
\000\000\104\000\105\000\000\000\000\000\000\000\106\000\107\000\
\000\000\000\000\000\000\000\000\109\000\139\000\140\000\110\000\
\000\000\000\000\127\000\128\000\129\000\130\000\000\000\000\000\
\111\000\112\000\113\000\000\000\000\000\094\000\095\000\096\000\
\097\000\098\000\133\000\000\000\000\000\099\000\169\000\000\000\
\000\000\000\000\102\000\000\000\198\002\000\000\000\000\000\000\
\000\000\000\000\000\000\104\000\105\000\000\000\000\000\000\000\
\106\000\107\000\000\000\000\000\000\000\000\000\109\000\139\000\
\140\000\110\000\000\000\000\000\000\000\127\000\128\000\129\000\
\130\000\000\000\111\000\112\000\113\000\000\000\000\000\000\000\
\094\000\095\000\096\000\097\000\098\000\133\000\000\000\000\000\
\099\000\169\000\000\000\000\000\000\000\102\000\000\000\000\000\
\000\000\000\000\206\002\000\000\000\000\000\000\104\000\105\000\
\000\000\000\000\000\000\106\000\107\000\000\000\000\000\000\000\
\000\000\109\000\139\000\140\000\110\000\000\000\000\000\127\000\
\128\000\129\000\130\000\000\000\000\000\111\000\112\000\113\000\
\000\000\000\000\094\000\095\000\096\000\097\000\098\000\133\000\
\000\000\000\000\099\000\169\000\000\000\000\000\000\000\102\000\
\023\003\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\104\000\105\000\000\000\000\000\000\000\106\000\107\000\000\000\
\000\000\000\000\000\000\109\000\139\000\140\000\110\000\000\000\
\000\000\000\000\127\000\128\000\129\000\130\000\000\000\111\000\
\112\000\113\000\000\000\000\000\000\000\094\000\095\000\096\000\
\097\000\098\000\133\000\000\000\000\000\099\000\169\000\000\000\
\000\000\000\000\102\000\025\003\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\104\000\105\000\000\000\000\000\000\000\
\106\000\107\000\000\000\000\000\000\000\000\000\109\000\139\000\
\140\000\110\000\000\000\000\000\127\000\128\000\129\000\130\000\
\000\000\000\000\111\000\112\000\113\000\000\000\000\000\094\000\
\095\000\096\000\097\000\098\000\133\000\000\000\000\000\099\000\
\169\000\000\000\000\000\000\000\102\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\104\000\105\000\000\000\
\000\000\000\000\106\000\107\000\000\000\000\000\000\000\000\000\
\109\000\139\000\140\000\110\000\000\000\000\000\000\000\127\000\
\128\000\129\000\130\000\000\000\111\000\112\000\113\000\000\000\
\017\002\000\000\000\000\017\002\017\002\017\002\017\002\133\000\
\066\001\000\000\000\000\017\002\066\001\066\001\000\000\000\000\
\066\001\000\000\000\000\066\001\000\000\017\002\017\002\000\000\
\000\000\000\000\000\000\017\002\000\000\000\000\066\001\000\000\
\000\000\000\000\000\000\066\001\139\000\140\000\017\002\000\000\
\000\000\127\000\128\000\129\000\130\000\067\001\066\001\069\001\
\017\002\067\001\067\001\069\001\069\001\067\001\000\000\069\001\
\067\001\133\000\069\001\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\067\001\000\000\069\001\000\000\000\000\
\067\001\000\000\069\001\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\067\001\000\000\069\001\139\000\140\000\
\000\000\000\000\017\002\065\001\000\000\000\000\000\000\065\001\
\065\001\017\002\066\001\065\001\000\000\000\000\065\001\000\000\
\000\000\066\001\000\000\000\000\000\000\066\001\000\000\000\000\
\000\000\065\001\000\000\000\000\000\000\000\000\065\001\000\000\
\000\000\000\000\017\002\017\002\000\000\000\000\017\002\000\000\
\000\000\065\001\066\001\066\001\000\000\017\002\066\001\067\001\
\000\000\069\001\000\000\000\000\000\000\066\001\067\001\000\000\
\069\001\000\000\067\001\000\000\069\001\000\000\000\000\000\000\
\078\001\000\000\000\000\000\000\078\001\078\001\000\000\000\000\
\078\001\000\000\000\000\078\001\000\000\000\000\000\000\067\001\
\067\001\069\001\069\001\067\001\000\000\069\001\078\001\000\000\
\000\000\000\000\067\001\078\001\069\001\065\001\000\000\000\000\
\000\000\000\000\000\000\000\000\065\001\076\001\078\001\000\000\
\065\001\076\001\076\001\000\000\000\000\076\001\077\001\000\000\
\076\001\000\000\077\001\077\001\000\000\000\000\077\001\000\000\
\000\000\077\001\000\000\076\001\000\000\065\001\065\001\000\000\
\076\001\065\001\000\000\000\000\077\001\000\000\000\000\000\000\
\065\001\077\001\000\000\076\001\000\000\079\001\000\000\000\000\
\000\000\079\001\079\001\000\000\077\001\079\001\000\000\000\000\
\079\001\000\000\078\001\000\000\000\000\000\000\000\000\000\000\
\000\000\078\001\000\000\079\001\000\000\078\001\000\000\000\000\
\079\001\000\000\000\000\000\000\075\001\000\000\000\000\000\000\
\075\001\075\001\000\000\079\001\075\001\000\000\000\000\075\001\
\000\000\000\000\078\001\078\001\000\000\000\000\078\001\076\001\
\000\000\000\000\075\001\000\000\000\000\078\001\076\001\075\001\
\077\001\000\000\076\001\000\000\000\000\000\000\000\000\077\001\
\000\000\000\000\075\001\077\001\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\076\001\
\076\001\000\000\000\000\076\001\000\000\000\000\000\000\079\001\
\077\001\077\001\076\001\000\000\077\001\000\000\079\001\000\000\
\000\000\000\000\079\001\077\001\000\000\169\000\000\000\000\000\
\000\000\220\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\075\001\079\001\
\079\001\000\000\000\000\079\001\003\001\075\001\003\001\003\001\
\221\000\075\001\079\001\000\000\003\001\000\000\000\000\000\000\
\000\000\003\001\000\000\222\000\000\000\000\000\003\001\003\001\
\000\000\000\000\000\000\000\000\000\000\000\000\075\001\075\001\
\000\000\000\000\075\001\000\000\000\000\000\000\000\000\000\000\
\000\000\075\001\000\000\000\000\003\001\003\001\003\001\003\001\
\003\001\000\000\003\001\003\001\003\001\003\001\003\001\003\001\
\003\001\003\001\003\001\003\001\003\001\003\001\003\001\003\001\
\003\001\003\001\003\001\003\001\003\001\000\000\043\000\000\000\
\000\000\000\000\000\000\046\000\000\000\000\000\133\000\000\000\
\000\000\000\000\000\000\000\000\047\000\000\000\003\001\000\000\
\003\001\003\001\003\001\003\001\000\000\003\001\003\001\003\001\
\055\000\000\000\056\000\000\000\057\000\058\000\059\000\000\000\
\003\001\000\000\000\000\139\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\003\001\000\000\003\001\000\000\
\003\001\003\001\003\001\003\001\003\001\002\001\000\000\002\001\
\002\001\003\001\000\000\000\000\000\000\002\001\003\001\000\000\
\000\000\000\000\002\001\000\000\000\000\000\000\000\000\002\001\
\002\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\002\001\002\001\002\001\
\002\001\002\001\000\000\002\001\002\001\002\001\002\001\002\001\
\002\001\002\001\002\001\002\001\002\001\002\001\002\001\002\001\
\002\001\002\001\002\001\002\001\002\001\002\001\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\001\
\000\000\002\001\002\001\002\001\002\001\000\000\002\001\002\001\
\002\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\089\001\002\001\000\000\089\001\089\001\000\000\000\000\000\000\
\089\001\000\000\000\000\000\000\000\000\002\001\000\000\002\001\
\000\000\002\001\002\001\002\001\002\001\002\001\089\001\000\000\
\000\000\000\000\002\001\089\001\000\000\000\000\000\000\002\001\
\000\000\000\000\000\000\000\000\000\000\000\000\089\001\000\000\
\000\000\000\000\000\000\089\001\089\001\089\001\089\001\089\001\
\000\000\089\001\089\001\089\001\089\001\089\001\089\001\089\001\
\089\001\089\001\089\001\089\001\089\001\089\001\089\001\089\001\
\089\001\089\001\089\001\089\001\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\089\001\
\011\000\089\001\089\001\013\000\089\001\089\001\000\000\000\000\
\000\000\089\001\000\000\000\000\000\000\089\001\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\180\001\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\089\001\089\001\089\001\089\001\000\000\000\000\089\001\000\000\
\063\001\000\000\000\000\015\000\016\000\017\000\018\000\019\000\
\020\000\021\000\022\000\023\000\024\000\025\000\026\000\027\000\
\028\000\000\000\000\000\000\000\000\000\000\000\034\000\035\000\
\036\000\037\000\038\000\039\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\041\000\
\000\000\043\000\000\000\000\000\000\000\045\000\046\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\047\000\
\000\000\048\000\049\000\050\000\051\000\052\000\053\000\054\000\
\000\000\000\000\000\000\055\000\000\000\056\000\000\000\057\000\
\058\000\059\000\245\000\000\000\000\000\245\000\245\000\000\000\
\181\001\000\000\245\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\013\000\
\245\000\000\000\000\000\000\000\000\000\245\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\245\000\000\000\000\000\000\000\000\000\245\000\245\000\245\000\
\245\000\245\000\000\000\245\000\245\000\245\000\245\000\245\000\
\245\000\245\000\245\000\245\000\245\000\245\000\245\000\245\000\
\245\000\245\000\245\000\245\000\245\000\245\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\245\000\000\000\245\000\245\000\025\002\245\000\245\000\
\025\002\000\000\000\000\245\000\000\000\025\002\000\000\245\000\
\000\000\000\000\025\002\000\000\000\000\000\000\000\000\000\000\
\025\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\245\000\245\000\245\000\245\000\000\000\000\000\
\245\000\000\000\000\000\000\000\000\000\025\002\025\002\025\002\
\025\002\025\002\000\000\025\002\025\002\025\002\025\002\025\002\
\025\002\025\002\025\002\025\002\025\002\025\002\025\002\025\002\
\025\002\025\002\025\002\025\002\025\002\025\002\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\171\001\000\000\025\002\
\171\001\025\002\000\000\025\002\000\000\105\001\025\002\025\002\
\025\002\000\000\105\001\000\000\000\000\000\000\000\000\000\000\
\105\001\025\002\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\025\002\000\000\025\002\
\000\000\025\002\025\002\025\002\000\000\171\001\171\001\171\001\
\171\001\171\001\025\002\171\001\171\001\171\001\171\001\171\001\
\171\001\171\001\171\001\171\001\171\001\171\001\171\001\171\001\
\171\001\171\001\171\001\171\001\171\001\171\001\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\172\001\000\000\105\001\
\172\001\171\001\000\000\171\001\000\000\107\001\171\001\171\001\
\171\001\000\000\107\001\000\000\000\000\000\000\000\000\000\000\
\107\001\171\001\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\171\001\000\000\171\001\
\000\000\171\001\171\001\171\001\000\000\172\001\172\001\172\001\
\172\001\172\001\171\001\172\001\172\001\172\001\172\001\172\001\
\172\001\172\001\172\001\172\001\172\001\172\001\172\001\172\001\
\172\001\172\001\172\001\172\001\172\001\172\001\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\107\001\
\000\000\172\001\000\000\172\001\000\000\000\000\172\001\172\001\
\172\001\102\001\000\000\013\000\000\000\103\001\000\000\000\000\
\000\000\172\001\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\172\001\000\000\172\001\
\000\000\172\001\172\001\172\001\000\000\000\000\000\000\000\000\
\000\000\000\000\172\001\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\015\000\016\000\017\000\018\000\019\000\
\000\000\021\000\022\000\023\000\024\000\025\000\026\000\027\000\
\028\000\029\000\030\000\031\000\032\000\033\000\034\000\035\000\
\036\000\037\000\038\000\039\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\102\001\000\000\013\000\000\000\000\000\000\000\000\000\041\000\
\000\000\043\000\000\000\000\000\044\000\045\000\000\000\000\000\
\000\000\000\000\000\000\211\002\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\058\000\059\000\015\000\016\000\017\000\018\000\019\000\000\000\
\021\000\022\000\023\000\024\000\025\000\026\000\027\000\028\000\
\029\000\030\000\031\000\032\000\033\000\034\000\035\000\036\000\
\037\000\038\000\039\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\102\001\
\000\000\013\000\000\000\000\000\000\000\000\000\041\000\000\000\
\043\000\000\000\000\000\044\000\045\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\058\000\
\059\000\015\000\016\000\017\000\018\000\019\000\000\000\021\000\
\022\000\023\000\024\000\025\000\026\000\027\000\028\000\029\000\
\030\000\031\000\032\000\033\000\034\000\035\000\036\000\037\000\
\038\000\039\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\235\001\000\000\
\235\001\000\000\000\000\000\000\000\000\041\000\000\000\043\000\
\000\000\000\000\044\000\045\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\058\000\059\000\
\235\001\235\001\235\001\235\001\235\001\000\000\235\001\235\001\
\235\001\235\001\235\001\235\001\235\001\235\001\235\001\235\001\
\235\001\235\001\235\001\235\001\235\001\235\001\235\001\235\001\
\235\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\012\000\013\000\
\000\000\000\000\000\000\221\002\235\001\000\000\235\001\000\000\
\000\000\235\001\235\001\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\235\001\235\001\015\000\
\016\000\017\000\018\000\019\000\000\000\021\000\022\000\023\000\
\024\000\025\000\026\000\027\000\028\000\029\000\030\000\031\000\
\032\000\033\000\034\000\035\000\036\000\037\000\038\000\039\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\012\000\
\013\000\000\000\180\000\041\000\045\003\043\000\000\000\000\000\
\044\000\045\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\058\000\059\000\000\000\000\000\
\015\000\016\000\017\000\018\000\019\000\000\000\021\000\022\000\
\023\000\024\000\025\000\026\000\027\000\028\000\029\000\030\000\
\031\000\032\000\033\000\034\000\035\000\036\000\037\000\038\000\
\039\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\013\000\
\000\000\000\000\103\000\180\000\041\000\000\000\043\000\000\000\
\000\000\044\000\045\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\058\000\059\000\015\000\
\016\000\017\000\018\000\019\000\000\000\021\000\022\000\023\000\
\024\000\025\000\026\000\027\000\028\000\029\000\030\000\031\000\
\032\000\033\000\034\000\035\000\036\000\037\000\038\000\039\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\013\000\000\000\
\000\000\103\000\000\000\041\000\000\000\043\000\000\000\000\000\
\044\000\045\000\046\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\047\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\055\000\
\000\000\056\000\000\000\057\000\058\000\059\000\015\000\016\000\
\017\000\018\000\019\000\000\000\021\000\022\000\023\000\024\000\
\025\000\026\000\027\000\028\000\029\000\030\000\031\000\032\000\
\033\000\034\000\035\000\036\000\037\000\038\000\039\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\013\000\000\000\000\000\
\000\000\000\000\041\000\000\000\043\000\000\000\000\000\044\000\
\045\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\058\000\059\000\015\000\016\000\017\000\
\018\000\019\000\000\000\021\000\022\000\023\000\024\000\025\000\
\026\000\027\000\028\000\029\000\030\000\031\000\032\000\033\000\
\034\000\035\000\036\000\037\000\038\000\039\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\013\000\000\000\000\000\000\000\
\000\000\041\000\000\000\043\000\000\000\000\000\044\000\045\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\058\000\059\000\015\000\016\000\017\000\018\000\
\019\000\000\000\021\000\022\000\023\000\024\000\025\000\026\000\
\027\000\028\000\029\000\030\000\031\000\032\000\033\000\034\000\
\035\000\036\000\037\000\038\000\039\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\013\000\000\000\000\000\000\000\000\000\
\041\000\000\000\043\000\000\000\000\000\212\000\045\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\058\000\059\000\015\000\016\000\017\000\018\000\019\000\
\000\000\021\000\022\000\023\000\024\000\025\000\026\000\027\000\
\028\000\000\000\000\000\000\000\000\000\000\000\034\000\035\000\
\036\000\037\000\038\000\039\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\111\000\000\000\000\000\000\000\000\000\041\000\
\000\000\043\000\000\000\000\000\000\000\045\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\058\000\059\000\111\000\111\000\111\000\111\000\111\000\000\000\
\111\000\111\000\111\000\111\000\111\000\111\000\111\000\111\000\
\000\000\000\000\000\000\000\000\000\000\111\000\111\000\111\000\
\111\000\111\000\111\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\111\000\000\000\
\111\000\000\000\000\000\000\000\111\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\010\000\000\000\000\000\000\000\010\000\000\000\010\000\010\000\
\010\000\010\000\010\000\010\000\010\000\010\000\000\000\111\000\
\111\000\012\000\010\000\010\000\010\000\010\000\010\000\010\000\
\010\000\010\000\010\000\010\000\010\000\010\000\010\000\010\000\
\010\000\010\000\010\000\010\000\010\000\010\000\010\000\011\000\
\000\000\000\000\000\000\011\000\000\000\011\000\011\000\011\000\
\011\000\011\000\011\000\011\000\011\000\000\000\000\000\000\000\
\014\000\011\000\011\000\011\000\011\000\011\000\011\000\011\000\
\011\000\011\000\011\000\011\000\011\000\011\000\011\000\011\000\
\011\000\011\000\011\000\011\000\011\000\011\000\018\001\000\000\
\000\000\019\001\020\001\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\010\000\000\000\000\000\000\000\000\000\000\000\018\001\
\000\000\000\000\019\001\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\015\000\016\000\017\000\018\000\019\000\000\000\021\000\
\022\000\023\000\024\000\025\000\026\000\027\000\028\000\000\000\
\011\000\000\000\000\000\000\000\000\000\000\000\036\000\037\000\
\038\000\039\000\015\000\016\000\017\000\018\000\019\000\000\000\
\021\000\022\000\023\000\024\000\025\000\026\000\027\000\028\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\036\000\
\037\000\038\000\039\000\045\000\000\000\000\000\000\000\185\000\
\185\000\185\000\185\000\000\000\000\000\000\000\000\000\000\000\
\185\000\000\000\000\000\185\000\185\000\185\000\185\000\185\000\
\000\000\000\000\000\000\185\000\045\000\185\000\185\000\185\000\
\185\000\185\000\000\000\185\000\000\000\185\000\185\000\185\000\
\185\000\185\000\185\000\185\000\185\000\185\000\185\000\185\000\
\185\000\185\000\185\000\185\000\185\000\185\000\185\000\185\000\
\185\000\185\000\185\000\000\000\000\000\000\000\000\000\000\000\
\000\000\181\000\181\000\181\000\181\000\000\000\000\000\000\000\
\000\000\000\000\181\000\000\000\000\000\181\000\181\000\181\000\
\181\000\181\000\000\000\000\000\000\000\181\000\185\000\181\000\
\181\000\181\000\181\000\181\000\185\000\181\000\000\000\181\000\
\181\000\181\000\181\000\181\000\181\000\181\000\181\000\181\000\
\181\000\181\000\181\000\181\000\181\000\181\000\181\000\181\000\
\181\000\181\000\181\000\181\000\181\000\000\000\000\000\000\000\
\000\000\000\000\000\000\205\001\206\001\207\001\208\001\000\000\
\000\000\000\000\000\000\000\000\209\001\000\000\000\000\210\001\
\211\001\212\001\213\001\214\001\000\000\000\000\000\000\215\001\
\181\000\216\001\217\001\218\001\219\001\220\001\181\000\221\001\
\000\000\222\001\000\000\223\001\224\001\225\001\226\001\227\001\
\228\001\229\001\230\001\231\001\232\001\233\001\234\001\235\001\
\236\001\237\001\238\001\239\001\240\001\241\001\242\001\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\010\000\000\000\
\000\000\010\000\010\000\000\000\010\000\010\000\010\000\010\000\
\010\000\000\000\243\001\010\000\000\000\000\000\000\000\005\000\
\244\001\010\000\010\000\010\000\010\000\010\000\010\000\010\000\
\010\000\010\000\010\000\010\000\010\000\010\000\010\000\010\000\
\010\000\010\000\010\000\010\000\010\000"

let yycheck = "\003\000\
\033\001\003\000\002\000\002\000\002\000\076\000\006\000\038\000\
\076\000\164\000\118\000\004\000\086\000\002\000\002\000\205\000\
\038\001\129\000\002\000\226\000\076\000\010\000\010\000\036\000\
\037\000\002\000\010\000\157\000\102\000\117\001\246\001\177\001\
\012\000\000\000\125\000\185\001\177\000\105\001\000\000\173\001\
\006\001\209\000\096\001\155\000\008\001\008\001\173\001\145\002\
\000\000\027\001\205\000\177\000\083\000\014\001\083\002\038\003\
\017\001\097\001\108\002\130\000\138\002\019\001\019\001\173\000\
\174\000\175\000\019\001\025\001\025\001\199\000\000\000\035\001\
\025\001\164\000\019\001\021\001\038\003\036\001\082\002\009\003\
\025\001\018\001\018\001\018\001\204\001\018\001\086\000\228\000\
\014\001\197\000\019\001\052\001\030\001\062\001\014\001\145\002\
\025\001\086\000\086\000\167\001\014\001\062\001\086\000\107\002\
\018\001\196\000\019\001\115\001\020\001\102\000\062\001\014\001\
\153\000\119\002\017\001\030\001\115\000\121\000\124\002\121\000\
\032\001\125\000\035\001\035\001\254\002\014\001\030\001\167\001\
\014\001\018\001\240\000\124\000\018\001\022\001\142\001\014\001\
\062\001\018\001\017\001\003\002\077\001\077\001\077\001\176\001\
\127\003\178\001\076\003\014\001\198\002\220\000\111\001\063\001\
\220\000\027\001\018\001\226\000\115\001\115\001\021\001\062\001\
\164\000\099\001\164\000\204\000\085\001\127\003\164\000\029\001\
\030\001\225\000\020\001\245\000\246\000\244\000\252\002\164\000\
\164\000\141\001\141\001\140\001\164\000\003\003\032\001\062\001\
\099\001\035\001\085\001\216\002\244\000\147\001\147\001\111\001\
\196\000\067\003\147\001\099\001\142\001\111\001\072\003\073\001\
\184\000\205\000\147\001\205\000\164\002\083\002\114\001\205\000\
\111\001\094\001\025\001\132\001\205\000\063\001\255\000\020\001\
\205\000\205\000\147\001\061\003\140\001\205\000\111\001\108\001\
\076\001\111\001\140\001\249\001\070\003\123\002\065\001\066\001\
\017\001\132\001\025\001\030\001\240\002\140\001\108\001\021\001\
\240\000\073\002\240\000\095\001\118\001\036\001\246\000\227\000\
\018\001\134\001\085\001\140\001\115\001\001\003\140\001\005\000\
\245\000\245\000\070\002\153\002\072\002\245\000\147\001\240\000\
\134\001\002\001\137\002\015\001\021\001\015\001\141\002\008\001\
\009\001\006\001\006\001\012\001\111\001\147\001\006\001\142\001\
\078\002\010\001\015\001\012\001\250\001\251\001\171\001\015\001\
\072\002\011\002\038\001\018\001\038\001\108\001\042\003\061\002\
\108\001\132\001\020\001\103\001\025\001\118\000\018\001\108\001\
\041\001\038\001\114\001\021\001\019\001\104\001\038\001\036\001\
\117\001\019\001\166\001\065\000\020\003\065\001\066\001\134\001\
\036\001\133\002\134\001\019\001\129\001\179\001\131\001\064\001\
\133\001\025\001\134\001\135\001\147\001\115\001\134\001\147\001\
\190\001\085\001\023\001\085\001\025\001\136\001\137\001\085\001\
\014\001\019\001\065\000\017\001\004\002\005\002\020\001\025\001\
\085\001\085\001\118\001\000\000\025\001\085\001\173\001\014\001\
\142\001\030\001\115\001\111\001\254\002\003\003\018\001\036\001\
\000\000\097\001\185\001\148\002\149\002\185\001\142\001\099\001\
\098\002\125\001\128\000\125\001\197\000\143\001\104\001\078\002\
\132\001\185\001\132\001\009\003\025\001\142\001\132\001\191\001\
\062\001\011\002\081\003\082\003\248\001\209\002\018\001\132\001\
\132\001\115\001\022\001\153\000\132\001\127\002\019\001\222\001\
\008\002\018\001\004\002\005\002\025\001\022\001\136\001\137\001\
\022\001\014\001\024\001\115\001\026\001\018\001\035\001\173\000\
\174\000\175\000\104\000\105\000\142\001\173\001\099\001\118\003\
\041\001\067\003\023\001\179\001\202\002\179\001\072\003\167\001\
\164\001\115\001\044\000\052\001\041\001\034\001\190\001\076\002\
\190\001\127\000\019\001\147\001\052\002\019\001\204\000\052\001\
\025\001\025\001\179\001\025\001\104\000\105\000\212\000\213\000\
\214\000\215\000\216\000\104\001\036\001\190\001\072\000\073\000\
\204\000\147\001\118\000\071\002\253\002\209\000\210\000\081\000\
\098\002\088\001\089\001\127\000\091\001\129\000\019\001\025\001\
\111\001\085\002\240\000\087\002\025\001\212\000\213\000\214\000\
\215\000\216\000\036\001\136\001\137\001\249\001\035\001\249\001\
\083\002\255\000\023\001\103\002\025\001\127\002\232\002\155\000\
\022\003\025\001\111\001\076\001\249\001\076\002\104\001\078\002\
\076\002\249\001\014\001\017\001\036\001\017\001\007\002\249\002\
\025\001\019\001\025\001\023\002\013\002\018\001\095\001\025\001\
\018\001\144\001\035\001\036\001\008\001\036\001\034\001\140\001\
\020\001\066\003\014\001\034\001\035\001\018\001\136\001\137\001\
\019\001\197\000\022\001\233\002\032\001\033\001\025\001\035\001\
\036\001\123\002\018\001\039\001\040\001\035\001\104\001\128\001\
\060\002\061\002\060\002\061\002\023\001\022\001\025\001\024\001\
\077\002\014\001\137\002\123\002\072\001\030\001\141\002\060\002\
\061\002\104\002\090\001\063\001\060\002\061\002\233\002\083\002\
\000\000\018\001\062\001\083\002\035\001\108\001\136\001\137\001\
\072\002\069\002\089\002\075\002\019\001\166\001\117\001\104\001\
\018\001\153\002\025\001\088\002\088\002\019\001\232\002\019\001\
\088\002\109\001\129\001\025\001\131\001\025\001\133\001\034\001\
\035\001\014\001\236\002\237\002\019\001\018\001\019\001\249\002\
\242\002\022\001\025\001\018\001\025\001\216\002\014\001\136\001\
\137\001\014\001\018\001\019\001\017\001\019\001\022\001\020\001\
\018\001\025\001\151\002\025\001\022\001\141\002\042\001\043\001\
\044\001\045\001\046\001\047\001\048\001\049\001\050\001\051\001\
\052\001\053\001\054\001\055\001\056\001\057\001\058\001\059\001\
\060\001\061\001\019\001\019\001\168\002\018\001\168\002\036\001\
\025\001\025\001\174\002\175\002\036\001\179\001\025\001\248\001\
\076\001\062\001\171\002\172\002\173\002\014\001\018\001\021\001\
\190\001\018\001\022\001\025\001\176\001\177\001\178\001\195\002\
\196\002\014\001\009\003\095\001\017\001\009\003\202\002\020\001\
\202\002\014\001\035\001\003\003\020\001\057\003\020\001\000\000\
\041\001\019\001\111\001\019\001\216\002\202\002\115\001\025\001\
\216\002\025\001\202\002\052\001\018\001\210\002\210\002\111\001\
\223\002\005\000\210\002\115\001\128\001\233\002\019\001\233\002\
\019\001\120\001\121\001\233\002\025\001\019\001\025\001\140\001\
\233\002\062\001\019\001\025\001\233\002\233\002\147\001\014\001\
\025\001\233\002\017\001\014\001\140\001\020\001\071\002\115\001\
\036\000\037\000\102\001\147\001\104\001\076\003\132\001\019\001\
\076\003\009\003\166\001\036\001\085\002\025\001\087\002\104\001\
\004\002\005\002\022\003\023\003\022\003\025\003\111\001\014\001\
\017\003\127\001\128\001\018\001\019\001\065\000\103\002\022\001\
\036\003\022\003\036\003\108\002\136\001\137\001\022\003\062\001\
\018\001\019\001\011\001\019\001\022\001\018\001\020\001\136\001\
\137\001\025\001\041\001\140\001\051\003\005\000\000\000\014\001\
\009\001\019\001\018\001\052\003\014\001\052\001\014\001\041\001\
\018\001\091\001\018\001\018\001\022\001\019\001\022\001\018\001\
\145\002\022\001\052\001\022\001\076\003\024\001\000\000\026\001\
\027\001\028\001\086\003\156\002\088\003\023\001\090\003\041\001\
\019\001\041\001\094\003\095\003\248\001\018\001\025\001\035\001\
\019\001\018\001\052\001\019\001\052\001\021\001\025\001\023\001\
\019\001\025\001\020\001\035\001\008\002\021\001\025\001\019\001\
\041\001\065\000\034\001\035\001\036\001\153\000\025\001\025\001\
\111\001\019\001\019\001\052\001\197\002\198\002\030\001\025\001\
\025\001\019\001\019\001\119\002\136\003\137\003\136\003\137\003\
\124\002\173\000\174\000\175\000\144\003\019\001\144\003\019\001\
\115\001\019\001\148\001\076\001\077\001\140\001\104\001\025\001\
\052\002\189\000\115\001\148\001\019\001\111\001\019\001\111\001\
\148\002\149\002\025\001\236\002\237\002\018\001\021\001\019\001\
\204\000\242\002\018\001\071\002\101\001\025\001\103\001\181\002\
\212\000\213\000\214\000\215\000\216\000\111\001\136\001\137\001\
\104\001\085\002\140\001\087\002\140\001\024\001\019\001\019\001\
\228\000\036\001\011\003\115\001\025\001\025\001\018\001\014\001\
\019\001\153\000\017\001\103\002\240\000\134\001\135\001\019\001\
\108\002\019\001\035\001\019\001\000\000\025\001\023\001\021\001\
\136\001\137\001\035\001\255\000\036\001\173\000\174\000\175\000\
\019\001\091\001\019\001\147\001\021\001\018\001\023\001\035\001\
\025\001\025\001\018\001\023\001\036\001\017\001\031\001\035\001\
\057\003\034\001\035\001\036\001\037\001\145\002\014\001\062\001\
\020\001\014\001\035\001\018\001\204\000\036\001\023\001\019\001\
\156\002\019\001\018\001\025\001\212\000\213\000\214\000\215\000\
\216\000\253\002\254\002\048\001\049\001\050\001\051\001\052\001\
\053\001\054\001\055\001\056\001\228\000\001\000\002\000\003\000\
\004\000\005\000\006\000\007\000\019\001\021\001\036\001\019\001\
\240\000\036\001\014\001\174\002\175\002\108\001\014\001\036\001\
\111\001\197\002\198\002\025\001\023\001\019\001\117\001\255\000\
\050\001\051\001\052\001\053\001\054\001\055\001\056\001\104\001\
\195\002\196\002\129\001\021\001\131\001\049\003\133\001\019\001\
\036\001\017\001\115\001\084\001\014\001\140\001\036\001\036\001\
\018\001\019\001\084\001\036\001\022\001\115\001\066\003\067\003\
\236\002\237\002\021\001\019\001\072\003\008\001\242\002\136\001\
\137\001\035\001\036\001\023\001\036\001\122\001\018\001\041\001\
\128\001\019\001\147\001\021\001\022\001\023\001\000\000\025\001\
\019\001\036\001\052\001\029\001\030\001\031\001\009\001\011\003\
\034\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\042\001\043\001\044\001\045\001\046\001\047\001\048\001\049\001\
\050\001\051\001\052\001\053\001\054\001\055\001\056\001\171\001\
\036\001\173\001\142\001\000\000\023\003\021\001\025\003\179\001\
\052\001\053\001\054\001\055\001\056\001\036\001\036\001\035\001\
\140\003\019\001\190\001\019\001\021\001\057\003\104\001\212\000\
\213\000\214\000\215\000\216\000\115\001\111\001\041\001\042\001\
\043\001\044\001\045\001\046\001\047\001\048\001\049\001\050\001\
\051\001\052\001\053\001\054\001\055\001\056\001\104\001\021\001\
\036\001\115\001\035\001\021\001\019\001\115\001\136\001\137\001\
\007\000\115\001\140\001\115\001\115\001\115\001\002\000\127\001\
\181\002\250\000\157\000\086\003\090\002\088\003\140\001\090\003\
\148\001\051\003\140\003\094\003\095\003\015\003\136\001\137\001\
\132\000\029\001\012\002\171\001\130\002\075\002\147\001\141\002\
\239\000\147\001\014\001\179\001\110\002\017\001\018\001\019\001\
\179\001\021\001\022\001\023\001\147\001\025\001\190\001\155\002\
\000\000\029\001\030\001\031\001\147\002\011\003\034\001\035\001\
\036\001\037\001\038\001\039\001\040\001\041\001\042\001\043\001\
\044\001\045\001\046\001\047\001\048\001\049\001\050\001\051\001\
\052\001\053\001\054\001\055\001\056\001\057\001\058\001\059\001\
\060\001\061\001\190\001\063\001\064\001\065\001\066\001\067\001\
\068\001\069\001\070\001\071\001\072\001\073\001\074\001\075\001\
\076\001\077\001\078\001\079\001\080\001\081\001\195\000\111\001\
\233\002\077\002\042\001\043\001\044\001\045\001\046\001\047\001\
\048\001\049\001\050\001\051\001\052\001\053\001\054\001\055\001\
\056\001\101\001\214\002\103\001\104\001\137\001\106\001\107\001\
\192\002\127\003\126\003\111\001\168\000\168\000\255\255\115\001\
\039\001\040\001\041\001\042\001\043\001\044\001\045\001\046\001\
\047\001\048\001\049\001\050\001\051\001\052\001\053\001\054\001\
\055\001\056\001\134\001\135\001\136\001\137\001\255\255\255\255\
\140\001\255\255\255\255\255\255\255\255\255\255\255\255\147\001\
\255\255\141\002\255\255\005\001\006\001\007\001\008\001\000\000\
\255\255\255\255\255\255\151\002\014\001\255\255\255\255\017\001\
\018\001\019\001\020\001\021\001\022\001\023\001\024\001\025\001\
\026\001\027\001\028\001\029\001\030\001\031\001\255\255\033\001\
\034\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\042\001\043\001\044\001\045\001\046\001\047\001\048\001\049\001\
\050\001\051\001\052\001\053\001\054\001\055\001\056\001\057\001\
\058\001\059\001\060\001\061\001\255\255\063\001\064\001\065\001\
\066\001\067\001\068\001\069\001\070\001\071\001\072\001\073\001\
\074\001\075\001\076\001\077\001\078\001\079\001\080\001\081\001\
\255\255\255\255\084\001\255\255\255\255\255\255\255\255\255\255\
\090\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\099\001\255\255\101\001\102\001\103\001\104\001\255\255\
\106\001\107\001\108\001\255\255\255\255\255\255\255\255\255\255\
\255\255\115\001\255\255\117\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\129\001\
\255\255\131\001\255\255\133\001\134\001\135\001\136\001\137\001\
\255\255\255\255\000\000\255\255\142\001\005\001\006\001\007\001\
\008\001\147\001\255\255\255\255\255\255\255\255\014\001\255\255\
\255\255\017\001\018\001\019\001\020\001\021\001\022\001\023\001\
\024\001\025\001\026\001\027\001\028\001\029\001\030\001\031\001\
\255\255\033\001\034\001\035\001\036\001\037\001\038\001\039\001\
\040\001\041\001\042\001\043\001\044\001\045\001\046\001\047\001\
\048\001\049\001\050\001\051\001\052\001\053\001\054\001\055\001\
\056\001\057\001\058\001\059\001\060\001\061\001\255\255\063\001\
\064\001\065\001\066\001\067\001\068\001\069\001\070\001\071\001\
\072\001\073\001\074\001\075\001\076\001\077\001\078\001\079\001\
\080\001\081\001\255\255\255\255\084\001\255\255\255\255\255\255\
\255\255\255\255\090\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\099\001\255\255\101\001\102\001\103\001\
\104\001\255\255\106\001\107\001\108\001\255\255\255\255\255\255\
\255\255\255\255\255\255\115\001\255\255\117\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\129\001\255\255\131\001\255\255\133\001\134\001\135\001\
\136\001\137\001\000\000\255\255\255\255\014\001\142\001\255\255\
\017\001\018\001\019\001\147\001\021\001\022\001\023\001\255\255\
\025\001\255\255\255\255\255\255\029\001\030\001\031\001\255\255\
\255\255\034\001\035\001\036\001\037\001\038\001\039\001\040\001\
\041\001\042\001\043\001\044\001\045\001\046\001\047\001\048\001\
\049\001\050\001\051\001\052\001\053\001\054\001\055\001\056\001\
\057\001\058\001\059\001\060\001\061\001\255\255\063\001\064\001\
\065\001\066\001\067\001\068\001\069\001\070\001\071\001\072\001\
\073\001\074\001\075\001\076\001\077\001\078\001\079\001\080\001\
\081\001\040\001\041\001\042\001\043\001\044\001\045\001\046\001\
\047\001\048\001\049\001\050\001\051\001\052\001\053\001\054\001\
\055\001\056\001\255\255\000\000\101\001\255\255\103\001\104\001\
\255\255\106\001\107\001\255\255\255\255\255\255\111\001\255\255\
\255\255\255\255\115\001\044\001\045\001\046\001\047\001\048\001\
\049\001\050\001\051\001\052\001\053\001\054\001\055\001\056\001\
\255\255\255\255\255\255\255\255\255\255\134\001\135\001\136\001\
\137\001\255\255\255\255\140\001\000\000\255\255\255\255\255\255\
\014\001\255\255\147\001\017\001\018\001\019\001\255\255\021\001\
\022\001\023\001\255\255\025\001\255\255\255\255\255\255\029\001\
\030\001\031\001\255\255\255\255\034\001\035\001\036\001\037\001\
\038\001\039\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001\047\001\048\001\049\001\050\001\051\001\052\001\053\001\
\054\001\055\001\056\001\057\001\058\001\059\001\060\001\061\001\
\255\255\063\001\064\001\065\001\066\001\067\001\068\001\069\001\
\070\001\071\001\072\001\073\001\074\001\075\001\076\001\077\001\
\078\001\079\001\080\001\081\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\000\000\255\255\255\255\255\255\255\255\101\001\
\255\255\103\001\104\001\255\255\106\001\107\001\255\255\255\255\
\255\255\111\001\255\255\255\255\255\255\115\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\134\001\135\001\136\001\137\001\255\255\255\255\140\001\000\000\
\255\255\255\255\255\255\255\255\255\255\147\001\255\255\255\255\
\014\001\255\255\255\255\017\001\018\001\019\001\255\255\021\001\
\022\001\023\001\255\255\025\001\255\255\255\255\255\255\029\001\
\030\001\031\001\255\255\255\255\034\001\035\001\036\001\037\001\
\038\001\039\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001\047\001\048\001\049\001\050\001\051\001\052\001\053\001\
\054\001\055\001\056\001\057\001\058\001\059\001\060\001\061\001\
\255\255\063\001\064\001\065\001\066\001\067\001\068\001\069\001\
\070\001\071\001\072\001\073\001\074\001\075\001\076\001\077\001\
\078\001\079\001\080\001\081\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\000\000\
\255\255\014\001\255\255\255\255\255\255\018\001\255\255\101\001\
\255\255\103\001\104\001\255\255\106\001\107\001\019\001\255\255\
\021\001\111\001\023\001\255\255\025\001\115\001\035\001\255\255\
\255\255\255\255\031\001\255\255\041\001\034\001\035\001\036\001\
\037\001\038\001\039\001\040\001\041\001\255\255\000\000\052\001\
\134\001\135\001\136\001\137\001\008\001\255\255\140\001\255\255\
\255\255\255\255\255\255\255\255\255\255\147\001\018\001\019\001\
\255\255\021\001\022\001\023\001\024\001\025\001\026\001\027\001\
\028\001\029\001\030\001\031\001\255\255\255\255\034\001\035\001\
\036\001\037\001\038\001\039\001\040\001\041\001\042\001\043\001\
\044\001\045\001\046\001\047\001\048\001\049\001\050\001\051\001\
\052\001\053\001\054\001\055\001\056\001\255\255\255\255\108\001\
\255\255\255\255\111\001\104\001\255\255\255\255\255\255\255\255\
\117\001\255\255\255\255\255\255\255\255\255\255\115\001\255\255\
\255\255\255\255\255\255\255\255\129\001\255\255\131\001\255\255\
\133\001\255\255\255\255\255\255\000\000\255\255\255\255\140\001\
\255\255\255\255\255\255\136\001\137\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\104\001\019\001\147\001\021\001\
\014\001\023\001\255\255\025\001\018\001\019\001\255\255\115\001\
\022\001\031\001\255\255\025\001\034\001\035\001\036\001\037\001\
\038\001\039\001\040\001\255\255\255\255\000\000\036\001\255\255\
\255\255\255\255\255\255\041\001\136\001\137\001\255\255\008\001\
\255\255\141\001\255\255\255\255\255\255\255\255\052\001\147\001\
\255\255\018\001\019\001\255\255\021\001\022\001\023\001\024\001\
\025\001\026\001\027\001\028\001\029\001\030\001\031\001\255\255\
\255\255\034\001\035\001\036\001\037\001\038\001\039\001\040\001\
\041\001\042\001\043\001\044\001\045\001\046\001\047\001\048\001\
\049\001\050\001\051\001\052\001\053\001\054\001\055\001\056\001\
\255\255\255\255\104\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\104\001\255\255\255\255\115\001\255\255\255\255\
\255\255\111\001\255\255\255\255\255\255\115\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\136\001\137\001\255\255\255\255\255\255\255\255\
\255\255\255\255\136\001\137\001\255\255\147\001\140\001\104\001\
\255\255\255\255\019\001\255\255\021\001\147\001\023\001\255\255\
\025\001\255\255\115\001\255\255\000\000\255\255\031\001\255\255\
\255\255\034\001\035\001\036\001\037\001\038\001\039\001\040\001\
\041\001\042\001\043\001\044\001\045\001\046\001\047\001\136\001\
\137\001\255\255\255\255\255\255\141\001\255\255\255\255\255\255\
\018\001\019\001\147\001\021\001\022\001\023\001\024\001\025\001\
\026\001\027\001\028\001\029\001\030\001\031\001\000\000\255\255\
\034\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\042\001\043\001\044\001\045\001\046\001\047\001\048\001\049\001\
\050\001\051\001\052\001\053\001\054\001\055\001\056\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\104\001\
\255\255\255\255\255\255\255\255\255\255\031\001\255\255\255\255\
\255\255\255\255\115\001\037\001\038\001\039\001\040\001\041\001\
\042\001\043\001\044\001\045\001\046\001\047\001\048\001\049\001\
\050\001\051\001\052\001\053\001\054\001\055\001\056\001\136\001\
\137\001\255\255\255\255\255\255\255\255\255\255\104\001\019\001\
\255\255\021\001\147\001\023\001\255\255\025\001\255\255\255\255\
\255\255\115\001\255\255\031\001\255\255\255\255\034\001\035\001\
\036\001\037\001\038\001\039\001\040\001\041\001\042\001\043\001\
\044\001\045\001\046\001\047\001\048\001\049\001\136\001\137\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\018\001\
\019\001\147\001\021\001\022\001\023\001\024\001\025\001\026\001\
\027\001\028\001\029\001\030\001\031\001\000\000\255\255\034\001\
\035\001\036\001\037\001\038\001\039\001\040\001\041\001\042\001\
\043\001\044\001\045\001\046\001\047\001\048\001\049\001\050\001\
\051\001\052\001\053\001\054\001\055\001\056\001\255\255\255\255\
\255\255\255\255\255\255\255\255\104\001\255\255\255\255\255\255\
\255\255\255\255\255\255\000\000\255\255\255\255\255\255\115\001\
\042\001\043\001\044\001\045\001\046\001\047\001\048\001\049\001\
\050\001\051\001\052\001\053\001\054\001\055\001\056\001\057\001\
\058\001\059\001\060\001\061\001\136\001\137\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\104\001\255\255\147\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\115\001\038\001\039\001\040\001\041\001\042\001\043\001\044\001\
\045\001\046\001\047\001\048\001\049\001\050\001\051\001\052\001\
\053\001\054\001\055\001\056\001\255\255\136\001\137\001\019\001\
\255\255\021\001\255\255\023\001\255\255\025\001\255\255\255\255\
\147\001\029\001\030\001\031\001\255\255\000\000\034\001\035\001\
\036\001\037\001\038\001\039\001\040\001\041\001\042\001\043\001\
\044\001\045\001\046\001\047\001\048\001\049\001\050\001\051\001\
\052\001\053\001\054\001\055\001\056\001\255\255\255\255\255\255\
\255\255\019\001\255\255\021\001\255\255\023\001\000\000\025\001\
\255\255\255\255\255\255\029\001\030\001\031\001\255\255\255\255\
\034\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\042\001\043\001\044\001\045\001\046\001\047\001\048\001\049\001\
\050\001\051\001\052\001\053\001\054\001\055\001\056\001\255\255\
\255\255\255\255\255\255\255\255\104\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\115\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\136\001\137\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\104\001\147\001\
\255\255\255\255\255\255\255\255\000\000\255\255\255\255\255\255\
\255\255\115\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\136\001\137\001\
\255\255\255\255\255\255\255\255\255\255\255\255\000\000\255\255\
\019\001\147\001\021\001\255\255\023\001\255\255\025\001\255\255\
\255\255\255\255\029\001\030\001\031\001\255\255\255\255\034\001\
\035\001\036\001\037\001\038\001\039\001\040\001\041\001\042\001\
\043\001\044\001\045\001\046\001\047\001\048\001\049\001\050\001\
\051\001\052\001\053\001\054\001\055\001\056\001\019\001\255\255\
\021\001\255\255\023\001\255\255\025\001\255\255\000\000\255\255\
\029\001\030\001\031\001\255\255\255\255\034\001\035\001\036\001\
\037\001\038\001\039\001\040\001\041\001\042\001\043\001\044\001\
\045\001\046\001\047\001\048\001\049\001\050\001\051\001\052\001\
\053\001\054\001\055\001\056\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\000\000\104\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\115\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\136\001\137\001\255\255\
\019\001\255\255\021\001\104\001\023\001\255\255\025\001\255\255\
\147\001\255\255\255\255\255\255\031\001\000\000\115\001\034\001\
\035\001\036\001\037\001\038\001\039\001\040\001\041\001\042\001\
\043\001\044\001\045\001\046\001\047\001\048\001\049\001\050\001\
\051\001\019\001\255\255\136\001\137\001\023\001\255\255\025\001\
\255\255\255\255\255\255\255\255\255\255\031\001\147\001\255\255\
\255\255\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\042\001\043\001\044\001\045\001\046\001\047\001\048\001\049\001\
\050\001\051\001\052\001\053\001\054\001\055\001\056\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\000\000\104\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\115\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\136\001\137\001\019\001\
\255\255\021\001\255\255\023\001\255\255\025\001\255\255\255\255\
\147\001\115\001\255\255\031\001\000\000\255\255\034\001\035\001\
\036\001\037\001\038\001\039\001\040\001\041\001\042\001\043\001\
\044\001\045\001\046\001\047\001\048\001\049\001\050\001\051\001\
\255\255\019\001\255\255\021\001\255\255\023\001\000\000\025\001\
\255\255\147\001\255\255\255\255\255\255\031\001\255\255\255\255\
\034\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\042\001\043\001\044\001\045\001\046\001\047\001\048\001\049\001\
\255\255\255\255\255\255\255\255\000\000\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\019\001\255\255\021\001\104\001\023\001\255\255\025\001\
\255\255\255\255\255\255\255\255\255\255\031\001\255\255\115\001\
\034\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\042\001\043\001\044\001\045\001\046\001\047\001\255\255\255\255\
\255\255\255\255\255\255\255\255\136\001\137\001\104\001\019\001\
\255\255\021\001\255\255\023\001\255\255\025\001\014\001\147\001\
\255\255\115\001\018\001\031\001\255\255\255\255\034\001\035\001\
\036\001\037\001\038\001\039\001\040\001\041\001\042\001\043\001\
\044\001\045\001\046\001\047\001\255\255\255\255\136\001\137\001\
\255\255\041\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\147\001\255\255\255\255\052\001\255\255\104\001\255\255\
\019\001\255\255\021\001\255\255\023\001\255\255\025\001\255\255\
\255\255\115\001\255\255\255\255\031\001\000\000\255\255\034\001\
\035\001\036\001\037\001\038\001\039\001\040\001\041\001\042\001\
\043\001\044\001\045\001\046\001\047\001\255\255\136\001\137\001\
\255\255\255\255\255\255\255\255\104\001\255\255\255\255\255\255\
\255\255\147\001\255\255\255\255\255\255\255\255\255\255\115\001\
\104\001\255\255\255\255\255\255\255\255\255\255\255\255\111\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\136\001\137\001\255\255\019\001\
\255\255\021\001\255\255\023\001\255\255\025\001\255\255\147\001\
\136\001\137\001\255\255\031\001\140\001\104\001\034\001\035\001\
\036\001\037\001\038\001\039\001\040\001\041\001\042\001\043\001\
\115\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\136\001\137\001\019\001\
\255\255\021\001\255\255\023\001\255\255\025\001\255\255\255\255\
\147\001\255\255\255\255\031\001\255\255\255\255\034\001\035\001\
\036\001\037\001\038\001\039\001\040\001\041\001\042\001\043\001\
\000\000\019\001\000\000\021\001\255\255\023\001\255\255\025\001\
\255\255\000\000\255\255\255\255\104\001\031\001\255\255\255\255\
\034\001\035\001\036\001\037\001\038\001\039\001\255\255\115\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\019\001\
\255\255\021\001\255\255\023\001\255\255\025\001\255\255\255\255\
\255\255\255\255\255\255\031\001\136\001\137\001\034\001\035\001\
\036\001\037\001\038\001\255\255\255\255\255\255\255\255\147\001\
\255\255\255\255\255\255\255\255\104\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\115\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\104\001\255\255\
\255\255\255\255\255\255\000\000\136\001\137\001\255\255\255\255\
\255\255\115\001\255\255\255\255\255\255\255\255\255\255\147\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\104\001\255\255\136\001\137\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\115\001\
\255\255\147\001\005\001\006\001\007\001\008\001\009\001\255\255\
\255\255\255\255\013\001\014\001\255\255\016\001\017\001\018\001\
\255\255\020\001\021\001\255\255\136\001\137\001\255\255\255\255\
\027\001\028\001\255\255\255\255\255\255\032\001\033\001\147\001\
\255\255\036\001\255\255\038\001\255\255\255\255\041\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\050\001\
\051\001\052\001\255\255\255\255\255\255\255\255\057\001\058\001\
\059\001\060\001\061\001\062\001\063\001\064\001\065\001\066\001\
\067\001\068\001\069\001\070\001\071\001\072\001\073\001\074\001\
\075\001\076\001\077\001\078\001\079\001\080\001\081\001\082\001\
\083\001\255\255\085\001\086\001\087\001\088\001\089\001\090\001\
\091\001\092\001\093\001\094\001\095\001\096\001\097\001\098\001\
\255\255\255\255\101\001\102\001\103\001\104\001\255\255\106\001\
\107\001\108\001\255\255\255\255\111\001\255\255\255\255\255\255\
\115\001\255\255\117\001\255\255\119\001\120\001\121\001\122\001\
\123\001\124\001\125\001\126\001\255\255\128\001\129\001\255\255\
\131\001\255\255\133\001\134\001\135\001\136\001\137\001\138\001\
\139\001\140\001\141\001\142\001\255\255\144\001\014\001\255\255\
\014\001\255\255\018\001\019\001\018\001\019\001\022\001\255\255\
\022\001\016\001\017\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\035\001\036\001\035\001\036\001\255\255\
\255\255\041\001\255\255\041\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\052\001\255\255\052\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\057\001\058\001\059\001\060\001\061\001\255\255\
\063\001\064\001\065\001\066\001\067\001\068\001\069\001\070\001\
\071\001\072\001\073\001\074\001\075\001\076\001\077\001\078\001\
\079\001\080\001\081\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\104\001\014\001\104\001\016\001\017\001\100\001\101\001\111\001\
\103\001\111\001\255\255\106\001\107\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\036\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\136\001\137\001\136\001\137\001\140\001\255\255\140\001\134\001\
\135\001\255\255\255\255\255\255\057\001\058\001\059\001\060\001\
\061\001\062\001\063\001\064\001\065\001\066\001\067\001\068\001\
\069\001\070\001\071\001\072\001\073\001\074\001\075\001\076\001\
\077\001\078\001\079\001\080\001\081\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\100\001\
\101\001\102\001\103\001\255\255\255\255\106\001\107\001\108\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\117\001\255\255\119\001\120\001\121\001\122\001\123\001\124\001\
\125\001\255\255\255\255\255\255\129\001\255\255\131\001\255\255\
\133\001\134\001\135\001\005\001\006\001\007\001\008\001\009\001\
\255\255\255\255\255\255\013\001\014\001\015\001\255\255\017\001\
\018\001\019\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\027\001\028\001\255\255\255\255\255\255\032\001\033\001\
\255\255\255\255\255\255\255\255\038\001\255\255\255\255\041\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\050\001\051\001\052\001\255\255\255\255\255\255\255\255\057\001\
\058\001\059\001\060\001\061\001\255\255\063\001\064\001\065\001\
\066\001\067\001\068\001\069\001\070\001\071\001\072\001\073\001\
\074\001\075\001\076\001\077\001\078\001\079\001\080\001\081\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\095\001\096\001\097\001\
\098\001\255\255\255\255\101\001\255\255\103\001\255\255\255\255\
\106\001\107\001\255\255\255\255\255\255\111\001\255\255\255\255\
\255\255\255\255\005\001\006\001\007\001\008\001\009\001\255\255\
\255\255\255\255\013\001\014\001\015\001\255\255\017\001\018\001\
\019\001\255\255\255\255\255\255\134\001\135\001\255\255\255\255\
\027\001\028\001\140\001\141\001\255\255\032\001\033\001\255\255\
\255\255\255\255\148\001\038\001\255\255\255\255\041\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\050\001\
\051\001\052\001\255\255\255\255\255\255\255\255\057\001\058\001\
\059\001\060\001\061\001\255\255\063\001\064\001\065\001\066\001\
\067\001\068\001\069\001\070\001\071\001\072\001\073\001\074\001\
\075\001\076\001\077\001\078\001\079\001\080\001\081\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\095\001\096\001\097\001\098\001\
\255\255\255\255\101\001\255\255\103\001\255\255\255\255\106\001\
\107\001\255\255\255\255\255\255\111\001\255\255\255\255\255\255\
\255\255\005\001\006\001\007\001\008\001\009\001\255\255\255\255\
\255\255\013\001\014\001\015\001\255\255\017\001\018\001\019\001\
\255\255\255\255\255\255\134\001\135\001\255\255\255\255\027\001\
\028\001\140\001\141\001\255\255\032\001\033\001\255\255\255\255\
\255\255\148\001\038\001\255\255\255\255\041\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\050\001\051\001\
\052\001\255\255\255\255\255\255\255\255\057\001\058\001\059\001\
\060\001\061\001\255\255\063\001\064\001\065\001\066\001\067\001\
\068\001\069\001\070\001\071\001\072\001\073\001\074\001\075\001\
\076\001\077\001\078\001\079\001\080\001\081\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\095\001\096\001\097\001\098\001\255\255\
\255\255\101\001\255\255\103\001\255\255\255\255\106\001\107\001\
\255\255\255\255\255\255\111\001\255\255\255\255\255\255\255\255\
\005\001\006\001\007\001\008\001\009\001\255\255\255\255\255\255\
\013\001\014\001\015\001\255\255\017\001\018\001\019\001\255\255\
\255\255\255\255\134\001\135\001\255\255\255\255\027\001\028\001\
\140\001\141\001\255\255\032\001\033\001\255\255\255\255\255\255\
\148\001\038\001\255\255\255\255\041\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\050\001\051\001\052\001\
\255\255\255\255\255\255\255\255\057\001\058\001\059\001\060\001\
\061\001\255\255\063\001\064\001\065\001\066\001\067\001\068\001\
\069\001\070\001\071\001\072\001\073\001\074\001\075\001\076\001\
\077\001\078\001\079\001\080\001\081\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\095\001\096\001\097\001\098\001\255\255\255\255\
\101\001\255\255\103\001\255\255\255\255\106\001\107\001\255\255\
\255\255\255\255\111\001\255\255\255\255\255\255\255\255\005\001\
\006\001\007\001\008\001\009\001\255\255\255\255\255\255\013\001\
\014\001\015\001\255\255\017\001\018\001\255\255\255\255\255\255\
\255\255\134\001\135\001\255\255\255\255\027\001\028\001\140\001\
\141\001\255\255\032\001\033\001\255\255\255\255\255\255\148\001\
\038\001\255\255\255\255\041\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\050\001\051\001\052\001\255\255\
\255\255\255\255\255\255\057\001\058\001\059\001\060\001\061\001\
\255\255\063\001\064\001\065\001\066\001\067\001\068\001\069\001\
\070\001\071\001\072\001\073\001\074\001\075\001\076\001\077\001\
\078\001\079\001\080\001\081\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\095\001\096\001\097\001\098\001\255\255\255\255\101\001\
\255\255\103\001\255\255\255\255\106\001\107\001\255\255\255\255\
\255\255\111\001\255\255\255\255\255\255\255\255\005\001\006\001\
\007\001\008\001\009\001\255\255\255\255\255\255\013\001\014\001\
\015\001\255\255\017\001\018\001\255\255\255\255\255\255\255\255\
\134\001\135\001\255\255\255\255\027\001\028\001\140\001\141\001\
\255\255\032\001\033\001\255\255\255\255\255\255\148\001\038\001\
\255\255\255\255\041\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\050\001\051\001\052\001\255\255\255\255\
\255\255\255\255\057\001\058\001\059\001\060\001\061\001\255\255\
\063\001\064\001\065\001\066\001\067\001\068\001\069\001\070\001\
\071\001\072\001\073\001\074\001\075\001\076\001\077\001\078\001\
\079\001\080\001\081\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\095\001\096\001\097\001\098\001\255\255\255\255\101\001\255\255\
\103\001\255\255\255\255\106\001\107\001\255\255\255\255\255\255\
\111\001\255\255\255\255\255\255\255\255\005\001\006\001\007\001\
\008\001\009\001\255\255\255\255\255\255\013\001\014\001\255\255\
\016\001\017\001\018\001\255\255\020\001\255\255\255\255\134\001\
\135\001\255\255\255\255\027\001\028\001\140\001\141\001\255\255\
\032\001\033\001\255\255\255\255\036\001\148\001\038\001\255\255\
\255\255\041\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\050\001\051\001\052\001\255\255\255\255\255\255\
\255\255\057\001\058\001\059\001\060\001\061\001\062\001\063\001\
\064\001\065\001\066\001\067\001\068\001\069\001\070\001\071\001\
\072\001\073\001\074\001\075\001\076\001\077\001\078\001\079\001\
\080\001\081\001\082\001\083\001\255\255\085\001\086\001\087\001\
\088\001\089\001\090\001\091\001\092\001\093\001\094\001\095\001\
\096\001\097\001\098\001\255\255\255\255\101\001\102\001\103\001\
\104\001\255\255\106\001\107\001\108\001\255\255\255\255\111\001\
\112\001\113\001\255\255\255\255\255\255\117\001\255\255\119\001\
\120\001\121\001\122\001\123\001\124\001\125\001\126\001\255\255\
\255\255\129\001\255\255\131\001\255\255\133\001\134\001\135\001\
\136\001\137\001\138\001\139\001\140\001\141\001\255\255\255\255\
\144\001\005\001\006\001\007\001\008\001\009\001\255\255\255\255\
\255\255\013\001\014\001\255\255\016\001\017\001\018\001\255\255\
\020\001\255\255\255\255\255\255\255\255\255\255\255\255\027\001\
\028\001\255\255\255\255\255\255\032\001\033\001\255\255\255\255\
\036\001\255\255\038\001\255\255\255\255\041\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\050\001\051\001\
\052\001\255\255\255\255\255\255\255\255\057\001\058\001\059\001\
\060\001\061\001\062\001\063\001\064\001\065\001\066\001\067\001\
\068\001\069\001\070\001\071\001\072\001\073\001\074\001\075\001\
\076\001\077\001\078\001\079\001\080\001\081\001\082\001\083\001\
\255\255\085\001\086\001\087\001\088\001\089\001\090\001\091\001\
\092\001\093\001\094\001\095\001\096\001\097\001\098\001\255\255\
\255\255\101\001\102\001\103\001\104\001\255\255\106\001\107\001\
\108\001\255\255\255\255\111\001\255\255\255\255\255\255\115\001\
\255\255\117\001\255\255\119\001\120\001\121\001\122\001\123\001\
\124\001\125\001\126\001\255\255\255\255\129\001\255\255\131\001\
\255\255\133\001\134\001\135\001\136\001\137\001\138\001\139\001\
\140\001\141\001\142\001\255\255\144\001\005\001\006\001\007\001\
\008\001\009\001\255\255\255\255\255\255\013\001\014\001\255\255\
\016\001\017\001\018\001\255\255\020\001\255\255\255\255\255\255\
\255\255\255\255\255\255\027\001\028\001\255\255\255\255\255\255\
\032\001\033\001\255\255\255\255\036\001\255\255\038\001\255\255\
\255\255\041\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\050\001\051\001\052\001\255\255\255\255\255\255\
\255\255\057\001\058\001\059\001\060\001\061\001\062\001\063\001\
\064\001\065\001\066\001\067\001\068\001\069\001\070\001\071\001\
\072\001\073\001\074\001\075\001\076\001\077\001\078\001\079\001\
\080\001\081\001\082\001\083\001\255\255\085\001\086\001\087\001\
\088\001\089\001\090\001\091\001\092\001\093\001\094\001\095\001\
\096\001\097\001\098\001\255\255\255\255\101\001\102\001\103\001\
\104\001\255\255\106\001\107\001\108\001\255\255\255\255\111\001\
\255\255\255\255\255\255\115\001\255\255\117\001\255\255\119\001\
\120\001\121\001\122\001\123\001\124\001\125\001\126\001\255\255\
\255\255\129\001\255\255\131\001\255\255\133\001\134\001\135\001\
\136\001\137\001\138\001\139\001\140\001\141\001\142\001\255\255\
\144\001\005\001\006\001\007\001\008\001\009\001\255\255\255\255\
\255\255\013\001\014\001\255\255\016\001\017\001\018\001\255\255\
\020\001\255\255\255\255\255\255\255\255\255\255\255\255\027\001\
\028\001\255\255\255\255\255\255\032\001\033\001\255\255\255\255\
\036\001\255\255\038\001\255\255\255\255\041\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\050\001\051\001\
\052\001\255\255\255\255\255\255\255\255\057\001\058\001\059\001\
\060\001\061\001\062\001\063\001\064\001\065\001\066\001\067\001\
\068\001\069\001\070\001\071\001\072\001\073\001\074\001\075\001\
\076\001\077\001\078\001\079\001\080\001\081\001\082\001\083\001\
\255\255\085\001\086\001\087\001\088\001\089\001\090\001\091\001\
\092\001\093\001\094\001\095\001\096\001\097\001\098\001\255\255\
\255\255\101\001\102\001\103\001\104\001\255\255\106\001\107\001\
\108\001\255\255\255\255\111\001\255\255\255\255\255\255\115\001\
\255\255\117\001\255\255\119\001\120\001\121\001\122\001\123\001\
\124\001\125\001\126\001\255\255\255\255\129\001\255\255\131\001\
\255\255\133\001\134\001\135\001\136\001\137\001\138\001\139\001\
\140\001\141\001\142\001\255\255\144\001\005\001\006\001\007\001\
\008\001\009\001\255\255\255\255\255\255\013\001\014\001\255\255\
\016\001\017\001\018\001\255\255\020\001\255\255\255\255\255\255\
\255\255\255\255\255\255\027\001\028\001\255\255\255\255\255\255\
\032\001\033\001\255\255\255\255\036\001\255\255\038\001\255\255\
\255\255\041\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\050\001\051\001\052\001\255\255\255\255\255\255\
\255\255\057\001\058\001\059\001\060\001\061\001\062\001\063\001\
\064\001\065\001\066\001\067\001\068\001\069\001\070\001\071\001\
\072\001\073\001\074\001\075\001\076\001\077\001\078\001\079\001\
\080\001\081\001\082\001\083\001\255\255\085\001\086\001\087\001\
\088\001\089\001\090\001\091\001\092\001\093\001\094\001\095\001\
\096\001\097\001\098\001\255\255\255\255\101\001\102\001\103\001\
\104\001\255\255\106\001\107\001\108\001\255\255\255\255\111\001\
\255\255\113\001\255\255\255\255\255\255\117\001\255\255\119\001\
\120\001\121\001\122\001\123\001\124\001\125\001\126\001\255\255\
\255\255\129\001\255\255\131\001\255\255\133\001\134\001\135\001\
\136\001\137\001\138\001\139\001\140\001\141\001\255\255\255\255\
\144\001\005\001\006\001\007\001\008\001\009\001\255\255\255\255\
\255\255\013\001\014\001\255\255\016\001\017\001\018\001\255\255\
\020\001\255\255\255\255\255\255\255\255\255\255\255\255\027\001\
\028\001\255\255\255\255\255\255\032\001\033\001\255\255\255\255\
\036\001\255\255\038\001\255\255\255\255\041\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\050\001\051\001\
\052\001\255\255\255\255\255\255\255\255\057\001\058\001\059\001\
\060\001\061\001\062\001\063\001\064\001\065\001\066\001\067\001\
\068\001\069\001\070\001\071\001\072\001\073\001\074\001\075\001\
\076\001\077\001\078\001\079\001\080\001\081\001\082\001\083\001\
\255\255\085\001\086\001\087\001\088\001\089\001\090\001\091\001\
\092\001\093\001\094\001\095\001\096\001\097\001\098\001\255\255\
\255\255\101\001\102\001\103\001\104\001\255\255\106\001\107\001\
\108\001\255\255\255\255\111\001\255\255\255\255\255\255\255\255\
\255\255\117\001\255\255\119\001\120\001\121\001\122\001\123\001\
\124\001\125\001\126\001\255\255\255\255\129\001\255\255\131\001\
\255\255\133\001\134\001\135\001\136\001\137\001\138\001\139\001\
\140\001\141\001\255\255\255\255\144\001\005\001\006\001\007\001\
\008\001\009\001\255\255\255\255\255\255\013\001\014\001\255\255\
\255\255\017\001\018\001\255\255\020\001\255\255\255\255\255\255\
\255\255\255\255\255\255\027\001\028\001\255\255\255\255\255\255\
\032\001\033\001\255\255\255\255\036\001\255\255\038\001\255\255\
\255\255\041\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\050\001\051\001\052\001\255\255\255\255\255\255\
\255\255\057\001\058\001\059\001\060\001\061\001\062\001\063\001\
\064\001\065\001\066\001\067\001\068\001\069\001\070\001\071\001\
\072\001\073\001\074\001\075\001\076\001\077\001\078\001\079\001\
\080\001\081\001\082\001\083\001\255\255\085\001\086\001\087\001\
\088\001\089\001\090\001\091\001\092\001\093\001\094\001\095\001\
\096\001\097\001\098\001\255\255\255\255\101\001\102\001\103\001\
\104\001\255\255\106\001\107\001\255\255\255\255\255\255\111\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\126\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\134\001\135\001\
\136\001\137\001\138\001\139\001\140\001\141\001\255\255\255\255\
\144\001\005\001\006\001\007\001\008\001\009\001\255\255\255\255\
\255\255\013\001\014\001\255\255\255\255\017\001\018\001\255\255\
\020\001\255\255\255\255\255\255\255\255\255\255\255\255\027\001\
\028\001\255\255\255\255\255\255\032\001\033\001\255\255\255\255\
\036\001\255\255\038\001\255\255\255\255\041\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\050\001\051\001\
\052\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\062\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\082\001\083\001\
\255\255\085\001\086\001\087\001\088\001\089\001\090\001\091\001\
\092\001\093\001\094\001\095\001\096\001\097\001\098\001\255\255\
\255\255\255\255\102\001\255\255\104\001\255\255\255\255\255\255\
\255\255\255\255\255\255\111\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\119\001\005\001\006\001\007\001\008\001\
\009\001\255\255\126\001\255\255\013\001\014\001\255\255\255\255\
\017\001\018\001\255\255\020\001\136\001\137\001\138\001\139\001\
\140\001\141\001\027\001\028\001\144\001\255\255\255\255\032\001\
\033\001\255\255\255\255\036\001\255\255\038\001\255\255\255\255\
\041\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\050\001\051\001\052\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\062\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\082\001\083\001\255\255\085\001\086\001\087\001\088\001\
\089\001\090\001\091\001\092\001\093\001\094\001\095\001\096\001\
\097\001\098\001\255\255\255\255\255\255\102\001\255\255\104\001\
\255\255\255\255\255\255\255\255\255\255\255\255\111\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\005\001\
\006\001\007\001\008\001\009\001\255\255\126\001\255\255\013\001\
\014\001\255\255\255\255\017\001\018\001\255\255\255\255\136\001\
\137\001\138\001\139\001\140\001\141\001\027\001\028\001\144\001\
\255\255\255\255\032\001\033\001\255\255\255\255\036\001\255\255\
\038\001\255\255\255\255\041\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\050\001\051\001\052\001\255\255\
\255\255\255\255\255\255\057\001\058\001\059\001\060\001\061\001\
\255\255\063\001\064\001\065\001\066\001\067\001\068\001\069\001\
\070\001\071\001\072\001\073\001\074\001\075\001\076\001\077\001\
\078\001\079\001\080\001\081\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\095\001\096\001\097\001\098\001\255\255\255\255\101\001\
\255\255\103\001\104\001\255\255\106\001\107\001\255\255\255\255\
\255\255\111\001\255\255\255\255\255\255\255\255\005\001\006\001\
\007\001\008\001\009\001\255\255\255\255\255\255\013\001\014\001\
\255\255\255\255\017\001\018\001\255\255\255\255\255\255\255\255\
\134\001\135\001\136\001\137\001\027\001\028\001\140\001\141\001\
\255\255\032\001\033\001\255\255\255\255\255\255\255\255\038\001\
\255\255\255\255\041\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\050\001\051\001\052\001\255\255\255\255\
\255\255\255\255\057\001\058\001\059\001\060\001\061\001\255\255\
\063\001\064\001\065\001\066\001\067\001\068\001\069\001\070\001\
\255\255\255\255\255\255\255\255\255\255\076\001\077\001\078\001\
\079\001\080\001\081\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\095\001\096\001\097\001\098\001\255\255\255\255\101\001\255\255\
\103\001\255\255\255\255\255\255\107\001\255\255\255\255\255\255\
\111\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\134\001\
\135\001\255\255\255\255\255\255\255\255\140\001\141\001\005\001\
\006\001\007\001\008\001\009\001\255\255\255\255\255\255\013\001\
\014\001\255\255\255\255\017\001\018\001\255\255\020\001\021\001\
\022\001\255\255\024\001\255\255\255\255\027\001\028\001\255\255\
\255\255\255\255\032\001\033\001\255\255\255\255\255\255\255\255\
\038\001\255\255\255\255\041\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\050\001\051\001\052\001\255\255\
\255\255\005\001\006\001\007\001\008\001\009\001\255\255\255\255\
\062\001\013\001\014\001\255\255\255\255\017\001\018\001\255\255\
\020\001\021\001\022\001\255\255\024\001\255\255\255\255\027\001\
\028\001\255\255\255\255\255\255\032\001\033\001\255\255\255\255\
\255\255\255\255\038\001\255\255\255\255\041\001\255\255\255\255\
\255\255\095\001\096\001\097\001\098\001\255\255\050\001\051\001\
\052\001\255\255\255\255\255\255\005\001\006\001\007\001\008\001\
\009\001\111\001\062\001\255\255\013\001\014\001\255\255\255\255\
\017\001\018\001\255\255\020\001\255\255\022\001\255\255\024\001\
\255\255\255\255\027\001\028\001\255\255\255\255\255\255\032\001\
\033\001\255\255\255\255\255\255\255\255\038\001\140\001\141\001\
\041\001\255\255\255\255\095\001\096\001\097\001\098\001\255\255\
\255\255\050\001\051\001\052\001\255\255\255\255\005\001\006\001\
\007\001\008\001\009\001\111\001\255\255\062\001\013\001\014\001\
\255\255\255\255\255\255\018\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\027\001\028\001\255\255\255\255\
\255\255\032\001\033\001\255\255\255\255\036\001\255\255\038\001\
\140\001\141\001\041\001\255\255\255\255\255\255\095\001\096\001\
\097\001\098\001\255\255\050\001\051\001\052\001\255\255\255\255\
\255\255\005\001\006\001\007\001\008\001\009\001\111\001\255\255\
\255\255\013\001\014\001\255\255\255\255\255\255\018\001\255\255\
\020\001\255\255\255\255\255\255\255\255\255\255\255\255\027\001\
\028\001\255\255\255\255\255\255\032\001\033\001\255\255\255\255\
\255\255\255\255\038\001\140\001\141\001\041\001\255\255\255\255\
\095\001\096\001\097\001\098\001\255\255\255\255\050\001\051\001\
\052\001\104\001\255\255\005\001\006\001\007\001\008\001\009\001\
\111\001\255\255\255\255\013\001\014\001\255\255\255\255\255\255\
\018\001\255\255\255\255\255\255\022\001\255\255\255\255\255\255\
\255\255\027\001\028\001\255\255\255\255\255\255\032\001\033\001\
\255\255\136\001\137\001\255\255\038\001\140\001\141\001\041\001\
\255\255\255\255\255\255\095\001\096\001\097\001\098\001\255\255\
\050\001\051\001\052\001\255\255\255\255\255\255\005\001\006\001\
\007\001\008\001\009\001\111\001\255\255\255\255\013\001\014\001\
\255\255\255\255\255\255\018\001\255\255\255\255\255\255\255\255\
\023\001\255\255\255\255\255\255\027\001\028\001\255\255\255\255\
\255\255\032\001\033\001\255\255\255\255\255\255\255\255\038\001\
\140\001\141\001\041\001\255\255\255\255\095\001\096\001\097\001\
\098\001\255\255\255\255\050\001\051\001\052\001\255\255\255\255\
\005\001\006\001\007\001\008\001\009\001\111\001\255\255\255\255\
\013\001\014\001\255\255\255\255\255\255\018\001\255\255\255\255\
\255\255\255\255\023\001\255\255\255\255\255\255\027\001\028\001\
\255\255\255\255\255\255\032\001\033\001\255\255\255\255\255\255\
\255\255\038\001\140\001\141\001\041\001\255\255\255\255\255\255\
\095\001\096\001\097\001\098\001\255\255\050\001\051\001\052\001\
\255\255\255\255\255\255\005\001\006\001\007\001\008\001\009\001\
\111\001\255\255\255\255\013\001\014\001\255\255\255\255\255\255\
\018\001\255\255\020\001\255\255\255\255\255\255\255\255\255\255\
\255\255\027\001\028\001\255\255\255\255\255\255\032\001\033\001\
\255\255\255\255\255\255\255\255\038\001\140\001\141\001\041\001\
\255\255\255\255\095\001\096\001\097\001\098\001\255\255\255\255\
\050\001\051\001\052\001\255\255\255\255\005\001\006\001\007\001\
\008\001\009\001\111\001\255\255\255\255\013\001\014\001\255\255\
\255\255\255\255\018\001\255\255\020\001\255\255\255\255\255\255\
\255\255\255\255\255\255\027\001\028\001\255\255\255\255\255\255\
\032\001\033\001\255\255\255\255\255\255\255\255\038\001\140\001\
\141\001\041\001\255\255\255\255\255\255\095\001\096\001\097\001\
\098\001\255\255\050\001\051\001\052\001\255\255\255\255\255\255\
\005\001\006\001\007\001\008\001\009\001\111\001\255\255\255\255\
\013\001\014\001\255\255\255\255\255\255\018\001\255\255\255\255\
\255\255\255\255\023\001\255\255\255\255\255\255\027\001\028\001\
\255\255\255\255\255\255\032\001\033\001\255\255\255\255\255\255\
\255\255\038\001\140\001\141\001\041\001\255\255\255\255\095\001\
\096\001\097\001\098\001\255\255\255\255\050\001\051\001\052\001\
\255\255\255\255\005\001\006\001\007\001\008\001\009\001\111\001\
\255\255\255\255\013\001\014\001\255\255\255\255\255\255\018\001\
\019\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\027\001\028\001\255\255\255\255\255\255\032\001\033\001\255\255\
\255\255\255\255\255\255\038\001\140\001\141\001\041\001\255\255\
\255\255\255\255\095\001\096\001\097\001\098\001\255\255\050\001\
\051\001\052\001\255\255\255\255\255\255\005\001\006\001\007\001\
\008\001\009\001\111\001\255\255\255\255\013\001\014\001\255\255\
\255\255\255\255\018\001\019\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\027\001\028\001\255\255\255\255\255\255\
\032\001\033\001\255\255\255\255\255\255\255\255\038\001\140\001\
\141\001\041\001\255\255\255\255\095\001\096\001\097\001\098\001\
\255\255\255\255\050\001\051\001\052\001\255\255\255\255\005\001\
\006\001\007\001\008\001\009\001\111\001\255\255\255\255\013\001\
\014\001\255\255\255\255\255\255\018\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\027\001\028\001\255\255\
\255\255\255\255\032\001\033\001\255\255\255\255\255\255\255\255\
\038\001\140\001\141\001\041\001\255\255\255\255\255\255\095\001\
\096\001\097\001\098\001\255\255\050\001\051\001\052\001\255\255\
\014\001\255\255\255\255\017\001\018\001\019\001\020\001\111\001\
\014\001\255\255\255\255\025\001\018\001\019\001\255\255\255\255\
\022\001\255\255\255\255\025\001\255\255\035\001\036\001\255\255\
\255\255\255\255\255\255\041\001\255\255\255\255\036\001\255\255\
\255\255\255\255\255\255\041\001\140\001\141\001\052\001\255\255\
\255\255\095\001\096\001\097\001\098\001\014\001\052\001\014\001\
\062\001\018\001\019\001\018\001\019\001\022\001\255\255\022\001\
\025\001\111\001\025\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\036\001\255\255\036\001\255\255\255\255\
\041\001\255\255\041\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\052\001\255\255\052\001\140\001\141\001\
\255\255\255\255\104\001\014\001\255\255\255\255\255\255\018\001\
\019\001\111\001\104\001\022\001\255\255\255\255\025\001\255\255\
\255\255\111\001\255\255\255\255\255\255\115\001\255\255\255\255\
\255\255\036\001\255\255\255\255\255\255\255\255\041\001\255\255\
\255\255\255\255\136\001\137\001\255\255\255\255\140\001\255\255\
\255\255\052\001\136\001\137\001\255\255\147\001\140\001\104\001\
\255\255\104\001\255\255\255\255\255\255\147\001\111\001\255\255\
\111\001\255\255\115\001\255\255\115\001\255\255\255\255\255\255\
\014\001\255\255\255\255\255\255\018\001\019\001\255\255\255\255\
\022\001\255\255\255\255\025\001\255\255\255\255\255\255\136\001\
\137\001\136\001\137\001\140\001\255\255\140\001\036\001\255\255\
\255\255\255\255\147\001\041\001\147\001\104\001\255\255\255\255\
\255\255\255\255\255\255\255\255\111\001\014\001\052\001\255\255\
\115\001\018\001\019\001\255\255\255\255\022\001\014\001\255\255\
\025\001\255\255\018\001\019\001\255\255\255\255\022\001\255\255\
\255\255\025\001\255\255\036\001\255\255\136\001\137\001\255\255\
\041\001\140\001\255\255\255\255\036\001\255\255\255\255\255\255\
\147\001\041\001\255\255\052\001\255\255\014\001\255\255\255\255\
\255\255\018\001\019\001\255\255\052\001\022\001\255\255\255\255\
\025\001\255\255\104\001\255\255\255\255\255\255\255\255\255\255\
\255\255\111\001\255\255\036\001\255\255\115\001\255\255\255\255\
\041\001\255\255\255\255\255\255\014\001\255\255\255\255\255\255\
\018\001\019\001\255\255\052\001\022\001\255\255\255\255\025\001\
\255\255\255\255\136\001\137\001\255\255\255\255\140\001\104\001\
\255\255\255\255\036\001\255\255\255\255\147\001\111\001\041\001\
\104\001\255\255\115\001\255\255\255\255\255\255\255\255\111\001\
\255\255\255\255\052\001\115\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\136\001\
\137\001\255\255\255\255\140\001\255\255\255\255\255\255\104\001\
\136\001\137\001\147\001\255\255\140\001\255\255\111\001\255\255\
\255\255\255\255\115\001\147\001\255\255\014\001\255\255\255\255\
\255\255\018\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\104\001\136\001\
\137\001\255\255\255\255\140\001\017\001\111\001\019\001\020\001\
\041\001\115\001\147\001\255\255\025\001\255\255\255\255\255\255\
\255\255\030\001\255\255\052\001\255\255\255\255\035\001\036\001\
\255\255\255\255\255\255\255\255\255\255\255\255\136\001\137\001\
\255\255\255\255\140\001\255\255\255\255\255\255\255\255\255\255\
\255\255\147\001\255\255\255\255\057\001\058\001\059\001\060\001\
\061\001\255\255\063\001\064\001\065\001\066\001\067\001\068\001\
\069\001\070\001\071\001\072\001\073\001\074\001\075\001\076\001\
\077\001\078\001\079\001\080\001\081\001\255\255\103\001\255\255\
\255\255\255\255\255\255\108\001\255\255\255\255\111\001\255\255\
\255\255\255\255\255\255\255\255\117\001\255\255\099\001\255\255\
\101\001\102\001\103\001\104\001\255\255\106\001\107\001\108\001\
\129\001\255\255\131\001\255\255\133\001\134\001\135\001\255\255\
\117\001\255\255\255\255\140\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\129\001\255\255\131\001\255\255\
\133\001\134\001\135\001\136\001\137\001\017\001\255\255\019\001\
\020\001\142\001\255\255\255\255\255\255\025\001\147\001\255\255\
\255\255\255\255\030\001\255\255\255\255\255\255\255\255\035\001\
\036\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\057\001\058\001\059\001\
\060\001\061\001\255\255\063\001\064\001\065\001\066\001\067\001\
\068\001\069\001\070\001\071\001\072\001\073\001\074\001\075\001\
\076\001\077\001\078\001\079\001\080\001\081\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\099\001\
\255\255\101\001\102\001\103\001\104\001\255\255\106\001\107\001\
\108\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\014\001\117\001\255\255\017\001\018\001\255\255\255\255\255\255\
\022\001\255\255\255\255\255\255\255\255\129\001\255\255\131\001\
\255\255\133\001\134\001\135\001\136\001\137\001\036\001\255\255\
\255\255\255\255\142\001\041\001\255\255\255\255\255\255\147\001\
\255\255\255\255\255\255\255\255\255\255\255\255\052\001\255\255\
\255\255\255\255\255\255\057\001\058\001\059\001\060\001\061\001\
\255\255\063\001\064\001\065\001\066\001\067\001\068\001\069\001\
\070\001\071\001\072\001\073\001\074\001\075\001\076\001\077\001\
\078\001\079\001\080\001\081\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\101\001\
\014\001\103\001\104\001\017\001\106\001\107\001\255\255\255\255\
\255\255\111\001\255\255\255\255\255\255\115\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\036\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\134\001\135\001\136\001\137\001\255\255\255\255\140\001\255\255\
\142\001\255\255\255\255\057\001\058\001\059\001\060\001\061\001\
\062\001\063\001\064\001\065\001\066\001\067\001\068\001\069\001\
\070\001\255\255\255\255\255\255\255\255\255\255\076\001\077\001\
\078\001\079\001\080\001\081\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\101\001\
\255\255\103\001\255\255\255\255\255\255\107\001\108\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\117\001\
\255\255\119\001\120\001\121\001\122\001\123\001\124\001\125\001\
\255\255\255\255\255\255\129\001\255\255\131\001\255\255\133\001\
\134\001\135\001\014\001\255\255\255\255\017\001\018\001\255\255\
\142\001\255\255\022\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\035\001\
\036\001\255\255\255\255\255\255\255\255\041\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\052\001\255\255\255\255\255\255\255\255\057\001\058\001\059\001\
\060\001\061\001\255\255\063\001\064\001\065\001\066\001\067\001\
\068\001\069\001\070\001\071\001\072\001\073\001\074\001\075\001\
\076\001\077\001\078\001\079\001\080\001\081\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\101\001\255\255\103\001\104\001\017\001\106\001\107\001\
\020\001\255\255\255\255\111\001\255\255\025\001\255\255\115\001\
\255\255\255\255\030\001\255\255\255\255\255\255\255\255\255\255\
\036\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\134\001\135\001\136\001\137\001\255\255\255\255\
\140\001\255\255\255\255\255\255\255\255\057\001\058\001\059\001\
\060\001\061\001\255\255\063\001\064\001\065\001\066\001\067\001\
\068\001\069\001\070\001\071\001\072\001\073\001\074\001\075\001\
\076\001\077\001\078\001\079\001\080\001\081\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\017\001\255\255\099\001\
\020\001\101\001\255\255\103\001\255\255\025\001\106\001\107\001\
\108\001\255\255\030\001\255\255\255\255\255\255\255\255\255\255\
\036\001\117\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\129\001\255\255\131\001\
\255\255\133\001\134\001\135\001\255\255\057\001\058\001\059\001\
\060\001\061\001\142\001\063\001\064\001\065\001\066\001\067\001\
\068\001\069\001\070\001\071\001\072\001\073\001\074\001\075\001\
\076\001\077\001\078\001\079\001\080\001\081\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\017\001\255\255\099\001\
\020\001\101\001\255\255\103\001\255\255\025\001\106\001\107\001\
\108\001\255\255\030\001\255\255\255\255\255\255\255\255\255\255\
\036\001\117\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\129\001\255\255\131\001\
\255\255\133\001\134\001\135\001\255\255\057\001\058\001\059\001\
\060\001\061\001\142\001\063\001\064\001\065\001\066\001\067\001\
\068\001\069\001\070\001\071\001\072\001\073\001\074\001\075\001\
\076\001\077\001\078\001\079\001\080\001\081\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\099\001\
\255\255\101\001\255\255\103\001\255\255\255\255\106\001\107\001\
\108\001\015\001\255\255\017\001\255\255\019\001\255\255\255\255\
\255\255\117\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\129\001\255\255\131\001\
\255\255\133\001\134\001\135\001\255\255\255\255\255\255\255\255\
\255\255\255\255\142\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\057\001\058\001\059\001\060\001\061\001\
\255\255\063\001\064\001\065\001\066\001\067\001\068\001\069\001\
\070\001\071\001\072\001\073\001\074\001\075\001\076\001\077\001\
\078\001\079\001\080\001\081\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\015\001\255\255\017\001\255\255\255\255\255\255\255\255\101\001\
\255\255\103\001\255\255\255\255\106\001\107\001\255\255\255\255\
\255\255\255\255\255\255\034\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\134\001\135\001\057\001\058\001\059\001\060\001\061\001\255\255\
\063\001\064\001\065\001\066\001\067\001\068\001\069\001\070\001\
\071\001\072\001\073\001\074\001\075\001\076\001\077\001\078\001\
\079\001\080\001\081\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\015\001\
\255\255\017\001\255\255\255\255\255\255\255\255\101\001\255\255\
\103\001\255\255\255\255\106\001\107\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\134\001\
\135\001\057\001\058\001\059\001\060\001\061\001\255\255\063\001\
\064\001\065\001\066\001\067\001\068\001\069\001\070\001\071\001\
\072\001\073\001\074\001\075\001\076\001\077\001\078\001\079\001\
\080\001\081\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\015\001\255\255\
\017\001\255\255\255\255\255\255\255\255\101\001\255\255\103\001\
\255\255\255\255\106\001\107\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\134\001\135\001\
\057\001\058\001\059\001\060\001\061\001\255\255\063\001\064\001\
\065\001\066\001\067\001\068\001\069\001\070\001\071\001\072\001\
\073\001\074\001\075\001\076\001\077\001\078\001\079\001\080\001\
\081\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\016\001\017\001\
\255\255\255\255\255\255\021\001\101\001\255\255\103\001\255\255\
\255\255\106\001\107\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\134\001\135\001\057\001\
\058\001\059\001\060\001\061\001\255\255\063\001\064\001\065\001\
\066\001\067\001\068\001\069\001\070\001\071\001\072\001\073\001\
\074\001\075\001\076\001\077\001\078\001\079\001\080\001\081\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\016\001\
\017\001\255\255\100\001\101\001\021\001\103\001\255\255\255\255\
\106\001\107\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\134\001\135\001\255\255\255\255\
\057\001\058\001\059\001\060\001\061\001\255\255\063\001\064\001\
\065\001\066\001\067\001\068\001\069\001\070\001\071\001\072\001\
\073\001\074\001\075\001\076\001\077\001\078\001\079\001\080\001\
\081\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\017\001\
\255\255\255\255\020\001\100\001\101\001\255\255\103\001\255\255\
\255\255\106\001\107\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\134\001\135\001\057\001\
\058\001\059\001\060\001\061\001\255\255\063\001\064\001\065\001\
\066\001\067\001\068\001\069\001\070\001\071\001\072\001\073\001\
\074\001\075\001\076\001\077\001\078\001\079\001\080\001\081\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\017\001\255\255\
\255\255\020\001\255\255\101\001\255\255\103\001\255\255\255\255\
\106\001\107\001\108\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\117\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\129\001\
\255\255\131\001\255\255\133\001\134\001\135\001\057\001\058\001\
\059\001\060\001\061\001\255\255\063\001\064\001\065\001\066\001\
\067\001\068\001\069\001\070\001\071\001\072\001\073\001\074\001\
\075\001\076\001\077\001\078\001\079\001\080\001\081\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\017\001\255\255\255\255\
\255\255\255\255\101\001\255\255\103\001\255\255\255\255\106\001\
\107\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\134\001\135\001\057\001\058\001\059\001\
\060\001\061\001\255\255\063\001\064\001\065\001\066\001\067\001\
\068\001\069\001\070\001\071\001\072\001\073\001\074\001\075\001\
\076\001\077\001\078\001\079\001\080\001\081\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\017\001\255\255\255\255\255\255\
\255\255\101\001\255\255\103\001\255\255\255\255\106\001\107\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\134\001\135\001\057\001\058\001\059\001\060\001\
\061\001\255\255\063\001\064\001\065\001\066\001\067\001\068\001\
\069\001\070\001\071\001\072\001\073\001\074\001\075\001\076\001\
\077\001\078\001\079\001\080\001\081\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\017\001\255\255\255\255\255\255\255\255\
\101\001\255\255\103\001\255\255\255\255\106\001\107\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\134\001\135\001\057\001\058\001\059\001\060\001\061\001\
\255\255\063\001\064\001\065\001\066\001\067\001\068\001\069\001\
\070\001\255\255\255\255\255\255\255\255\255\255\076\001\077\001\
\078\001\079\001\080\001\081\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\017\001\255\255\255\255\255\255\255\255\101\001\
\255\255\103\001\255\255\255\255\255\255\107\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\134\001\135\001\057\001\058\001\059\001\060\001\061\001\255\255\
\063\001\064\001\065\001\066\001\067\001\068\001\069\001\070\001\
\255\255\255\255\255\255\255\255\255\255\076\001\077\001\078\001\
\079\001\080\001\081\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\101\001\255\255\
\103\001\255\255\255\255\255\255\107\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\018\001\255\255\255\255\255\255\022\001\255\255\024\001\025\001\
\026\001\027\001\028\001\029\001\030\001\031\001\255\255\134\001\
\135\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\042\001\043\001\044\001\045\001\046\001\047\001\048\001\049\001\
\050\001\051\001\052\001\053\001\054\001\055\001\056\001\018\001\
\255\255\255\255\255\255\022\001\255\255\024\001\025\001\026\001\
\027\001\028\001\029\001\030\001\031\001\255\255\255\255\255\255\
\035\001\036\001\037\001\038\001\039\001\040\001\041\001\042\001\
\043\001\044\001\045\001\046\001\047\001\048\001\049\001\050\001\
\051\001\052\001\053\001\054\001\055\001\056\001\014\001\255\255\
\255\255\017\001\018\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\115\001\255\255\255\255\255\255\255\255\255\255\014\001\
\255\255\255\255\017\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\057\001\058\001\059\001\060\001\061\001\255\255\063\001\
\064\001\065\001\066\001\067\001\068\001\069\001\070\001\255\255\
\115\001\255\255\255\255\255\255\255\255\255\255\078\001\079\001\
\080\001\081\001\057\001\058\001\059\001\060\001\061\001\255\255\
\063\001\064\001\065\001\066\001\067\001\068\001\069\001\070\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\078\001\
\079\001\080\001\081\001\107\001\255\255\255\255\255\255\005\001\
\006\001\007\001\008\001\255\255\255\255\255\255\255\255\255\255\
\014\001\255\255\255\255\017\001\018\001\019\001\020\001\021\001\
\255\255\255\255\255\255\025\001\107\001\027\001\028\001\029\001\
\030\001\031\001\255\255\033\001\255\255\035\001\036\001\037\001\
\038\001\039\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001\047\001\048\001\049\001\050\001\051\001\052\001\053\001\
\054\001\055\001\056\001\255\255\255\255\255\255\255\255\255\255\
\255\255\005\001\006\001\007\001\008\001\255\255\255\255\255\255\
\255\255\255\255\014\001\255\255\255\255\017\001\018\001\019\001\
\020\001\021\001\255\255\255\255\255\255\025\001\084\001\027\001\
\028\001\029\001\030\001\031\001\090\001\033\001\255\255\035\001\
\036\001\037\001\038\001\039\001\040\001\041\001\042\001\043\001\
\044\001\045\001\046\001\047\001\048\001\049\001\050\001\051\001\
\052\001\053\001\054\001\055\001\056\001\255\255\255\255\255\255\
\255\255\255\255\255\255\005\001\006\001\007\001\008\001\255\255\
\255\255\255\255\255\255\255\255\014\001\255\255\255\255\017\001\
\018\001\019\001\020\001\021\001\255\255\255\255\255\255\025\001\
\084\001\027\001\028\001\029\001\030\001\031\001\090\001\033\001\
\255\255\035\001\255\255\037\001\038\001\039\001\040\001\041\001\
\042\001\043\001\044\001\045\001\046\001\047\001\048\001\049\001\
\050\001\051\001\052\001\053\001\054\001\055\001\056\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\018\001\255\255\
\255\255\021\001\022\001\255\255\024\001\025\001\026\001\027\001\
\028\001\255\255\084\001\031\001\255\255\255\255\255\255\035\001\
\090\001\037\001\038\001\039\001\040\001\041\001\042\001\043\001\
\044\001\045\001\046\001\047\001\048\001\049\001\050\001\051\001\
\052\001\053\001\054\001\055\001\056\001"

let yynames_const = "\
  "

let yynames_block = "\
  TUnknown\000\
  TCommentSpace\000\
  TCommentNewline\000\
  TComment\000\
  TInt\000\
  TFloat\000\
  TChar\000\
  TString\000\
  TQuote\000\
  TPct\000\
  TFormat\000\
  TSubString\000\
  TDecimal\000\
  TIdent\000\
  TKRParam\000\
  Tconstructorname\000\
  TypedefIdent\000\
  TOPar\000\
  TCPar\000\
  TOBrace\000\
  TCBrace\000\
  TOCro\000\
  TCCro\000\
  TDot\000\
  TComma\000\
  TPtrOp\000\
  TInc\000\
  TDec\000\
  TAssign\000\
  TEq\000\
  TWhy\000\
  TTilde\000\
  TBang\000\
  TEllipsis\000\
  TDotDot\000\
  TPtVirg\000\
  TOrLog\000\
  TAndLog\000\
  TOr\000\
  TXor\000\
  TAnd\000\
  TEqEq\000\
  TNotEq\000\
  TInf\000\
  TSup\000\
  TInfEq\000\
  TSupEq\000\
  TShl\000\
  TShr\000\
  TPlus\000\
  TMinus\000\
  TMul\000\
  TDiv\000\
  TMod\000\
  TMax\000\
  TMin\000\
  Tchar\000\
  Tshort\000\
  Tint\000\
  Tdouble\000\
  Tfloat\000\
  Tcomplex\000\
  Tlong\000\
  Tunsigned\000\
  Tsigned\000\
  Tvoid\000\
  Tsize_t\000\
  Tssize_t\000\
  Tptrdiff_t\000\
  TautoType\000\
  Tauto\000\
  Tregister\000\
  Textern\000\
  Tstatic\000\
  Ttypedef\000\
  Tconst\000\
  Tvolatile\000\
  Tstruct\000\
  Tunion\000\
  Tenum\000\
  Tdecimal\000\
  Texec\000\
  Tbreak\000\
  Telse\000\
  Tswitch\000\
  Tcase\000\
  Tcontinue\000\
  Tfor\000\
  Tdo\000\
  Tif\000\
  Twhile\000\
  Treturn\000\
  Tgoto\000\
  Tdefault\000\
  Tsizeof\000\
  Tnew\000\
  Tdelete\000\
  Tdefined\000\
  TOParCplusplusInit\000\
  Tnamespace\000\
  Trestrict\000\
  Tasm\000\
  Tattribute\000\
  TMacroGccEndAttr\000\
  TattributeNoarg\000\
  Tinline\000\
  Ttypeof\000\
  TDefine\000\
  TDefParamVariadic\000\
  TCppEscapedNewline\000\
  TCppConcatOp\000\
  TOParDefine\000\
  TOBraceDefineInit\000\
  TIdentDefine\000\
  TDefEOL\000\
  TInclude\000\
  TIncludeStart\000\
  TIncludeFilename\000\
  TIfdef\000\
  TIfdefelif\000\
  TIfdefelse\000\
  TEndif\000\
  TIfdefBool\000\
  TIfdefMisc\000\
  TIfdefVersion\000\
  TUifdef\000\
  TUelseif\000\
  TUendif\000\
  TUndef\000\
  TPrePragma\000\
  TPragma\000\
  TPragmaString\000\
  TCppDirectiveOther\000\
  TMacroAttr\000\
  TMacroAttrArgs\000\
  TMacroEndAttr\000\
  TMacroEndAttrArgs\000\
  TMacroStmt\000\
  TMacroIdStmt\000\
  TMacroIdentBuilder\000\
  TMacroString\000\
  TMacroDecl\000\
  TMacroDeclConst\000\
  TMacroIterator\000\
  TCommentSkipTagStart\000\
  TCommentSkipTagEnd\000\
  TCParEOL\000\
  TAction\000\
  TCommentMisc\000\
  TCommentCpp\000\
  EOF\000\
  TTODO\000\
  "

let yyact = [|
  (fun _ -> failwith "parser")
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'translation_unit) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 709 "parsing_c/parser_c.mly"
                          ( _1 )
# 3742 "parsing_c/parser_c.ml"
               : Ast_c.program))
; (fun __caml_parser_env ->
    Obj.repr(
# 713 "parsing_c/parser_c.mly"
     ( [] )
# 3748 "parsing_c/parser_c.ml"
               : 'translation_unit))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'translation_unit) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'external_declaration) in
    Obj.repr(
# 715 "parsing_c/parser_c.mly"
     ( !LP._lexer_hint.context_stack <- [LP.InTopLevel]; _1 @ [_2] )
# 3756 "parsing_c/parser_c.ml"
               : 'translation_unit))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : 'translation_unit) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : string * Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : 'translation_unit) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 717 "parsing_c/parser_c.mly"
     ( !LP._lexer_hint.context_stack <- [LP.InTopLevel];
       _1 @ [Namespace (_5, [_2; snd _3; _4; _6])] )
# 3769 "parsing_c/parser_c.ml"
               : 'translation_unit))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 730 "parsing_c/parser_c.mly"
                ( _1 )
# 3776 "parsing_c/parser_c.ml"
               : 'ident))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 731 "parsing_c/parser_c.mly"
                ( _1 )
# 3783 "parsing_c/parser_c.ml"
               : 'ident))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 732 "parsing_c/parser_c.mly"
                ( ("complex", _1) )
# 3790 "parsing_c/parser_c.ml"
               : 'ident))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 736 "parsing_c/parser_c.mly"
                ( _1 )
# 3797 "parsing_c/parser_c.ml"
               : 'identifier))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 737 "parsing_c/parser_c.mly"
                ( ("complex", _1) )
# 3804 "parsing_c/parser_c.ml"
               : 'identifier))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 746 "parsing_c/parser_c.mly"
     ( RegularName (mk_string_wrap _1) )
# 3811 "parsing_c/parser_c.ml"
               : 'identifier_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'ident_extra_cpp) in
    Obj.repr(
# 747 "parsing_c/parser_c.mly"
                   ( _1 )
# 3818 "parsing_c/parser_c.ml"
               : 'identifier_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 751 "parsing_c/parser_c.mly"
     ( RegularName (mk_string_wrap _1) )
# 3825 "parsing_c/parser_c.ml"
               : 'ident_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 753 "parsing_c/parser_c.mly"
     ( RegularName (mk_string_wrap _1) )
# 3832 "parsing_c/parser_c.ml"
               : 'ident_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'ident_extra_cpp) in
    Obj.repr(
# 754 "parsing_c/parser_c.mly"
                   ( _1 )
# 3839 "parsing_c/parser_c.ml"
               : 'ident_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 755 "parsing_c/parser_c.mly"
                ( RegularName (mk_string_wrap ("complex", _1)) )
# 3846 "parsing_c/parser_c.ml"
               : 'ident_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'identifier_cpp_list) in
    Obj.repr(
# 759 "parsing_c/parser_c.mly"
     (
       CppConcatenatedName (
         match _3 with
         | [] -> raise (Impossible 87)
         | (x,concatnull)::xs ->
             assert (concatnull = []);
             (mk_string_wrap _1, [])::(x,[_2])::xs
       )
   )
# 3863 "parsing_c/parser_c.ml"
               : 'ident_extra_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 769 "parsing_c/parser_c.mly"
     ( CppVariadicName (fst _2, [_1; snd _2]) )
# 3871 "parsing_c/parser_c.ml"
               : 'ident_extra_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : (string * Ast_c.info)) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'param_define_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 771 "parsing_c/parser_c.mly"
     ( CppIdentBuilder ((fst _1, [snd _1;_2;_4]), _3) )
# 3881 "parsing_c/parser_c.ml"
               : 'ident_extra_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 774 "parsing_c/parser_c.mly"
          ( [mk_string_wrap _1, []] )
# 3888 "parsing_c/parser_c.ml"
               : 'identifier_cpp_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'identifier_cpp_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 775 "parsing_c/parser_c.mly"
                                           ( _1 @ [mk_string_wrap _3, [_2]] )
# 3897 "parsing_c/parser_c.ml"
               : 'identifier_cpp_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 782 "parsing_c/parser_c.mly"
                           ( _1 )
# 3904 "parsing_c/parser_c.ml"
               : Ast_c.expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 783 "parsing_c/parser_c.mly"
                           ( mk_e (Sequence (_1,_3)) [_2] )
# 3913 "parsing_c/parser_c.ml"
               : Ast_c.expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cond_expr) in
    Obj.repr(
# 786 "parsing_c/parser_c.mly"
                                 ( _1 )
# 3920 "parsing_c/parser_c.ml"
               : 'assign_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'unary_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.assignOp) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 787 "parsing_c/parser_c.mly"
                                  ( mk_e(Assignment (_1, _2, _3)) [])
# 3929 "parsing_c/parser_c.ml"
               : 'assign_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'unary_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 788 "parsing_c/parser_c.mly"
                                  ( mk_e (Assignment (_1, (SimpleAssign, [_2]),_3)) [])
# 3938 "parsing_c/parser_c.ml"
               : 'assign_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 793 "parsing_c/parser_c.mly"
     ( _1 )
# 3945 "parsing_c/parser_c.ml"
               : 'cond_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'gcc_opt_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'cond_expr) in
    Obj.repr(
# 795 "parsing_c/parser_c.mly"
     ( mk_e (CondExpr (_1,_3,_5)) [_2;_4] )
# 3956 "parsing_c/parser_c.ml"
               : 'cond_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cast_expr) in
    Obj.repr(
# 799 "parsing_c/parser_c.mly"
                                 ( _1 )
# 3963 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 800 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Mul,[_2]), _3)) [] )
# 3972 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 801 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Div, [_2]), _3)) [] )
# 3981 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 802 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Min, [_2]), _3)) [] )
# 3990 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 803 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Max, [_2]), _3)) [] )
# 3999 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 804 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Mod, [_2]), _3)) [] )
# 4008 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 805 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Plus, [_2]), _3)) [] )
# 4017 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 806 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Minus, [_2]), _3)) [] )
# 4026 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 807 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith DecLeft, [_2]), _3)) [] )
# 4035 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 808 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith DecRight, [_2]), _3)) [] )
# 4044 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 809 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical Inf, [_2]), _3)) [] )
# 4053 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 810 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical Sup, [_2]), _3)) [] )
# 4062 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 811 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical InfEq, [_2]), _3)) [] )
# 4071 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 812 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical SupEq, [_2]), _3)) [] )
# 4080 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 813 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical Eq, [_2]), _3)) [] )
# 4089 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 814 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical NotEq, [_2]), _3)) [] )
# 4098 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 815 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith And, [_2]), _3)) [] )
# 4107 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 816 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Or, [_2]), _3)) [] )
# 4116 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 817 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Xor, [_2]), _3)) [] )
# 4125 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 818 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical AndLog, [_2]), _3)) [] )
# 4134 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 819 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical OrLog, [_2]), _3)) [] )
# 4143 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'unary_expr) in
    Obj.repr(
# 822 "parsing_c/parser_c.mly"
                                     ( _1 )
# 4150 "parsing_c/parser_c.ml"
               : 'cast_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'topar2) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.attribute list * Ast_c.fullType) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'tcpar2) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'cast_expr) in
    Obj.repr(
# 824 "parsing_c/parser_c.mly"
   ( mk_e(Cast (snd _2, fst _2, _4)) [_1;_3] )
# 4160 "parsing_c/parser_c.ml"
               : 'cast_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'postfix_expr) in
    Obj.repr(
# 832 "parsing_c/parser_c.mly"
                                   ( _1 )
# 4167 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'unary_expr) in
    Obj.repr(
# 833 "parsing_c/parser_c.mly"
                                   ( mk_e(Infix (_2, Inc))    [_1] )
# 4175 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'unary_expr) in
    Obj.repr(
# 834 "parsing_c/parser_c.mly"
                                   ( mk_e(Infix (_2, Dec))    [_1] )
# 4183 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'unary_op) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'cast_expr) in
    Obj.repr(
# 835 "parsing_c/parser_c.mly"
                                   ( mk_e(Unary (_2, fst _1)) [snd _1] )
# 4191 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'unary_expr) in
    Obj.repr(
# 836 "parsing_c/parser_c.mly"
                                   ( mk_e(SizeOfExpr (_2))    [_1] )
# 4199 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'topar2) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.attribute list * Ast_c.fullType) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar2) in
    Obj.repr(
# 838 "parsing_c/parser_c.mly"
     ( let ret = mk_e(SizeOfType (snd _3)) [_1;_2;_4] in
       match (fst _3) with (* warn about dropped attributes *)
         [] -> ret
       | _ -> warning "attributes found in sizeof(...), dropping" ret )
# 4212 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'new_argument) in
    Obj.repr(
# 842 "parsing_c/parser_c.mly"
                                   ( mk_e(New (None, _2))     [_1] )
# 4220 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list_ne) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'new_argument) in
    Obj.repr(
# 843 "parsing_c/parser_c.mly"
                                                  ( mk_e(New (Some _3, _5))             [_1; _2; _4] )
# 4231 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'cast_expr) in
    Obj.repr(
# 844 "parsing_c/parser_c.mly"
                                   ( mk_e(Delete(false, _2))  [_1] )
# 4239 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'cast_expr) in
    Obj.repr(
# 845 "parsing_c/parser_c.mly"
                                   ( mk_e(Delete(true, _4))   [_1;_2;_3] )
# 4249 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'identifier_cpp) in
    Obj.repr(
# 846 "parsing_c/parser_c.mly"
                                   ( mk_e(Defined _2)         [_1] )
# 4257 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'identifier_cpp) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 848 "parsing_c/parser_c.mly"
 ( mk_e(Defined _3) [_1;_2;_4] )
# 4267 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'argument_list_ne) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 852 "parsing_c/parser_c.mly"
     ( let fn = mk_e(Ident (RegularName (mk_string_wrap _1))) [] in
       Left (mk_e(FunCall (fn, _3)) [_2;_4]) )
# 4278 "parsing_c/parser_c.ml"
               : 'new_argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 855 "parsing_c/parser_c.mly"
     ( let fn = mk_e(Ident (RegularName (mk_string_wrap _1))) [] in
       Left(mk_e(FunCall (fn, [])) [_2;_3]) )
# 4288 "parsing_c/parser_c.ml"
               : 'new_argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'argument_list_ne) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 858 "parsing_c/parser_c.mly"
     ( let fn = mk_e(Ident (RegularName (mk_string_wrap _1))) [] in
       Left (mk_e(FunCall (fn, _3)) [_2;_4]) )
# 4299 "parsing_c/parser_c.ml"
               : 'new_argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 861 "parsing_c/parser_c.mly"
     ( let fn = mk_e(Ident (RegularName (mk_string_wrap _1))) [] in
       Left (mk_e(FunCall (fn, [])) [_2;_3]) )
# 4309 "parsing_c/parser_c.ml"
               : 'new_argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_spec) in
    Obj.repr(
# 864 "parsing_c/parser_c.mly"
     ( let ty = addTypeD (_1,nullDecl) in
       let ((returnType,hasreg), iihasreg) = fixDeclSpecForParam ty in
       Right (ArgType { p_namei = None; p_type = returnType;
                        p_register = hasreg, iihasreg; p_attr = [];
                        p_midattr = []; p_endattr = [];
		      } )
     )
# 4322 "parsing_c/parser_c.ml"
               : 'new_argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'new_argument) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.expression) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 872 "parsing_c/parser_c.mly"
     (
       match _1 with
	 Left(e) -> Left(mk_e(ArrayAccess (e, _3)) [_2;_4])
       | Right(ArgType(ty)) -> (* lots of hacks to make the right type *)
	   let fty = mk_ty (Array (Some _3, ty.Ast_c.p_type)) [_2;_4] in
	   let pty = { ty with p_type = fty } in
	   Right(ArgType pty)
       | _ -> raise (Impossible 88)
     )
# 4340 "parsing_c/parser_c.ml"
               : 'new_argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 883 "parsing_c/parser_c.mly"
          ( GetRef,     _1 )
# 4347 "parsing_c/parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 884 "parsing_c/parser_c.mly"
          ( DeRef,      _1 )
# 4354 "parsing_c/parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 885 "parsing_c/parser_c.mly"
          ( UnPlus,     _1 )
# 4361 "parsing_c/parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 886 "parsing_c/parser_c.mly"
          ( UnMinus,    _1 )
# 4368 "parsing_c/parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 887 "parsing_c/parser_c.mly"
          ( Tilde,      _1 )
# 4375 "parsing_c/parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 888 "parsing_c/parser_c.mly"
          ( Not,        _1 )
# 4382 "parsing_c/parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 892 "parsing_c/parser_c.mly"
           ( GetRefLabel, _1 )
# 4389 "parsing_c/parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'primary_expr) in
    Obj.repr(
# 895 "parsing_c/parser_c.mly"
                              ( _1 )
# 4396 "parsing_c/parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.expression) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 897 "parsing_c/parser_c.mly"
     ( mk_e(ArrayAccess (_1, _3)) [_2;_4] )
# 4406 "parsing_c/parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'argument_list_ne) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 899 "parsing_c/parser_c.mly"
     ( mk_e(FunCall (_1, _3)) [_2;_4] )
# 4416 "parsing_c/parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 900 "parsing_c/parser_c.mly"
                              ( mk_e(FunCall (_1, [])) [_2;_3] )
# 4425 "parsing_c/parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'ident_cpp) in
    Obj.repr(
# 901 "parsing_c/parser_c.mly"
                                 ( mk_e(RecordAccess   (_1,_3)) [_2] )
# 4434 "parsing_c/parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'ident_cpp) in
    Obj.repr(
# 902 "parsing_c/parser_c.mly"
                                 ( mk_e(RecordPtAccess (_1,_3)) [_2] )
# 4443 "parsing_c/parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 903 "parsing_c/parser_c.mly"
                              ( mk_e(Postfix (_1, Inc)) [_2] )
# 4451 "parsing_c/parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 904 "parsing_c/parser_c.mly"
                              ( mk_e(Postfix (_1, Dec)) [_2] )
# 4459 "parsing_c/parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : 'topar2) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.attribute list * Ast_c.fullType) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'tcpar2) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 908 "parsing_c/parser_c.mly"
     ( mk_e(Constructor (snd _2, (InitList [], [_4;_5]))) [_1;_3] )
# 4470 "parsing_c/parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : 'topar2) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.attribute list * Ast_c.fullType) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : 'tcpar2) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : 'initialize_list) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : 'gcc_comma_opt_struct) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 910 "parsing_c/parser_c.mly"
     ( mk_e(Constructor (snd _2, (InitList (List.rev _5),[_4;_7] @ _6))) [_1;_3] )
# 4483 "parsing_c/parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'identifier_cpp) in
    Obj.repr(
# 914 "parsing_c/parser_c.mly"
                   ( mk_e(Ident  (_1)) [] )
# 4490 "parsing_c/parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * (Ast_c.sign * Ast_c.base)) * Ast_c.info) in
    Obj.repr(
# 916 "parsing_c/parser_c.mly"
    ( let (str,(sign,base)) = fst _1 in
      mk_e(Constant (Int (str,Si(sign,base)))) [snd _1] )
# 4498 "parsing_c/parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.floatType) * Ast_c.info) in
    Obj.repr(
# 918 "parsing_c/parser_c.mly"
           ( mk_e(Constant (Float  (fst _1))) [snd _1] )
# 4505 "parsing_c/parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.isWchar) * Ast_c.info) in
    Obj.repr(
# 919 "parsing_c/parser_c.mly"
           ( mk_e(Constant (String (fst _1))) [snd _1] )
# 4512 "parsing_c/parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : (string * Ast_c.isWchar) * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'string_fragments) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.isWchar) * Ast_c.info) in
    Obj.repr(
# 921 "parsing_c/parser_c.mly"
     ( let ((fullstring,isW),lqinfo) = _1 in
       let (_,rqinfo) = _3 in
       mk_e (Ast_c.StringConstant(_2, fullstring, isW)) [lqinfo;rqinfo] )
# 4523 "parsing_c/parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.isWchar) * Ast_c.info) in
    Obj.repr(
# 924 "parsing_c/parser_c.mly"
           ( mk_e(Constant (Char   (fst _1))) [snd _1] )
# 4530 "parsing_c/parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * string (*n*) * string (*p*)) * Ast_c.info) in
    Obj.repr(
# 925 "parsing_c/parser_c.mly"
            ( let (a,b,c) = fst _1 in
              mk_e(Constant (DecimalConst (a,b,c))) [snd _1] )
# 4538 "parsing_c/parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 927 "parsing_c/parser_c.mly"
                    ( mk_e(ParenExpr (_2)) [_1;_3] )
# 4547 "parsing_c/parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 930 "parsing_c/parser_c.mly"
                ( mk_e(Constant (MultiString [fst _1])) [snd _1] )
# 4554 "parsing_c/parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'string_elem) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'string_list) in
    Obj.repr(
# 932 "parsing_c/parser_c.mly"
     ( mk_e(Constant (MultiString ["TODO: MultiString"])) (_1 @ _2) )
# 4562 "parsing_c/parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'compound) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 935 "parsing_c/parser_c.mly"
                         ( mk_e(StatementExpr (_2)) [_1;_3] )
# 4571 "parsing_c/parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    Obj.repr(
# 938 "parsing_c/parser_c.mly"
               ( [] )
# 4577 "parsing_c/parser_c.ml"
               : 'string_fragments))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'string_fragment) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'string_fragments) in
    Obj.repr(
# 939 "parsing_c/parser_c.mly"
                                    ( _1 :: _2 )
# 4585 "parsing_c/parser_c.ml"
               : 'string_fragments))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'string_format) in
    Obj.repr(
# 942 "parsing_c/parser_c.mly"
                      ( Ast_c.FormatFragment(_2), [_1] )
# 4593 "parsing_c/parser_c.ml"
               : 'string_fragment))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 943 "parsing_c/parser_c.mly"
              ( Ast_c.ConstantFragment(fst _1), [snd _1] )
# 4600 "parsing_c/parser_c.ml"
               : 'string_fragment))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 946 "parsing_c/parser_c.mly"
           ( Ast_c.ConstantFormat(fst _1), [snd _1] )
# 4607 "parsing_c/parser_c.ml"
               : 'string_format))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 955 "parsing_c/parser_c.mly"
               ( Left _1 )
# 4614 "parsing_c/parser_c.ml"
               : 'argument_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_decl_arg) in
    Obj.repr(
# 956 "parsing_c/parser_c.mly"
                      ( Right (ArgType _1) )
# 4621 "parsing_c/parser_c.ml"
               : 'argument_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'action_higherordermacro_ne) in
    Obj.repr(
# 957 "parsing_c/parser_c.mly"
                              ( Right (ArgAction _1) )
# 4628 "parsing_c/parser_c.ml"
               : 'argument_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 961 "parsing_c/parser_c.mly"
               ( Left _1 )
# 4635 "parsing_c/parser_c.ml"
               : 'argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_decl_arg) in
    Obj.repr(
# 962 "parsing_c/parser_c.mly"
                      ( Right (ArgType _1) )
# 4642 "parsing_c/parser_c.ml"
               : 'argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'action_higherordermacro) in
    Obj.repr(
# 964 "parsing_c/parser_c.mly"
                           ( Right (ArgAction _1) )
# 4649 "parsing_c/parser_c.ml"
               : 'argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'taction_list_ne) in
    Obj.repr(
# 968 "parsing_c/parser_c.mly"
     ( if _1=[]
       then ActMisc [Ast_c.fakeInfo()]
       else ActMisc _1
     )
# 4659 "parsing_c/parser_c.ml"
               : 'action_higherordermacro_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'taction_list) in
    Obj.repr(
# 976 "parsing_c/parser_c.mly"
     ( if _1=[]
       then ActMisc [Ast_c.fakeInfo()]
       else ActMisc _1
     )
# 4669 "parsing_c/parser_c.ml"
               : 'action_higherordermacro))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cond_expr) in
    Obj.repr(
# 987 "parsing_c/parser_c.mly"
                      ( _1  )
# 4676 "parsing_c/parser_c.ml"
               : 'const_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 990 "parsing_c/parser_c.mly"
              ( et "topar2" (); _1  )
# 4683 "parsing_c/parser_c.ml"
               : 'topar2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 991 "parsing_c/parser_c.mly"
              ( et "tcpar2" (); _1 (*TODO? et ? sure ? c pas dt plutot ? *) )
# 4690 "parsing_c/parser_c.ml"
               : 'tcpar2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'statement2) in
    Obj.repr(
# 999 "parsing_c/parser_c.mly"
                      ( mk_st (fst _1) (snd _1) )
# 4697 "parsing_c/parser_c.ml"
               : Ast_c.statement))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'labeled) in
    Obj.repr(
# 1002 "parsing_c/parser_c.mly"
                   ( Labeled      (fst _1), snd _1 )
# 4704 "parsing_c/parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'compound) in
    Obj.repr(
# 1003 "parsing_c/parser_c.mly"
                   ( Compound     (fst _1), snd _1 )
# 4711 "parsing_c/parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'expr_statement) in
    Obj.repr(
# 1004 "parsing_c/parser_c.mly"
                   ( ExprStatement(fst _1), snd _1 )
# 4718 "parsing_c/parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'selection) in
    Obj.repr(
# 1005 "parsing_c/parser_c.mly"
                   ( Selection    (fst _1), snd _1 @ [postfakeInfo(snd _1)] )
# 4725 "parsing_c/parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.iteration * Ast_c.info list) in
    Obj.repr(
# 1006 "parsing_c/parser_c.mly"
                   ( Iteration    (fst _1), snd _1 @ [postfakeInfo(snd _1)] )
# 4732 "parsing_c/parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'jump) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1007 "parsing_c/parser_c.mly"
                   ( Jump         (fst _1), snd _1 @ [_2] )
# 4740 "parsing_c/parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'asmbody) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1010 "parsing_c/parser_c.mly"
                                                ( Asm _3, [_1;_2;_4;_5] )
# 4751 "parsing_c/parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'asmbody) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1011 "parsing_c/parser_c.mly"
                                                ( Asm _4, [_1;_2;_3;_5;_6] )
# 4763 "parsing_c/parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : (string * Ast_c.info)) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'argument_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1014 "parsing_c/parser_c.mly"
                                        (
   let fn = mk_e(Ident (RegularName (mk_string_wrap _1))) [] in
   ExprStatement (Some(mk_e (FunCall (fn, _3)) [_2;_4])), [Ast_c.fakeInfo ()] )
# 4775 "parsing_c/parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 1017 "parsing_c/parser_c.mly"
                ( MacroStmt, [snd _1] )
# 4782 "parsing_c/parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'identifier) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'exec_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1019 "parsing_c/parser_c.mly"
                                      ( Exec(_3), [_1;snd _2;_4] )
# 4792 "parsing_c/parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'ident_cpp) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'sw_stat_or_decl) in
    Obj.repr(
# 1026 "parsing_c/parser_c.mly"
                                              ( Label (_1, _3),  [_2] )
# 4801 "parsing_c/parser_c.ml"
               : 'labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'const_expr) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'sw_stat_or_decl) in
    Obj.repr(
# 1027 "parsing_c/parser_c.mly"
                                              ( Case (_2, _4),       [_1; _3] )
# 4811 "parsing_c/parser_c.ml"
               : 'labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : 'const_expr) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'const_expr) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : 'sw_stat_or_decl) in
    Obj.repr(
# 1029 "parsing_c/parser_c.mly"
     ( CaseRange (_2, _4, _6), [_1;_3;_5] )
# 4823 "parsing_c/parser_c.ml"
               : 'labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'sw_stat_or_decl) in
    Obj.repr(
# 1030 "parsing_c/parser_c.mly"
                                         ( Default _3,             [_1; _2] )
# 4832 "parsing_c/parser_c.ml"
               : 'labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl) in
    Obj.repr(
# 1033 "parsing_c/parser_c.mly"
             ( mk_st (Decl (_1 Ast_c.LocalDecl)) Ast_c.noii )
# 4839 "parsing_c/parser_c.ml"
               : 'sw_stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1034 "parsing_c/parser_c.mly"
             ( _1 )
# 4846 "parsing_c/parser_c.ml"
               : 'sw_stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'ident_cpp) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1045 "parsing_c/parser_c.mly"
     ( Label (_1, (mk_st (ExprStatement None) Ast_c.noii)), [_2] )
# 4854 "parsing_c/parser_c.ml"
               : 'end_labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1047 "parsing_c/parser_c.mly"
     ( Case (_2, (mk_st (ExprStatement None) Ast_c.noii)), [_1;_3] )
# 4863 "parsing_c/parser_c.ml"
               : 'end_labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1049 "parsing_c/parser_c.mly"
     ( Default (mk_st (ExprStatement None) Ast_c.noii),    [_1; _2] )
# 4871 "parsing_c/parser_c.ml"
               : 'end_labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'tobrace) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'compound2) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace) in
    Obj.repr(
# 1055 "parsing_c/parser_c.mly"
                                    ( _2, [_1; _3]  )
# 4880 "parsing_c/parser_c.ml"
               : 'compound))
; (fun __caml_parser_env ->
    Obj.repr(
# 1067 "parsing_c/parser_c.mly"
                     ( ([]) )
# 4886 "parsing_c/parser_c.ml"
               : 'compound2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'stat_or_decl_list) in
    Obj.repr(
# 1068 "parsing_c/parser_c.mly"
                     ( _1 )
# 4893 "parsing_c/parser_c.ml"
               : 'compound2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'stat_or_decl) in
    Obj.repr(
# 1072 "parsing_c/parser_c.mly"
                                  ( [_1] )
# 4900 "parsing_c/parser_c.ml"
               : 'stat_or_decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'end_labeled) in
    Obj.repr(
# 1074 "parsing_c/parser_c.mly"
                ( [StmtElem (mk_st (Labeled  (fst _1)) (snd _1))] )
# 4907 "parsing_c/parser_c.ml"
               : 'stat_or_decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'stat_or_decl) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'stat_or_decl_list) in
    Obj.repr(
# 1076 "parsing_c/parser_c.mly"
                                  ( _1 :: _2 )
# 4915 "parsing_c/parser_c.ml"
               : 'stat_or_decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl) in
    Obj.repr(
# 1079 "parsing_c/parser_c.mly"
             ( StmtElem (mk_st (Decl (_1 Ast_c.LocalDecl)) Ast_c.noii) )
# 4922 "parsing_c/parser_c.ml"
               : 'stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1080 "parsing_c/parser_c.mly"
             ( StmtElem _1 )
# 4929 "parsing_c/parser_c.ml"
               : 'stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'function_definition) in
    Obj.repr(
# 1083 "parsing_c/parser_c.mly"
                       ( StmtElem (mk_st (NestedFunc _1) Ast_c.noii) )
# 4936 "parsing_c/parser_c.ml"
               : 'stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.cpp_directive) in
    Obj.repr(
# 1087 "parsing_c/parser_c.mly"
     ( CppDirectiveStmt _1 )
# 4943 "parsing_c/parser_c.ml"
               : 'stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_directive) in
    Obj.repr(
# 1089 "parsing_c/parser_c.mly"
     ( IfdefStmt _1 )
# 4950 "parsing_c/parser_c.ml"
               : 'stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1093 "parsing_c/parser_c.mly"
                               ( None,    [_1] )
# 4957 "parsing_c/parser_c.ml"
               : 'expr_statement))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'end_attributes) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1094 "parsing_c/parser_c.mly"
                               ( None,    [_2] )
# 4965 "parsing_c/parser_c.ml"
               : 'expr_statement))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.expression) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1095 "parsing_c/parser_c.mly"
                               ( Some _1, [_2] )
# 4973 "parsing_c/parser_c.ml"
               : 'expr_statement))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_statement) in
    Obj.repr(
# 1099 "parsing_c/parser_c.mly"
     ( If (_3, _5, (mk_st (ExprStatement None) Ast_c.noii)),   [_1;_2;_4] )
# 4984 "parsing_c/parser_c.ml"
               : 'selection))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.expression) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : 'cpp_ifdef_statement) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_statement) in
    Obj.repr(
# 1101 "parsing_c/parser_c.mly"
     ( If (_3, _5, _7),  [_1;_2;_4;_6] )
# 4997 "parsing_c/parser_c.ml"
               : 'selection))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1103 "parsing_c/parser_c.mly"
     ( Switch (_3,_5),   [_1;_2;_4]  )
# 5008 "parsing_c/parser_c.ml"
               : 'selection))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 8 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 7 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.expression) in
    let _5 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.statement) in
    let _7 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _8 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _9 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1106 "parsing_c/parser_c.mly"
     ( Ifdef_Ite (_4,_6,_9), [_1;_2;_3;_5;_7;_8] )
# 5023 "parsing_c/parser_c.ml"
               : 'selection))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 10 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 9 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 8 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 7 : Ast_c.expression) in
    let _5 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.statement) in
    let _7 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _8 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _9 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.statement) in
    let _10 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _11 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1109 "parsing_c/parser_c.mly"
     ( Ifdef_Ite2 (_4,_6,_9,_11), [_1;_2;_3;_5;_7;_8;_10] )
# 5040 "parsing_c/parser_c.ml"
               : 'selection))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_statement) in
    Obj.repr(
# 1113 "parsing_c/parser_c.mly"
     ( While (_3,_5),                [_1;_2;_4] )
# 5051 "parsing_c/parser_c.ml"
               : Ast_c.iteration * Ast_c.info list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.statement) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1115 "parsing_c/parser_c.mly"
     ( DoWhile (_2,_5),              [_1;_3;_4;_6;_7] )
# 5064 "parsing_c/parser_c.ml"
               : Ast_c.iteration * Ast_c.info list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : 'expr_statement) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'expr_statement) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_statement) in
    Obj.repr(
# 1117 "parsing_c/parser_c.mly"
     ( For (ForExp _3,_4,(None, []),_6),    [_1;_2;_5])
# 5076 "parsing_c/parser_c.ml"
               : Ast_c.iteration * Ast_c.info list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : 'expr_statement) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : 'expr_statement) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_statement) in
    Obj.repr(
# 1119 "parsing_c/parser_c.mly"
     ( For (ForExp _3,_4,(Some _5, []),_7), [_1;_2;_6] )
# 5089 "parsing_c/parser_c.ml"
               : Ast_c.iteration * Ast_c.info list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : 'decl) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'expr_statement) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_statement) in
    Obj.repr(
# 1122 "parsing_c/parser_c.mly"
     ( For (ForDecl (_3 Ast_c.LocalDecl),_4,(None, []),_6),    [_1;_2;_5])
# 5101 "parsing_c/parser_c.ml"
               : Ast_c.iteration * Ast_c.info list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : 'decl) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : 'expr_statement) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_statement) in
    Obj.repr(
# 1124 "parsing_c/parser_c.mly"
     ( For (ForDecl (_3 Ast_c.LocalDecl),_4,(Some _5, []),_7), [_1;_2;_6] )
# 5114 "parsing_c/parser_c.ml"
               : Ast_c.iteration * Ast_c.info list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : (string * Ast_c.info)) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list_ne) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_statement) in
    Obj.repr(
# 1127 "parsing_c/parser_c.mly"
     ( MacroIteration (fst _1, _3, _5), [snd _1;_2;_4] )
# 5125 "parsing_c/parser_c.ml"
               : Ast_c.iteration * Ast_c.info list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : (string * Ast_c.info)) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_statement) in
    Obj.repr(
# 1129 "parsing_c/parser_c.mly"
     ( MacroIteration (fst _1, [], _4), [snd _1;_2;_3] )
# 5135 "parsing_c/parser_c.ml"
               : Ast_c.iteration * Ast_c.info list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'ident_cpp) in
    Obj.repr(
# 1133 "parsing_c/parser_c.mly"
                    ( Goto (_2),  [_1] )
# 5143 "parsing_c/parser_c.ml"
               : 'jump))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1134 "parsing_c/parser_c.mly"
                ( Continue,       [_1] )
# 5150 "parsing_c/parser_c.ml"
               : 'jump))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1135 "parsing_c/parser_c.mly"
                ( Break,          [_1] )
# 5157 "parsing_c/parser_c.ml"
               : 'jump))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1136 "parsing_c/parser_c.mly"
                ( Return,         [_1] )
# 5164 "parsing_c/parser_c.ml"
               : 'jump))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.expression) in
    Obj.repr(
# 1137 "parsing_c/parser_c.mly"
                ( ReturnExpr _2,  [_1] )
# 5172 "parsing_c/parser_c.ml"
               : 'jump))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.expression) in
    Obj.repr(
# 1138 "parsing_c/parser_c.mly"
                   ( GotoComputed _3, [_1;_2] )
# 5181 "parsing_c/parser_c.ml"
               : 'jump))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.isWchar) * Ast_c.info) in
    Obj.repr(
# 1146 "parsing_c/parser_c.mly"
           ( [snd _1] )
# 5188 "parsing_c/parser_c.ml"
               : 'string_elem))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 1148 "parsing_c/parser_c.mly"
                ( [snd _1] )
# 5195 "parsing_c/parser_c.ml"
               : 'string_elem))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'string_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'colon_asm_list) in
    Obj.repr(
# 1152 "parsing_c/parser_c.mly"
                               ( _1, _2 )
# 5203 "parsing_c/parser_c.ml"
               : 'asmbody))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'string_list) in
    Obj.repr(
# 1153 "parsing_c/parser_c.mly"
               ( _1, [] )
# 5210 "parsing_c/parser_c.ml"
               : 'asmbody))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'colon_option_list) in
    Obj.repr(
# 1156 "parsing_c/parser_c.mly"
                                     ( Colon _2, [_1]   )
# 5218 "parsing_c/parser_c.ml"
               : 'colon_asm))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.isWchar) * Ast_c.info) in
    Obj.repr(
# 1159 "parsing_c/parser_c.mly"
                                ( ColonMisc, [snd _1] )
# 5225 "parsing_c/parser_c.ml"
               : 'colon_option))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : (string * Ast_c.isWchar) * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'asm_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1160 "parsing_c/parser_c.mly"
                                ( ColonExpr _3, [snd _1; _2;_4] )
# 5235 "parsing_c/parser_c.ml"
               : 'colon_option))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : 'identifier) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : (string * Ast_c.isWchar) * Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : 'asm_expr) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1163 "parsing_c/parser_c.mly"
     ( ColonExpr _6, [_1;snd _2;_3;snd _4; _5; _7 ] )
# 5248 "parsing_c/parser_c.ml"
               : 'colon_option))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'identifier) in
    Obj.repr(
# 1164 "parsing_c/parser_c.mly"
                                    ( ColonMisc, [snd _1] )
# 5255 "parsing_c/parser_c.ml"
               : 'colon_option))
; (fun __caml_parser_env ->
    Obj.repr(
# 1165 "parsing_c/parser_c.mly"
                                    ( ColonMisc, [] )
# 5261 "parsing_c/parser_c.ml"
               : 'colon_option))
; (fun __caml_parser_env ->
    Obj.repr(
# 1169 "parsing_c/parser_c.mly"
                ( [] )
# 5267 "parsing_c/parser_c.ml"
               : 'exec_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'identifier_cpp) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'exec_ident) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'exec_list) in
    Obj.repr(
# 1171 "parsing_c/parser_c.mly"
      ( (ExecEval (_3 (mk_e (Ident _2) [])), [_1]) :: _4 )
# 5277 "parsing_c/parser_c.ml"
               : 'exec_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'exec_ident2) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'exec_list) in
    Obj.repr(
# 1173 "parsing_c/parser_c.mly"
      ( (ExecToken, [snd _1]) :: _2 @ _3 )
# 5286 "parsing_c/parser_c.ml"
               : 'exec_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'token) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'exec_list) in
    Obj.repr(
# 1174 "parsing_c/parser_c.mly"
                    ( (ExecToken, [_1]) :: _2 )
# 5294 "parsing_c/parser_c.ml"
               : 'exec_list))
; (fun __caml_parser_env ->
    Obj.repr(
# 1177 "parsing_c/parser_c.mly"
    ( function prev -> prev )
# 5300 "parsing_c/parser_c.ml"
               : 'exec_ident))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : string * Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'exec_ident) in
    Obj.repr(
# 1179 "parsing_c/parser_c.mly"
     ( function prev ->
       let fld = RegularName (mk_string_wrap _2) in
       _3 (mk_e(RecordAccess   (prev,fld)) [_1]) )
# 5311 "parsing_c/parser_c.ml"
               : 'exec_ident))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : string * Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'exec_ident) in
    Obj.repr(
# 1183 "parsing_c/parser_c.mly"
     ( function prev ->
       let fld = RegularName (mk_string_wrap _2) in
       _3 (mk_e(RecordPtAccess   (prev,fld)) [_1]) )
# 5322 "parsing_c/parser_c.ml"
               : 'exec_ident))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'exec_ident) in
    Obj.repr(
# 1187 "parsing_c/parser_c.mly"
     ( function prev ->
       _4 (mk_e(ArrayAccess   (prev,_2)) [_1;_3]) )
# 5333 "parsing_c/parser_c.ml"
               : 'exec_ident))
; (fun __caml_parser_env ->
    Obj.repr(
# 1191 "parsing_c/parser_c.mly"
    ( [] )
# 5339 "parsing_c/parser_c.ml"
               : 'exec_ident2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : string * Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'exec_ident2) in
    Obj.repr(
# 1193 "parsing_c/parser_c.mly"
    ( (ExecToken, [_1]) :: (ExecToken, [snd _2]) :: _3 )
# 5348 "parsing_c/parser_c.ml"
               : 'exec_ident2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 1195 "parsing_c/parser_c.mly"
                      ( _1 )
# 5355 "parsing_c/parser_c.ml"
               : 'asm_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1198 "parsing_c/parser_c.mly"
            ( _1 )
# 5362 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1199 "parsing_c/parser_c.mly"
            ( _1 )
# 5369 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1200 "parsing_c/parser_c.mly"
            ( _1 )
# 5376 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1201 "parsing_c/parser_c.mly"
            ( _1 )
# 5383 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1202 "parsing_c/parser_c.mly"
            ( _1 )
# 5390 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1203 "parsing_c/parser_c.mly"
            ( _1 )
# 5397 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1204 "parsing_c/parser_c.mly"
            ( _1 )
# 5404 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1205 "parsing_c/parser_c.mly"
            ( _1 )
# 5411 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1206 "parsing_c/parser_c.mly"
            ( _1 )
# 5418 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1207 "parsing_c/parser_c.mly"
            ( _1 )
# 5425 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.assignOp) in
    Obj.repr(
# 1208 "parsing_c/parser_c.mly"
            ( List.hd (snd _1) )
# 5432 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1210 "parsing_c/parser_c.mly"
            ( _1 )
# 5439 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1211 "parsing_c/parser_c.mly"
            ( _1 )
# 5446 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1212 "parsing_c/parser_c.mly"
            ( _1 )
# 5453 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1213 "parsing_c/parser_c.mly"
            ( _1 )
# 5460 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1214 "parsing_c/parser_c.mly"
            ( _1 )
# 5467 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1215 "parsing_c/parser_c.mly"
            ( _1 )
# 5474 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1217 "parsing_c/parser_c.mly"
            ( _1 )
# 5481 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1218 "parsing_c/parser_c.mly"
            ( _1 )
# 5488 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1219 "parsing_c/parser_c.mly"
            ( _1 )
# 5495 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1220 "parsing_c/parser_c.mly"
            ( _1 )
# 5502 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1221 "parsing_c/parser_c.mly"
            ( _1 )
# 5509 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1222 "parsing_c/parser_c.mly"
            ( _1 )
# 5516 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1223 "parsing_c/parser_c.mly"
            ( _1 )
# 5523 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1225 "parsing_c/parser_c.mly"
            ( _1 )
# 5530 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1226 "parsing_c/parser_c.mly"
            ( _1 )
# 5537 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1229 "parsing_c/parser_c.mly"
            ( _1 )
# 5544 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1230 "parsing_c/parser_c.mly"
            ( _1 )
# 5551 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1234 "parsing_c/parser_c.mly"
            ( _1 )
# 5558 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1235 "parsing_c/parser_c.mly"
            ( _1 )
# 5565 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1236 "parsing_c/parser_c.mly"
            ( _1 )
# 5572 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 1238 "parsing_c/parser_c.mly"
                 ( snd _1 )
# 5579 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1240 "parsing_c/parser_c.mly"
            ( _1 )
# 5586 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1241 "parsing_c/parser_c.mly"
            ( _1 )
# 5593 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * (Ast_c.sign * Ast_c.base)) * Ast_c.info) in
    Obj.repr(
# 1242 "parsing_c/parser_c.mly"
            ( snd _1 )
# 5600 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.floatType) * Ast_c.info) in
    Obj.repr(
# 1243 "parsing_c/parser_c.mly"
            ( snd _1 )
# 5607 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.isWchar) * Ast_c.info) in
    Obj.repr(
# 1244 "parsing_c/parser_c.mly"
            ( snd _1 )
# 5614 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.isWchar) * Ast_c.info) in
    Obj.repr(
# 1245 "parsing_c/parser_c.mly"
            ( snd _1 )
# 5621 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1256 "parsing_c/parser_c.mly"
                        ( Right3 (BaseType Void),            [_1] )
# 5628 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1257 "parsing_c/parser_c.mly"
                        ( Right3 (BaseType (IntType CChar)), [_1])
# 5635 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1258 "parsing_c/parser_c.mly"
                        ( Right3 (BaseType (IntType (Si (Signed,CInt)))), [_1])
# 5642 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1259 "parsing_c/parser_c.mly"
                        ( Right3 (BaseType (FloatType CFloat)),  [_1])
# 5649 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1260 "parsing_c/parser_c.mly"
                        ( Right3 (BaseType (FloatType CDouble)), [_1] )
# 5656 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1261 "parsing_c/parser_c.mly"
                        ( Right3 (BaseType (FloatType CFloatComplex)),  [_1;_2])
# 5664 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1262 "parsing_c/parser_c.mly"
                        ( Right3 (BaseType (FloatType CDoubleComplex)), [_1;_2] )
# 5672 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1263 "parsing_c/parser_c.mly"
                        ( Right3 (BaseType SizeType),            [_1] )
# 5679 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1264 "parsing_c/parser_c.mly"
                        ( Right3 (BaseType SSizeType),           [_1] )
# 5686 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1265 "parsing_c/parser_c.mly"
                        ( Right3 (BaseType PtrDiffType),         [_1] )
# 5693 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1266 "parsing_c/parser_c.mly"
                        ( Middle3 Short,  [_1])
# 5700 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1267 "parsing_c/parser_c.mly"
                        ( Middle3 Long,   [_1])
# 5707 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1268 "parsing_c/parser_c.mly"
                        ( Left3 Signed,   [_1])
# 5714 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1269 "parsing_c/parser_c.mly"
                        ( Left3 UnSigned, [_1])
# 5721 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'struct_or_union_spec) in
    Obj.repr(
# 1270 "parsing_c/parser_c.mly"
                        ( Right3 (fst _1), snd _1 )
# 5728 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'enum_spec) in
    Obj.repr(
# 1271 "parsing_c/parser_c.mly"
                        ( Right3 (fst _1), snd _1 )
# 5735 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : 'const_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1273 "parsing_c/parser_c.mly"
     ( Right3 (Decimal(_3,Some _5)), [_1;_2;_4;_6] )
# 5747 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1275 "parsing_c/parser_c.mly"
     ( Right3 (Decimal(_3,None)), [_1;_2;_4] )
# 5757 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1276 "parsing_c/parser_c.mly"
             (
     let can_auto_type =
      let open Flag in
       match !c_plus_plus with
         Off -> false
       | On None -> true
       | On (Some i) -> i >= 2011
     in
     if can_auto_type
     then (Right3 AutoType, [_1])
     else
       let i = Ast_c.parse_info_of_info _1 in
       raise (Semantic("auto is not a valid C type, try using the --c++ option",
                       i)) )
# 5777 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 1305 "parsing_c/parser_c.mly"
     ( let name = RegularName (mk_string_wrap _1) in
       Right3 (TypeName (name, Ast_c.noTypedefDef())),[] )
# 5785 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'assign_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1308 "parsing_c/parser_c.mly"
                                   ( Right3 (TypeOfExpr (_3)), [_1;_2;_4] )
# 5795 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.attribute list * Ast_c.fullType) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1310 "parsing_c/parser_c.mly"
     ( let ret = Right3 (TypeOfType (snd _3)), [_1;_2;_4] in
       match (fst _3) with (* warn about dropped attributes *)
         [] -> ret
       | _ -> warning "attributes found in typeof(...), dropping" ret )
# 5808 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_spec2) in
    Obj.repr(
# 1319 "parsing_c/parser_c.mly"
                         ( dt "type" (); _1   )
# 5815 "parsing_c/parser_c.ml"
               : 'type_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1326 "parsing_c/parser_c.mly"
             ( {const=true  ; volatile=false}, _1 )
# 5822 "parsing_c/parser_c.ml"
               : 'type_qualif))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1327 "parsing_c/parser_c.mly"
             ( {const=false ; volatile=true},  _1 )
# 5829 "parsing_c/parser_c.ml"
               : 'type_qualif))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1329 "parsing_c/parser_c.mly"
             ( (* TODO *) {const=false ; volatile=false},  _1 )
# 5836 "parsing_c/parser_c.ml"
               : 'type_qualif))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'attribute_gcc) in
    Obj.repr(
# 1337 "parsing_c/parser_c.mly"
                 ( _1 )
# 5843 "parsing_c/parser_c.ml"
               : 'attribute))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'attr_arg) in
    Obj.repr(
# 1339 "parsing_c/parser_c.mly"
            ( Attribute _1, [] )
# 5850 "parsing_c/parser_c.ml"
               : 'attribute))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 1342 "parsing_c/parser_c.mly"
              ( MacroAttr (fst _1), [snd _1] )
# 5857 "parsing_c/parser_c.ml"
               : 'attr_arg))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : (string * Ast_c.info)) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'argument_list_ne) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1344 "parsing_c/parser_c.mly"
     ( MacroAttrArgs (fst _1,_3),[snd _1;_2;_4] )
# 5867 "parsing_c/parser_c.ml"
               : 'attr_arg))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'tdouble_opar_gcc_attr) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'attr_arg_gcc) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tdouble_cpar_gcc_attr) in
    Obj.repr(
# 1347 "parsing_c/parser_c.mly"
                                                                       ( GccAttribute _3, [_1]@_2@_4 )
# 5877 "parsing_c/parser_c.ml"
               : 'attribute_gcc))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 1350 "parsing_c/parser_c.mly"
          ( MacroAttr (fst _1), [snd _1] )
# 5884 "parsing_c/parser_c.ml"
               : 'attr_arg_gcc))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'pointer) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'direct_d) in
    Obj.repr(
# 1365 "parsing_c/parser_c.mly"
                    ( let (attr,ptr) = _1 in
                      (attr, (fst _2, fun x -> x +> ptr +> (snd _2))) )
# 5893 "parsing_c/parser_c.ml"
               : 'declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'direct_d) in
    Obj.repr(
# 1367 "parsing_c/parser_c.mly"
                    ( (Ast_c.noattr, _1)  )
# 5900 "parsing_c/parser_c.ml"
               : 'declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'tmul) in
    Obj.repr(
# 1371 "parsing_c/parser_c.mly"
                          ( (Ast_c.noattr,fun x -> mk_ty (Pointer x) [_1]) )
# 5907 "parsing_c/parser_c.ml"
               : 'pointer))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'tmul) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'pointer) in
    Obj.repr(
# 1373 "parsing_c/parser_c.mly"
     ( let (attr,ptr) = _2 in
       (attr,fun x -> ptr (mk_ty (Pointer x) [_1])) )
# 5916 "parsing_c/parser_c.ml"
               : 'pointer))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'tmul) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'type_qualif_list) in
    Obj.repr(
# 1376 "parsing_c/parser_c.mly"
     ( let (attr,tq) = _2 in
       (attr,fun x -> (tq.qualifD, mk_tybis (Pointer x) [_1])))
# 5925 "parsing_c/parser_c.ml"
               : 'pointer))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'tmul) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'type_qualif_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'pointer) in
    Obj.repr(
# 1379 "parsing_c/parser_c.mly"
     ( let (attr1,tq) = _2 in
       let (attr2,ptr) = _3 in
       (attr1@attr2,fun x -> ptr (tq.qualifD, mk_tybis (Pointer x) [_1])) )
# 5936 "parsing_c/parser_c.ml"
               : 'pointer))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1384 "parsing_c/parser_c.mly"
        ( _1 )
# 5943 "parsing_c/parser_c.ml"
               : 'tmul))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1386 "parsing_c/parser_c.mly"
     ( if !Flag.c_plus_plus <> Flag.Off
     then _1
     else
       let i = Ast_c.parse_info_of_info _1 in
       raise (Semantic("& not allowed in C types, try -c++ option", i)) )
# 5954 "parsing_c/parser_c.ml"
               : 'tmul))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'identifier_cpp) in
    Obj.repr(
# 1395 "parsing_c/parser_c.mly"
     ( (_1, fun x -> x) )
# 5961 "parsing_c/parser_c.ml"
               : 'direct_d))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'declarator) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1397 "parsing_c/parser_c.mly"
     ( let (attr,dec) = _2 in  (* attr gets ignored... *)
       (fst dec, fun x -> mk_ty (ParenType ((snd dec) x)) [_1;_3]) )
# 5971 "parsing_c/parser_c.ml"
               : 'direct_d))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'direct_d) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'tocro) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'tccro) in
    Obj.repr(
# 1400 "parsing_c/parser_c.mly"
     ( (fst _1,fun x->(snd _1) (mk_ty (Array (None,x)) [_2;_3])) )
# 5980 "parsing_c/parser_c.ml"
               : 'direct_d))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'direct_d) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'tocro) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tccro) in
    Obj.repr(
# 1402 "parsing_c/parser_c.mly"
     ( (fst _1,fun x->(snd _1) (mk_ty (Array (Some _3,x)) [_2;_4])) )
# 5990 "parsing_c/parser_c.ml"
               : 'direct_d))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'direct_d) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'topar) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 1404 "parsing_c/parser_c.mly"
     ( (fst _1,
       fun x->(snd _1)
         (mk_ty (FunctionType (x,(([],(false, []))))) [_2;_3]))
     )
# 6002 "parsing_c/parser_c.ml"
               : 'direct_d))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'direct_d) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'topar) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'parameter_type_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 1409 "parsing_c/parser_c.mly"
     ( (fst _1,fun x->(snd _1)
       (mk_ty (FunctionType (x, _3)) [_2;_4]))
     )
# 6014 "parsing_c/parser_c.ml"
               : 'direct_d))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1418 "parsing_c/parser_c.mly"
             ( et "tocro" ();_1 )
# 6021 "parsing_c/parser_c.ml"
               : 'tocro))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1419 "parsing_c/parser_c.mly"
             ( dt "tccro" ();_1 )
# 6028 "parsing_c/parser_c.ml"
               : 'tccro))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'pointer) in
    Obj.repr(
# 1423 "parsing_c/parser_c.mly"
                                      ( _1 )
# 6035 "parsing_c/parser_c.ml"
               : 'abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'direct_abstract_declarator) in
    Obj.repr(
# 1424 "parsing_c/parser_c.mly"
                                      ( ([], _1) )
# 6042 "parsing_c/parser_c.ml"
               : 'abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'pointer) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'direct_abstract_declarator) in
    Obj.repr(
# 1426 "parsing_c/parser_c.mly"
     ( (fst _1, fun x -> x +> _2 +> (snd _1)) )
# 6050 "parsing_c/parser_c.ml"
               : 'abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'abstract_declarator) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1430 "parsing_c/parser_c.mly"
     ( fun x -> mk_ty (ParenType ((snd _2) x)) [_1;_3] )
# 6059 "parsing_c/parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1433 "parsing_c/parser_c.mly"
     ( fun x -> mk_ty (Array (None, x)) [_1;_2] )
# 6067 "parsing_c/parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1435 "parsing_c/parser_c.mly"
     ( fun x -> mk_ty (Array (Some _2, x)) [_1;_3] )
# 6076 "parsing_c/parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'direct_abstract_declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1437 "parsing_c/parser_c.mly"
     ( fun x -> _1 (mk_ty (Array (None, x))  [_2;_3]) )
# 6085 "parsing_c/parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'direct_abstract_declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1439 "parsing_c/parser_c.mly"
     ( fun x -> _1 (mk_ty (Array (Some _3,x))  [_2;_4]) )
# 6095 "parsing_c/parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1441 "parsing_c/parser_c.mly"
     ( fun x -> mk_ty (FunctionType (x, ([], (false,  [])))) [_1;_2] )
# 6103 "parsing_c/parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'topar) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'parameter_type_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 1443 "parsing_c/parser_c.mly"
     ( fun x -> mk_ty (FunctionType (x, _2))  [_1;_3] )
# 6112 "parsing_c/parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'direct_abstract_declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'topar) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 1454 "parsing_c/parser_c.mly"
     ( fun x -> _1 (mk_ty (FunctionType (x, (([], (false, []))))) [_2;_3]) )
# 6121 "parsing_c/parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'direct_abstract_declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'topar) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'parameter_type_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 1456 "parsing_c/parser_c.mly"
     ( fun x -> _1 (mk_ty (FunctionType (x, _3)) [_2;_4]) )
# 6131 "parsing_c/parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_list) in
    Obj.repr(
# 1462 "parsing_c/parser_c.mly"
                                   ( (_1, (false, [])))
# 6138 "parsing_c/parser_c.ml"
               : 'parameter_type_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'parameter_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1463 "parsing_c/parser_c.mly"
                                   ( (_1, (true,  [_2;_3])) )
# 6147 "parsing_c/parser_c.ml"
               : 'parameter_type_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 1467 "parsing_c/parser_c.mly"
            (
     let name = RegularName (mk_string_wrap _1) in
     LP.add_ident (str_of_name name);
     { p_namei = Some name;
       p_type = mk_ty NoType [];
       p_register = (false, []);
       p_attr = [];
       p_midattr = [];
       p_endattr = [];
     }
   )
# 6164 "parsing_c/parser_c.ml"
               : 'parameter_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'decl_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'declaratorp) in
    Obj.repr(
# 1479 "parsing_c/parser_c.mly"
     ( LP.kr_impossible();
       let ((returnType,hasreg),iihasreg) = fixDeclSpecForParam (snd _1) in
       let attrs = (fst (fst _1)) in
       let midattrs = (snd (fst _1)) in
       let endattrs = (fst _2) in
       let (name, ftyp) = snd _2 in
       { p_namei = Some (name);
         p_type = ftyp returnType;
         p_register = (hasreg, iihasreg);
         p_attr = attrs;
         p_midattr = midattrs;
         p_endattr = endattrs;
       }
     )
# 6185 "parsing_c/parser_c.ml"
               : 'parameter_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'decl_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'abstract_declaratorp) in
    Obj.repr(
# 1494 "parsing_c/parser_c.mly"
     ( LP.kr_impossible();
       let ((returnType,hasreg), iihasreg) = fixDeclSpecForParam (snd _1) in
       let attrs = (fst (fst _1)) in
       let midattrs = (snd (fst _1)) in
       let endattrs = (fst _2) in
       { p_namei = None;
         p_type = (snd _2) returnType;
         p_register = hasreg, iihasreg;
         p_attr = attrs;
         p_midattr = midattrs;
         p_endattr = endattrs;
       }
     )
# 6205 "parsing_c/parser_c.ml"
               : 'parameter_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec) in
    Obj.repr(
# 1508 "parsing_c/parser_c.mly"
     ( let ((returnType,hasreg), iihasreg) = fixDeclSpecForParam (snd _1) in
       { p_namei = None;
         p_type = returnType;
         p_register = hasreg, iihasreg;
         p_attr = (fst (fst _1));
         p_midattr = [];
         p_endattr = (snd (fst _1));
       }
     )
# 6220 "parsing_c/parser_c.ml"
               : 'parameter_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 1519 "parsing_c/parser_c.mly"
            (
     let name = RegularName (mk_string_wrap _1) in
     LP.add_ident (str_of_name name);
     { p_namei = Some name;
       p_type = mk_ty NoType [];
       p_register = (false, []);
       p_attr = [];
       p_midattr = [];
       p_endattr = [];
     }
   )
# 6237 "parsing_c/parser_c.ml"
               : 'parameter_decl_arg))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'decl_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'declaratorp) in
    Obj.repr(
# 1531 "parsing_c/parser_c.mly"
     ( LP.kr_impossible();
       let ((returnType,hasreg),iihasreg) = fixDeclSpecForArg (snd _1) in
       let attrs = (fst (fst _1)) in
       let midattrs = (snd (fst _1)) in
       let endattrs = (fst _2) in
       let (name, ftyp) = snd _2 in
       { p_namei = Some (name);
         p_type = ftyp returnType;
         p_register = (hasreg, iihasreg);
         p_attr = attrs;
         p_midattr = midattrs;
         p_endattr = endattrs;
       }
     )
# 6258 "parsing_c/parser_c.ml"
               : 'parameter_decl_arg))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'decl_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'abstract_declaratorp) in
    Obj.repr(
# 1546 "parsing_c/parser_c.mly"
     ( LP.kr_impossible();
       let ((returnType,hasreg), iihasreg) = fixDeclSpecForArg (snd _1) in
       let attrs = (fst (fst _1)) in
       let midattrs = (snd (fst _1)) in
       let endattrs = (fst _2) in
       { p_namei = None;
         p_type = snd _2 returnType;
         p_register = hasreg, iihasreg;
         p_attr = attrs;
         p_midattr = midattrs;
         p_endattr = endattrs;
       }
     )
# 6278 "parsing_c/parser_c.ml"
               : 'parameter_decl_arg))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec) in
    Obj.repr(
# 1560 "parsing_c/parser_c.mly"
     ( let ((returnType,hasreg), iihasreg) = fixDeclSpecForArg (snd _1) in
       { p_namei = None;
         p_type = returnType;
         p_register = hasreg, iihasreg;
         p_attr = (fst (fst _1));
         p_midattr = [];
         p_endattr = (snd (fst _1));
       }
     )
# 6293 "parsing_c/parser_c.ml"
               : 'parameter_decl_arg))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_decl2) in
    Obj.repr(
# 1575 "parsing_c/parser_c.mly"
                                ( et "param" ();  _1 )
# 6300 "parsing_c/parser_c.ml"
               : 'parameter_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'declarator) in
    Obj.repr(
# 1578 "parsing_c/parser_c.mly"
               ( let (attr,dec) = _1 in
                 LP.add_ident (str_of_name (fst dec)); attr, dec )
# 6308 "parsing_c/parser_c.ml"
               : 'declaratorp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attributes) in
    Obj.repr(
# 1582 "parsing_c/parser_c.mly"
               ( let (attr,dec) = _1 in
                 let attr = attr @ _2 in
                 LP.add_ident (str_of_name (fst dec)); attr, dec )
# 6318 "parsing_c/parser_c.ml"
               : 'declaratorp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'abstract_declarator) in
    Obj.repr(
# 1587 "parsing_c/parser_c.mly"
                       ( _1 )
# 6325 "parsing_c/parser_c.ml"
               : 'abstract_declaratorp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_spec) in
    Obj.repr(
# 1597 "parsing_c/parser_c.mly"
                                ( ([], addTypeD (_1, nullDecl)) )
# 6332 "parsing_c/parser_c.ml"
               : 'spec_qualif_list2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_qualif) in
    Obj.repr(
# 1598 "parsing_c/parser_c.mly"
                                ( ([], {nullDecl with qualifD = (fst _1,[snd _1])}))
# 6339 "parsing_c/parser_c.ml"
               : 'spec_qualif_list2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'attribute) in
    Obj.repr(
# 1599 "parsing_c/parser_c.mly"
                                ( ([_1], nullDecl) )
# 6346 "parsing_c/parser_c.ml"
               : 'spec_qualif_list2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'spec_qualif_list) in
    Obj.repr(
# 1600 "parsing_c/parser_c.mly"
                                ( (fst _2, addTypeD (_1,snd _2)) )
# 6354 "parsing_c/parser_c.ml"
               : 'spec_qualif_list2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_qualif) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'spec_qualif_list) in
    Obj.repr(
# 1601 "parsing_c/parser_c.mly"
                                ( (fst _2, addQualifD (_1,snd _2)) )
# 6362 "parsing_c/parser_c.ml"
               : 'spec_qualif_list2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'attribute) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'spec_qualif_list) in
    Obj.repr(
# 1602 "parsing_c/parser_c.mly"
                                ( ([_1]@(fst _2), snd _2) )
# 6370 "parsing_c/parser_c.ml"
               : 'spec_qualif_list2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'spec_qualif_list2) in
    Obj.repr(
# 1604 "parsing_c/parser_c.mly"
                                               (  dt "spec_qualif" (); _1 )
# 6377 "parsing_c/parser_c.ml"
               : 'spec_qualif_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_qualif) in
    Obj.repr(
# 1609 "parsing_c/parser_c.mly"
               ( (Ast_c.noattr,{nullDecl with qualifD = (fst _1,[snd _1])}) )
# 6384 "parsing_c/parser_c.ml"
               : 'type_qualif_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'attribute) in
    Obj.repr(
# 1610 "parsing_c/parser_c.mly"
                                ( ([_1],nullDecl) )
# 6391 "parsing_c/parser_c.ml"
               : 'type_qualif_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_qualif_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'type_qualif) in
    Obj.repr(
# 1611 "parsing_c/parser_c.mly"
                                ( (fst _1,addQualifD (_2,snd _1)) )
# 6399 "parsing_c/parser_c.ml"
               : 'type_qualif_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_qualif_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attribute) in
    Obj.repr(
# 1612 "parsing_c/parser_c.mly"
                                ( ((fst _1)@[_2],snd _1) )
# 6407 "parsing_c/parser_c.ml"
               : 'type_qualif_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'spec_qualif_list) in
    Obj.repr(
# 1620 "parsing_c/parser_c.mly"
     ( let (attrs, ds) = _1 in
       let (returnType, _) = fixDeclSpecForDecl ds in (attrs, returnType) )
# 6415 "parsing_c/parser_c.ml"
               : Ast_c.attribute list * Ast_c.fullType))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'spec_qualif_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'abstract_declaratort) in
    Obj.repr(
# 1623 "parsing_c/parser_c.mly"
     ( let (attrs1, ds) = _1 in
       let (attrs2, fn) = _2 in
       let (returnType, _) = fixDeclSpecForDecl ds in
       (attrs1@attrs2, fn returnType) )
# 6426 "parsing_c/parser_c.ml"
               : Ast_c.attribute list * Ast_c.fullType))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'abstract_declarator) in
    Obj.repr(
# 1631 "parsing_c/parser_c.mly"
                       ( _1 )
# 6433 "parsing_c/parser_c.ml"
               : 'abstract_declaratort))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'decl_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'end_attributes_opt) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1641 "parsing_c/parser_c.mly"
     ( function local ->
       let (returnType,storage) = fixDeclSpecForDecl (snd _1) in
       let iistart = Ast_c.fakeInfo () in
       DeclList ([{v_namei = None; v_type = returnType;
                   v_storage = unwrap storage; v_local = local;
                   v_attr = fst (fst _1); v_midattr = snd (fst _1);
                   v_endattr = _2; v_type_bis = ref None;
                },[]],
                (_3::iistart::snd storage))
     )
# 6451 "parsing_c/parser_c.ml"
               : 'decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'decl_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'init_declarator_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1652 "parsing_c/parser_c.mly"
     ( function local ->
       let (returnType,storage) = fixDeclSpecForDecl (snd _1) in
       let iistart = Ast_c.fakeInfo () in
       DeclList (
         (_2 +> List.map (fun ((((name,f),attrs,endattrs), ini), iivirg) ->
           let s = str_of_name name in
	   if fst (unwrap storage) = StoTypedef
	   then LP.add_typedef s;
           {v_namei = Some (name, ini);
            v_type = f returnType;
            v_storage = unwrap storage;
            v_local = local;
            v_attr = (fst (fst _1));
            v_midattr = (snd (fst _1))@attrs;
            v_endattr = endattrs;
            v_type_bis = ref None;
           },
           iivirg
         )
         ),  (_3::iistart::snd storage))
     )
# 6480 "parsing_c/parser_c.ml"
               : 'decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : 'storage_const_opt) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : (string * Ast_c.info)) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : 'argument_list) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : 'end_attributes_opt) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1677 "parsing_c/parser_c.mly"
     ( function _ ->
       match _1 with
	 Some (sto,stoii) ->
	   MacroDecl
	     ((sto, fst _2, _4, _6, true),
              (snd _2::_3::_5::_7::fakeInfo()::stoii))
       | None ->
	   MacroDecl
	     ((NoSto, fst _2, _4, _6, true),
              [snd _2;_3;_5;_7;fakeInfo()]) )
# 6502 "parsing_c/parser_c.ml"
               : 'decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 7 : 'storage_const_opt) in
    let _2 = (Parsing.peek_val __caml_parser_env 6 : (string * Ast_c.info)) in
    let _3 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 4 : 'argument_list) in
    let _5 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 2 : 'teq) in
    let _7 = (Parsing.peek_val __caml_parser_env 1 : 'initialize) in
    let _8 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1690 "parsing_c/parser_c.mly"
     ( function _ ->
       match _1 with
	 Some (sto,stoii) ->
	   MacroDeclInit
	     ((sto, fst _2, _4, _7),
	      (snd _2::_3::_5::_6::_8::fakeInfo()::stoii))
       | None ->
	   MacroDeclInit
	     ((NoSto, fst _2, _4, _7), [snd _2;_3;_5;_6;_8;fakeInfo()]) )
# 6524 "parsing_c/parser_c.ml"
               : 'decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'storage_class_spec_nt) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1701 "parsing_c/parser_c.mly"
                                         ( Some (fst _1,[snd _1; _2]) )
# 6532 "parsing_c/parser_c.ml"
               : 'storage_const_opt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'storage_class_spec_nt) in
    Obj.repr(
# 1702 "parsing_c/parser_c.mly"
                         ( Some (fst _1,[snd _1]) )
# 6539 "parsing_c/parser_c.ml"
               : 'storage_const_opt))
; (fun __caml_parser_env ->
    Obj.repr(
# 1703 "parsing_c/parser_c.mly"
                         ( None )
# 6545 "parsing_c/parser_c.ml"
               : 'storage_const_opt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'storage_class_spec) in
    Obj.repr(
# 1707 "parsing_c/parser_c.mly"
                      ( (([],[]), {nullDecl with storageD = (fst _1, [snd _1]) }) )
# 6552 "parsing_c/parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_spec) in
    Obj.repr(
# 1708 "parsing_c/parser_c.mly"
                      ( (([],[]), addTypeD (_1,nullDecl)) )
# 6559 "parsing_c/parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_qualif) in
    Obj.repr(
# 1709 "parsing_c/parser_c.mly"
                      ( (([],[]), {nullDecl with qualifD  = (fst _1, [snd _1]) }) )
# 6566 "parsing_c/parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1710 "parsing_c/parser_c.mly"
                      ( (([],[]), {nullDecl with inlineD = (true, [_1]) }) )
# 6573 "parsing_c/parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'attribute) in
    Obj.repr(
# 1711 "parsing_c/parser_c.mly"
                      ( (([_1],[]), nullDecl) )
# 6580 "parsing_c/parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'storage_class_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec2) in
    Obj.repr(
# 1712 "parsing_c/parser_c.mly"
                                 ( (fst _2, addStorageD (_1, snd _2)) )
# 6588 "parsing_c/parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_qualif) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec2) in
    Obj.repr(
# 1713 "parsing_c/parser_c.mly"
                                 ( (fst _2, addQualifD  (_1, snd _2)) )
# 6596 "parsing_c/parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec2) in
    Obj.repr(
# 1714 "parsing_c/parser_c.mly"
                                 ( (fst _2, addInlineD ((true, _1), snd _2)) )
# 6604 "parsing_c/parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'attribute) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec2) in
    Obj.repr(
# 1715 "parsing_c/parser_c.mly"
                                 ( ((_1::(fst (fst _2)),snd (fst _2)), snd _2) )
# 6612 "parsing_c/parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec2_after_type_spec) in
    Obj.repr(
# 1716 "parsing_c/parser_c.mly"
                                                 ( (fst _2, addTypeD    (_1, snd _2)) )
# 6620 "parsing_c/parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'storage_class_spec) in
    Obj.repr(
# 1719 "parsing_c/parser_c.mly"
                      ( (([],[]), {nullDecl with storageD = (fst _1, [snd _1]) }) )
# 6627 "parsing_c/parser_c.ml"
               : 'decl_spec2_after_type_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_spec) in
    Obj.repr(
# 1720 "parsing_c/parser_c.mly"
                      ( (([],[]), addTypeD (_1,nullDecl)) )
# 6634 "parsing_c/parser_c.ml"
               : 'decl_spec2_after_type_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_qualif) in
    Obj.repr(
# 1721 "parsing_c/parser_c.mly"
                      ( (([],[]), {nullDecl with qualifD  = (fst _1, [snd _1]) }) )
# 6641 "parsing_c/parser_c.ml"
               : 'decl_spec2_after_type_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1722 "parsing_c/parser_c.mly"
                      ( (([],[]), {nullDecl with inlineD = (true, [_1]) }) )
# 6648 "parsing_c/parser_c.ml"
               : 'decl_spec2_after_type_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'attribute) in
    Obj.repr(
# 1723 "parsing_c/parser_c.mly"
                      ( (([],[_1]), nullDecl) )
# 6655 "parsing_c/parser_c.ml"
               : 'decl_spec2_after_type_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'storage_class_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec2_after_type_spec) in
    Obj.repr(
# 1724 "parsing_c/parser_c.mly"
                                                 ( (fst _2, addStorageD (_1, snd _2)) )
# 6663 "parsing_c/parser_c.ml"
               : 'decl_spec2_after_type_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_qualif) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec2_after_type_spec) in
    Obj.repr(
# 1725 "parsing_c/parser_c.mly"
                                                 ( (fst _2, addQualifD  (_1, snd _2)) )
# 6671 "parsing_c/parser_c.ml"
               : 'decl_spec2_after_type_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec2_after_type_spec) in
    Obj.repr(
# 1726 "parsing_c/parser_c.mly"
                                                 ( (fst _2, addInlineD ((true, _1), snd _2)) )
# 6679 "parsing_c/parser_c.ml"
               : 'decl_spec2_after_type_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'attribute) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec2_after_type_spec) in
    Obj.repr(
# 1727 "parsing_c/parser_c.mly"
                                                 ( (((fst (fst _2)), _1::(snd (fst _2))), snd _2) )
# 6687 "parsing_c/parser_c.ml"
               : 'decl_spec2_after_type_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec2_after_type_spec) in
    Obj.repr(
# 1728 "parsing_c/parser_c.mly"
                                                 ( (fst _2, addTypeD    (_1, snd _2)) )
# 6695 "parsing_c/parser_c.ml"
               : 'decl_spec2_after_type_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1736 "parsing_c/parser_c.mly"
                ( Sto Static,  _1 )
# 6702 "parsing_c/parser_c.ml"
               : 'storage_class_spec_nt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1737 "parsing_c/parser_c.mly"
                ( Sto Extern,  _1 )
# 6709 "parsing_c/parser_c.ml"
               : 'storage_class_spec_nt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1739 "parsing_c/parser_c.mly"
     (
      let can_auto_storage =
        let open Flag in
        match !c_plus_plus with
          Off | On None -> true
        | On (Some i) -> i < 2011
      in
      if can_auto_storage
      then (Sto Auto, _1)
      else
        let i = Ast_c.parse_info_of_info _1 in
        raise
          (Semantic
            ("auto is not a valid storage since C++11, \
              try removing the version specification on the --c++ option \
              or removing the whole option",
             i))
     )
# 6733 "parsing_c/parser_c.ml"
               : 'storage_class_spec_nt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1757 "parsing_c/parser_c.mly"
                ( Sto Register,_1 )
# 6740 "parsing_c/parser_c.ml"
               : 'storage_class_spec_nt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'storage_class_spec_nt) in
    Obj.repr(
# 1760 "parsing_c/parser_c.mly"
                         ( _1 )
# 6747 "parsing_c/parser_c.ml"
               : 'storage_class_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1761 "parsing_c/parser_c.mly"
                ( StoTypedef,  _1 )
# 6754 "parsing_c/parser_c.ml"
               : 'storage_class_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl2) in
    Obj.repr(
# 1768 "parsing_c/parser_c.mly"
                         ( et "decl" (); _1 )
# 6761 "parsing_c/parser_c.ml"
               : 'decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec2) in
    Obj.repr(
# 1769 "parsing_c/parser_c.mly"
                         ( dt "declspec" (); _1  )
# 6768 "parsing_c/parser_c.ml"
               : 'decl_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'declaratori) in
    Obj.repr(
# 1775 "parsing_c/parser_c.mly"
                                ( (_1, NoInit) )
# 6775 "parsing_c/parser_c.ml"
               : 'init_declarator2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'declaratori) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'teq) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'initialize) in
    Obj.repr(
# 1776 "parsing_c/parser_c.mly"
                                ( (_1, ValInit(_2, _3)) )
# 6784 "parsing_c/parser_c.ml"
               : 'init_declarator2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'declaratori) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'argument_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1779 "parsing_c/parser_c.mly"
     ( (_1, ConstrInit(_3,[_2;_4])) )
# 6794 "parsing_c/parser_c.ml"
               : 'init_declarator2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'declaratori) in
    Obj.repr(
# 1789 "parsing_c/parser_c.mly"
                                ( (_1, NoInit) )
# 6801 "parsing_c/parser_c.ml"
               : 'init_declarator_attrs2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'attributes) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'declaratori) in
    Obj.repr(
# 1790 "parsing_c/parser_c.mly"
                                ( (_2, NoInit) )
# 6809 "parsing_c/parser_c.ml"
               : 'init_declarator_attrs2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'declaratori) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'teq) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'initialize) in
    Obj.repr(
# 1791 "parsing_c/parser_c.mly"
                                ( (_1, ValInit(_2, _3)) )
# 6818 "parsing_c/parser_c.ml"
               : 'init_declarator_attrs2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'attributes) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'declaratori) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'teq) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'initialize) in
    Obj.repr(
# 1792 "parsing_c/parser_c.mly"
                                           ( (_2, ValInit(_3, _4)) )
# 6828 "parsing_c/parser_c.ml"
               : 'init_declarator_attrs2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'declaratori) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'argument_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1795 "parsing_c/parser_c.mly"
     ( (_1, ConstrInit(_3,[_2;_4])) )
# 6838 "parsing_c/parser_c.ml"
               : 'init_declarator_attrs2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : 'attributes) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : 'declaratori) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'argument_list) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1797 "parsing_c/parser_c.mly"
     ( (_2, ConstrInit(_4,[_3;_5])) )
# 6849 "parsing_c/parser_c.ml"
               : 'init_declarator_attrs2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1802 "parsing_c/parser_c.mly"
          ( et "teq" (); _1 )
# 6856 "parsing_c/parser_c.ml"
               : 'teq))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'init_declarator2) in
    Obj.repr(
# 1804 "parsing_c/parser_c.mly"
                                   ( dt "init" (); _1 )
# 6863 "parsing_c/parser_c.ml"
               : 'init_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'init_declarator_attrs2) in
    Obj.repr(
# 1806 "parsing_c/parser_c.mly"
                                              ( dt "init_attrs" (); _1 )
# 6870 "parsing_c/parser_c.ml"
               : 'init_declarator_attrs))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'declarator) in
    Obj.repr(
# 1815 "parsing_c/parser_c.mly"
     ( let (attr,dec) = _1 in
       LP.add_ident (str_of_name (fst dec)); dec, attr, [] )
# 6878 "parsing_c/parser_c.ml"
               : 'declaratori))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'gcc_asm_decl) in
    Obj.repr(
# 1819 "parsing_c/parser_c.mly"
     ( let (attr,dec) = _1 in
       LP.add_ident (str_of_name (fst dec)); dec, attr, [] )
# 6887 "parsing_c/parser_c.ml"
               : 'declaratori))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'end_attributes) in
    Obj.repr(
# 1823 "parsing_c/parser_c.mly"
     ( let (attr,dec) = _1 in
       LP.add_ident (str_of_name (fst dec)); dec, attr, _2 (* TODO *) )
# 6896 "parsing_c/parser_c.ml"
               : 'declaratori))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'asmbody) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1828 "parsing_c/parser_c.mly"
                                         (  )
# 6906 "parsing_c/parser_c.ml"
               : 'gcc_asm_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'asmbody) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1829 "parsing_c/parser_c.mly"
                                        (  )
# 6917 "parsing_c/parser_c.ml"
               : 'gcc_asm_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 1835 "parsing_c/parser_c.mly"
     ( InitExpr _1,                [] )
# 6924 "parsing_c/parser_c.ml"
               : 'initialize))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'tobrace_ini) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'initialize_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'gcc_comma_opt_struct) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_ini) in
    Obj.repr(
# 1837 "parsing_c/parser_c.mly"
     ( InitList (List.rev _2),     [_1;_4] @ _3 )
# 6934 "parsing_c/parser_c.ml"
               : 'initialize))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'tobrace_ini) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_ini) in
    Obj.repr(
# 1839 "parsing_c/parser_c.mly"
     ( InitList [],       [_1;_2] )
# 6942 "parsing_c/parser_c.ml"
               : 'initialize))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'initialize2) in
    Obj.repr(
# 1850 "parsing_c/parser_c.mly"
                                      ( [_1,   []] )
# 6949 "parsing_c/parser_c.ml"
               : 'initialize_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'initialize_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'initialize2) in
    Obj.repr(
# 1851 "parsing_c/parser_c.mly"
                                      ( (_3,  [_2])::_1 )
# 6958 "parsing_c/parser_c.ml"
               : 'initialize_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cond_expr) in
    Obj.repr(
# 1857 "parsing_c/parser_c.mly"
     ( InitExpr _1,   [] )
# 6965 "parsing_c/parser_c.ml"
               : 'initialize2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'tobrace_ini) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'initialize_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'gcc_comma_opt_struct) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_ini) in
    Obj.repr(
# 1859 "parsing_c/parser_c.mly"
     ( InitList (List.rev _2),   [_1;_4] @ _3 )
# 6975 "parsing_c/parser_c.ml"
               : 'initialize2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'tobrace_ini) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_ini) in
    Obj.repr(
# 1861 "parsing_c/parser_c.mly"
     ( InitList [],  [_1;_2]  )
# 6983 "parsing_c/parser_c.ml"
               : 'initialize2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'designator_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'initialize2) in
    Obj.repr(
# 1865 "parsing_c/parser_c.mly"
     ( InitDesignators (_1, _3), [_2] )
# 6992 "parsing_c/parser_c.ml"
               : 'initialize2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'ident) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'initialize2) in
    Obj.repr(
# 1869 "parsing_c/parser_c.mly"
     ( InitFieldOld (fst _1, _3),     [snd _1; _2] )
# 7001 "parsing_c/parser_c.ml"
               : 'initialize2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'ident) in
    Obj.repr(
# 1880 "parsing_c/parser_c.mly"
     ( DesignatorField (fst _2), [_1;snd _2] )
# 7009 "parsing_c/parser_c.ml"
               : 'designator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1882 "parsing_c/parser_c.mly"
     ( DesignatorIndex (_2),  [_1;_3] )
# 7018 "parsing_c/parser_c.ml"
               : 'designator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : 'const_expr) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1884 "parsing_c/parser_c.mly"
     ( DesignatorRange (_2, _4),  [_1;_3;_5] )
# 7029 "parsing_c/parser_c.ml"
               : 'designator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1892 "parsing_c/parser_c.mly"
          (  [_1] )
# 7036 "parsing_c/parser_c.ml"
               : 'gcc_comma_opt_struct))
; (fun __caml_parser_env ->
    Obj.repr(
# 1893 "parsing_c/parser_c.mly"
                    (  [Ast_c.fakeInfo() +> Ast_c.rewrap_str ","]  )
# 7042 "parsing_c/parser_c.ml"
               : 'gcc_comma_opt_struct))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : 'struct_or_union) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : 'ident) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'tobrace_struct) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'struct_decl_list_gcc) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_struct) in
    Obj.repr(
# 1908 "parsing_c/parser_c.mly"
     ( StructUnion (fst _1, Some (fst _2), _4),  [snd _1;snd _2;_3;_5]  )
# 7053 "parsing_c/parser_c.ml"
               : 's_or_u_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'struct_or_union) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'tobrace_struct) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'struct_decl_list_gcc) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_struct) in
    Obj.repr(
# 1910 "parsing_c/parser_c.mly"
     ( StructUnion (fst _1, None, _3), [snd _1;_2;_4] )
# 7063 "parsing_c/parser_c.ml"
               : 's_or_u_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'struct_or_union) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'ident) in
    Obj.repr(
# 1912 "parsing_c/parser_c.mly"
     ( StructUnionName (fst _1, fst _2), [snd _1;snd _2] )
# 7071 "parsing_c/parser_c.ml"
               : 's_or_u_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1915 "parsing_c/parser_c.mly"
             ( Struct, _1 )
# 7078 "parsing_c/parser_c.ml"
               : 'struct_or_union2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1916 "parsing_c/parser_c.mly"
             ( Union, _1 )
# 7085 "parsing_c/parser_c.ml"
               : 'struct_or_union2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attributes) in
    Obj.repr(
# 1918 "parsing_c/parser_c.mly"
                        ( Struct, _1 (* TODO *) )
# 7093 "parsing_c/parser_c.ml"
               : 'struct_or_union2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attributes) in
    Obj.repr(
# 1919 "parsing_c/parser_c.mly"
                        ( Union, _1  (* TODO *) )
# 7101 "parsing_c/parser_c.ml"
               : 'struct_or_union2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'field_declaration) in
    Obj.repr(
# 1924 "parsing_c/parser_c.mly"
                     ( DeclarationField _1 )
# 7108 "parsing_c/parser_c.ml"
               : 'struct_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1925 "parsing_c/parser_c.mly"
           ( EmptyField _1  )
# 7115 "parsing_c/parser_c.ml"
               : 'struct_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : 'identifier) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1931 "parsing_c/parser_c.mly"
     ( MacroDeclField ((fst _1, _3), [snd _1;_2;_4;_5;fakeInfo()]) )
# 7126 "parsing_c/parser_c.ml"
               : 'struct_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : (string * Ast_c.info)) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1934 "parsing_c/parser_c.mly"
     ( MacroDeclField ((fst _1, _3), [snd _1;_2;_4;_5;fakeInfo()]) )
# 7137 "parsing_c/parser_c.ml"
               : 'struct_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.cpp_directive) in
    Obj.repr(
# 1938 "parsing_c/parser_c.mly"
     ( CppDirectiveStruct _1 )
# 7144 "parsing_c/parser_c.ml"
               : 'struct_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_directive) in
    Obj.repr(
# 1940 "parsing_c/parser_c.mly"
     ( IfdefStruct _1 )
# 7151 "parsing_c/parser_c.ml"
               : 'struct_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'spec_qualif_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'struct_declarator_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'end_attributes_opt) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1945 "parsing_c/parser_c.mly"
     (
       let (attrs, ds) = _1 in
       let (returnType,storage) = fixDeclSpecForDecl ds in
       if fst (unwrap storage) <> NoSto
       then internal_error "parsing don't allow this";

       let iistart = Ast_c.fakeInfo () in (* for parallelism with DeclList *)
       FieldDeclList (_2 +> (List.map (fun (f, iivirg) ->
         f returnType, iivirg))
                         ,[_4;iistart])
         (* don't need to check if typedef or func initialised cos
          * grammar don't allow typedef nor initialiser in struct
          *)
     )
# 7174 "parsing_c/parser_c.ml"
               : 'field_declaration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'spec_qualif_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'end_attributes_opt) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1961 "parsing_c/parser_c.mly"
     (
       let (attrs, ds) = _1 in
       (* gccext: allow empty elements if it is a structdef or enumdef *)
       let (returnType,storage) = fixDeclSpecForDecl ds in
       if fst (unwrap storage) <> NoSto
       then internal_error "parsing don't allow this";

       let iistart = Ast_c.fakeInfo () in (* for parallelism with DeclList *)
       FieldDeclList ([(Simple (None, returnType)) , []], [_3;iistart])
     )
# 7192 "parsing_c/parser_c.ml"
               : 'field_declaration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'declaratorsd) in
    Obj.repr(
# 1978 "parsing_c/parser_c.mly"
     ( (fun x -> Simple   (Some (fst _1), (snd _1) x)) )
# 7199 "parsing_c/parser_c.ml"
               : 'struct_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'dotdot) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'const_expr2) in
    Obj.repr(
# 1980 "parsing_c/parser_c.mly"
     ( (fun x -> BitField (None, x, _1, _2)) )
# 7207 "parsing_c/parser_c.ml"
               : 'struct_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'declaratorsd) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'dotdot) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'const_expr2) in
    Obj.repr(
# 1982 "parsing_c/parser_c.mly"
     ( (fun x -> BitField (Some (fst _1), ((snd _1) x), _2, _3)) )
# 7216 "parsing_c/parser_c.ml"
               : 'struct_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'declarator) in
    Obj.repr(
# 1990 "parsing_c/parser_c.mly"
     ( let (attr,dec) = _1 in (* attr ignored *)
       (*also ? LP.add_ident (fst (fst dec)); *) dec )
# 7224 "parsing_c/parser_c.ml"
               : 'declaratorsd))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attributes) in
    Obj.repr(
# 1993 "parsing_c/parser_c.mly"
                           ( let (attr,dec) = _1 in dec )
# 7232 "parsing_c/parser_c.ml"
               : 'declaratorsd))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 's_or_u_spec2) in
    Obj.repr(
# 1998 "parsing_c/parser_c.mly"
                                   ( dt "su" (); _1 )
# 7239 "parsing_c/parser_c.ml"
               : 'struct_or_union_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'struct_or_union2) in
    Obj.repr(
# 1999 "parsing_c/parser_c.mly"
                                  ( et "su" (); _1 )
# 7246 "parsing_c/parser_c.ml"
               : 'struct_or_union))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'struct_decl2) in
    Obj.repr(
# 2000 "parsing_c/parser_c.mly"
                           ( et "struct" (); _1 )
# 7253 "parsing_c/parser_c.ml"
               : 'struct_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2002 "parsing_c/parser_c.mly"
                 ( et "dotdot" (); _1 )
# 7260 "parsing_c/parser_c.ml"
               : 'dotdot))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'const_expr) in
    Obj.repr(
# 2003 "parsing_c/parser_c.mly"
                        ( dt "const_expr2" (); _1 )
# 7267 "parsing_c/parser_c.ml"
               : 'const_expr2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'struct_decl_list) in
    Obj.repr(
# 2006 "parsing_c/parser_c.mly"
                     ( _1 )
# 7274 "parsing_c/parser_c.ml"
               : 'struct_decl_list_gcc))
; (fun __caml_parser_env ->
    Obj.repr(
# 2007 "parsing_c/parser_c.mly"
                         ( [] )
# 7280 "parsing_c/parser_c.ml"
               : 'struct_decl_list_gcc))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : 'tobrace_enum) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'enumerator_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'gcc_comma_opt_struct) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_enum) in
    Obj.repr(
# 2015 "parsing_c/parser_c.mly"
     ( Enum (None,    _3),           [_1;_2;_5] @ _4 )
# 7291 "parsing_c/parser_c.ml"
               : 'enum_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : 'ident) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : 'tobrace_enum) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'enumerator_list) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : 'gcc_comma_opt_struct) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_enum) in
    Obj.repr(
# 2017 "parsing_c/parser_c.mly"
     ( Enum (Some (fst _2), _4),     [_1; snd _2; _3;_6] @ _5 )
# 7303 "parsing_c/parser_c.ml"
               : 'enum_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'ident) in
    Obj.repr(
# 2019 "parsing_c/parser_c.mly"
     ( EnumName (fst _2),       [_1; snd _2] )
# 7311 "parsing_c/parser_c.ml"
               : 'enum_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'idente) in
    Obj.repr(
# 2022 "parsing_c/parser_c.mly"
                          ( _1, None     )
# 7318 "parsing_c/parser_c.ml"
               : 'enumerator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'idente) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'const_expr) in
    Obj.repr(
# 2023 "parsing_c/parser_c.mly"
                          ( _1, Some (_2, _3) )
# 7327 "parsing_c/parser_c.ml"
               : 'enumerator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'ident_cpp) in
    Obj.repr(
# 2030 "parsing_c/parser_c.mly"
                  ( LP.add_ident (str_of_name _1); _1 )
# 7334 "parsing_c/parser_c.ml"
               : 'idente))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'function_def) in
    Obj.repr(
# 2037 "parsing_c/parser_c.mly"
                                     ( fixFunc _1 )
# 7341 "parsing_c/parser_c.ml"
               : 'function_definition))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl) in
    Obj.repr(
# 2040 "parsing_c/parser_c.mly"
                  ( [_1 Ast_c.LocalDecl]   )
# 7348 "parsing_c/parser_c.ml"
               : 'decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'decl_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'decl) in
    Obj.repr(
# 2041 "parsing_c/parser_c.mly"
                  ( _1 @ [_2 Ast_c.LocalDecl] )
# 7356 "parsing_c/parser_c.ml"
               : 'decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.cpp_directive) in
    Obj.repr(
# 2045 "parsing_c/parser_c.mly"
                                    ( )
# 7363 "parsing_c/parser_c.ml"
               : 'cpp_directive_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'cpp_directive_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.cpp_directive) in
    Obj.repr(
# 2046 "parsing_c/parser_c.mly"
                                    ( )
# 7371 "parsing_c/parser_c.ml"
               : 'cpp_directive_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'start_fun) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'compound) in
    Obj.repr(
# 2049 "parsing_c/parser_c.mly"
                           ( LP.del_scope(); (_1, _2, None) )
# 7379 "parsing_c/parser_c.ml"
               : 'function_def))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'start_fun) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'cpp_directive_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'compound) in
    Obj.repr(
# 2050 "parsing_c/parser_c.mly"
                                         ( LP.del_scope(); (_1, _3, None) )
# 7388 "parsing_c/parser_c.ml"
               : 'function_def))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'start_fun) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'decl_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'compound) in
    Obj.repr(
# 2051 "parsing_c/parser_c.mly"
                                     (
     (* TODO: undo the typedef added ? *)
     LP.del_scope();
     (_1, _3, Some _2)
   )
# 7401 "parsing_c/parser_c.ml"
               : 'function_def))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'start_fun2) in
    Obj.repr(
# 2058 "parsing_c/parser_c.mly"
  ( LP.new_scope();
    let (fn, endattrs) = _1 in
    fix_add_params_ident fn;
    (* toreput? !LP._lexer_hint.toplevel <- false;  *)
    (fn,endattrs)
  )
# 7413 "parsing_c/parser_c.ml"
               : 'start_fun))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'decl_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'declaratorfd) in
    Obj.repr(
# 2066 "parsing_c/parser_c.mly"
     ( let (returnType,storage) = fixDeclSpecForFuncDef (snd _1) in
       let (id, attrs, endattrs) = _2 in
       (fst id, fixOldCDecl ((snd id) returnType) , storage, (fst (fst _1))@(snd (fst _1))@attrs), endattrs
     )
# 7424 "parsing_c/parser_c.ml"
               : 'start_fun2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'ctor_dtor) in
    Obj.repr(
# 2070 "parsing_c/parser_c.mly"
              ( _1, [] )
# 7431 "parsing_c/parser_c.ml"
               : 'start_fun2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'topar) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 2073 "parsing_c/parser_c.mly"
                                (
     let id = RegularName (mk_string_wrap _1) in
     let ret = mk_ty NoType [] in
     let ty = mk_ty (FunctionType (ret, (([], (false, []))))) [_2;_3] in
     let storage = ((NoSto,false),[]) in
     let attrs = [] in
     (id, ty, storage, attrs) )
# 7446 "parsing_c/parser_c.ml"
               : 'ctor_dtor))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'topar) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'parameter_type_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 2080 "parsing_c/parser_c.mly"
                                                    (
     let id = RegularName (mk_string_wrap _1) in
     let ret = mk_ty NoType [] in
     let ty = mk_ty (FunctionType (ret, _3)) [_2;_4] in
     let storage = ((NoSto,false),[]) in
     let attrs = [] in
     (id, ty, storage, attrs) )
# 7462 "parsing_c/parser_c.ml"
               : 'ctor_dtor))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'declarator) in
    Obj.repr(
# 2102 "parsing_c/parser_c.mly"
   ( et "declaratorfd" (); let (attr,dec) = _1 in dec, attr, [] )
# 7469 "parsing_c/parser_c.ml"
               : 'declaratorfd))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'end_attributes) in
    Obj.repr(
# 2105 "parsing_c/parser_c.mly"
   ( et "declaratorfd" (); let (attr,dec) = _1 in dec, attr, _2 )
# 7477 "parsing_c/parser_c.ml"
               : 'declaratorfd))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : (Ast_c.info * bool ref)) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 2114 "parsing_c/parser_c.mly"
     (
       let (i1, in_ifdef) = _1 in
       let (s, i2) = _2 in

       (* redo some lexing work :( *)
       let inc_file =
         match () with
         | _ when s =~ "^\"\\(.*\\)\"$" ->
             Local (Common.split "/" (matched1 s))
         | _ when s =~ "^\\<\\(.*\\)\\>$" ->
             NonLocal (Common.split "/" (matched1 s))
         | _ ->
             Weird s
       in
       Include { i_include = (inc_file, [i1;i2]);
                 i_rel_pos = Ast_c.noRelPos();
                 i_overall_rel_pos = Ast_c.noRelPos();
                 i_is_in_ifdef = !in_ifdef;
                 i_content = Ast_c.noi_content;
       }
     )
# 7505 "parsing_c/parser_c.ml"
               : Ast_c.cpp_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : (string * Ast_c.info)) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'define_val) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2137 "parsing_c/parser_c.mly"
     ( Define ((fst _2, [_1; snd _2;_4]), (DefineVar, _3)) )
# 7515 "parsing_c/parser_c.ml"
               : Ast_c.cpp_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : (string * Ast_c.info)) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : 'param_define_list) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : 'define_val) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2144 "parsing_c/parser_c.mly"
     ( Define
         ((fst _2, [_1; snd _2; _7]),
           (DefineFunc (_4, [_3;_5]), _6))
     )
# 7531 "parsing_c/parser_c.ml"
               : Ast_c.cpp_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : (string * Ast_c.info)) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2150 "parsing_c/parser_c.mly"
     ( Define((fst _2, [_1; snd _2; _3]), (Undef,DefineEmpty)) )
# 7540 "parsing_c/parser_c.ml"
               : Ast_c.cpp_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : string * Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'pragma_strings) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2153 "parsing_c/parser_c.mly"
     ( Pragma((RegularName (mk_string_wrap _2),_3),[_1;_4]) )
# 7550 "parsing_c/parser_c.ml"
               : Ast_c.cpp_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2155 "parsing_c/parser_c.mly"
                      ( OtherDirective ([_1]) )
# 7557 "parsing_c/parser_c.ml"
               : Ast_c.cpp_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 2158 "parsing_c/parser_c.mly"
                 ( [(fst _1, [snd _1])] )
# 7564 "parsing_c/parser_c.ml"
               : 'pragma_strings))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'pragma_strings) in
    Obj.repr(
# 2159 "parsing_c/parser_c.mly"
                                ( (fst _1, [snd _1])::_2 )
# 7572 "parsing_c/parser_c.ml"
               : 'pragma_strings))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.expression) in
    Obj.repr(
# 2165 "parsing_c/parser_c.mly"
             ( DefineExpr _1 )
# 7579 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 2166 "parsing_c/parser_c.mly"
             ( DefineStmt _1 )
# 7586 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl) in
    Obj.repr(
# 2167 "parsing_c/parser_c.mly"
             ( DefineStmt (mk_st (Decl (_1 Ast_c.NotLocalDecl)) Ast_c.noii) )
# 7593 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec) in
    Obj.repr(
# 2177 "parsing_c/parser_c.mly"
     ( let returnType = fixDeclSpecForMacro (snd _1) in
       DefineType returnType
     )
# 7602 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'decl_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'abstract_declarator) in
    Obj.repr(
# 2181 "parsing_c/parser_c.mly"
     ( let returnType = fixDeclSpecForMacro (snd _1) in
       let typ = (snd _2) returnType in
       DefineType typ
     )
# 7613 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'stat_or_decl) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'stat_or_decl_list) in
    Obj.repr(
# 2193 "parsing_c/parser_c.mly"
     ( DefineMulti
	 (List.map
	    (function
		StmtElem e -> e
	      | _ -> failwith "unexpected statement for DefineMulti")
	    (_1 :: _2)) )
# 7626 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'function_definition) in
    Obj.repr(
# 2207 "parsing_c/parser_c.mly"
                       ( DefineFunction _1 )
# 7633 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : 'initialize_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'gcc_comma_opt_struct) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'comma_opt) in
    Obj.repr(
# 2210 "parsing_c/parser_c.mly"
    ( DefineInit (InitList (List.rev _2), [_1;_4] @ _3 @ _5)  )
# 7644 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.statement) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.expression) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2214 "parsing_c/parser_c.mly"
     (
       (* TOREPUT
       if fst $5 <> "0"
       then pr2 "WEIRD: in macro and have not a while(0)";
       *)
       DefineDoWhileZero ((_2,_5),   [_1;_3;_4;_6])
     )
# 7662 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'asmbody) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2222 "parsing_c/parser_c.mly"
                                         ( DefineTodo )
# 7672 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'asmbody) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2223 "parsing_c/parser_c.mly"
                                         ( DefineTodo )
# 7683 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    Obj.repr(
# 2227 "parsing_c/parser_c.mly"
                   ( DefineEmpty )
# 7689 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 2233 "parsing_c/parser_c.mly"
                        ( mk_string_wrap _1 )
# 7696 "parsing_c/parser_c.ml"
               : 'param_define))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 2234 "parsing_c/parser_c.mly"
                        ( mk_string_wrap _1 )
# 7703 "parsing_c/parser_c.ml"
               : 'param_define))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 2235 "parsing_c/parser_c.mly"
                        ( mk_string_wrap _1 )
# 7710 "parsing_c/parser_c.ml"
               : 'param_define))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2236 "parsing_c/parser_c.mly"
                        ( "...", [_1] )
# 7717 "parsing_c/parser_c.ml"
               : 'param_define))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2238 "parsing_c/parser_c.mly"
                        ( "register", [_1] )
# 7724 "parsing_c/parser_c.ml"
               : 'param_define))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'ifdef) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'cpp_ifdef_statement) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_statement_tail) in
    Obj.repr(
# 2245 "parsing_c/parser_c.mly"
     ( IfdefStmt1 ((_1::fst _3), (_2::snd _3)), [] )
# 7733 "parsing_c/parser_c.ml"
               : 'cpp_ifdef_statement))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 2246 "parsing_c/parser_c.mly"
             (_1)
# 7740 "parsing_c/parser_c.ml"
               : 'cpp_ifdef_statement))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'ifdefelse) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'cpp_ifdef_statement) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'endif) in
    Obj.repr(
# 2249 "parsing_c/parser_c.mly"
                                       ( [_1;_3], [_2] )
# 7749 "parsing_c/parser_c.ml"
               : 'cpp_ifdef_statement_tail))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'ifdefelif) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'cpp_ifdef_statement) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_statement_tail) in
    Obj.repr(
# 2251 "parsing_c/parser_c.mly"
   ( (_1::fst _3), (_2::snd _3) )
# 7758 "parsing_c/parser_c.ml"
               : 'cpp_ifdef_statement_tail))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (Ast_c.ifdef_guard * (int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 2255 "parsing_c/parser_c.mly"
     ( let (cond,tag,ii) = _1 in
       IfdefDirective ((Ifdef cond, IfdefTag (Common.some !tag)),  [ii]) )
# 7766 "parsing_c/parser_c.ml"
               : 'ifdef))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : ((int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 2260 "parsing_c/parser_c.mly"
     ( let (tag,ii) = _1 in
       IfdefDirective ((IfdefElse, IfdefTag (Common.some !tag)), [ii]) )
# 7774 "parsing_c/parser_c.ml"
               : 'ifdefelse))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (Ast_c.ifdef_guard * (int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 2265 "parsing_c/parser_c.mly"
     ( let (cond,tag,ii) = _1 in
       IfdefDirective ((IfdefElseif cond, IfdefTag (Common.some !tag)), [ii]) )
# 7782 "parsing_c/parser_c.ml"
               : 'ifdefelif))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : ((int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 2270 "parsing_c/parser_c.mly"
     ( let (tag,ii) = _1 in
       IfdefDirective ((IfdefEndif, IfdefTag (Common.some !tag)), [ii]) )
# 7790 "parsing_c/parser_c.ml"
               : 'endif))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'ifdef) in
    Obj.repr(
# 2274 "parsing_c/parser_c.mly"
         ( _1 )
# 7797 "parsing_c/parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'ifdefelse) in
    Obj.repr(
# 2275 "parsing_c/parser_c.mly"
             ( _1 )
# 7804 "parsing_c/parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'ifdefelif) in
    Obj.repr(
# 2276 "parsing_c/parser_c.mly"
             ( _1 )
# 7811 "parsing_c/parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'endif) in
    Obj.repr(
# 2277 "parsing_c/parser_c.mly"
         ( _1 )
# 7818 "parsing_c/parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (bool * (int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 2280 "parsing_c/parser_c.mly"
     ( let (_b, tag,ii) = _1 in
       IfdefDirective ((Ifdef Gnone, IfdefTag (Common.some !tag)), [ii]) )
# 7826 "parsing_c/parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (bool * (int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 2283 "parsing_c/parser_c.mly"
     ( let (_b, tag,ii) = _1 in
       IfdefDirective ((Ifdef Gnone, IfdefTag (Common.some !tag)), [ii]) )
# 7834 "parsing_c/parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (bool * (int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 2286 "parsing_c/parser_c.mly"
     ( let (_b, tag,ii) = _1 in
       IfdefDirective ((Ifdef Gnone, IfdefTag (Common.some !tag)), [ii]) )
# 7842 "parsing_c/parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : 'identifier) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : 'argument_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : 'end_attributes_opt) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2297 "parsing_c/parser_c.mly"
     (
       if args_are_params _3
       then
	 (* if all args are params, assume it is a prototype of a function
	    with no return type *)
	 let parameters = args_to_params _3 None in
	 let paramlist = (parameters, (false, [])) in (* no varargs *)
	 let id = RegularName (mk_string_wrap _1) in
	 let ret =
	   warning "type defaults to 'int'"
	     (mk_ty defaultInt [fakeInfo fake_pi]) in
	 let ty =
	   fixOldCDecl (mk_ty (FunctionType (ret, paramlist)) [_2;_4]) in
	 let attrs = Ast_c.noattr in
	 let midattrs = Ast_c.noattr in
	 let sto = (NoSto, false), [] in
	 let iistart = Ast_c.fakeInfo () in
	 Declaration(
	 DeclList ([{v_namei = Some (id,NoInit); v_type = ty;
                      v_storage = unwrap sto; v_local = NotLocalDecl;
                      v_attr = attrs; v_midattr = midattrs; v_endattr = _5;
		      v_type_bis = ref None;
                    },[]],
                   (_6::iistart::snd sto)))
       else
	 Declaration
	   (MacroDecl
             ((NoSto, fst _1, _3, _5, true),
              [snd _1;_2;_4;_6;fakeInfo()]))
           (* old: MacroTop (fst $1, $3,    [snd $1;$2;$4;$5])  *)
     )
# 7884 "parsing_c/parser_c.ml"
               : 'cpp_other))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : 'identifier) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'compound) in
    Obj.repr(
# 2332 "parsing_c/parser_c.mly"
                                                 (
   let parameters = args_to_params _3 (Some (snd _1)) in
   let paramlist = (parameters, (false, [])) in (* no varargs *)
   let fninfo =
     let id = RegularName (mk_string_wrap _1) in
     let ret =
       warning "type defaults to 'int'"
	 (mk_ty defaultInt [fakeInfo fake_pi]) in
     let ty = mk_ty (FunctionType (ret, paramlist)) [_2;_4] in
     let attrs = Ast_c.noattr in
     let sto = (NoSto, false), [] in
     (id, fixOldCDecl ty, sto, attrs) in
   let fundef = fixFunc ((fninfo, []), _5, None) in
   Definition fundef
 )
# 7909 "parsing_c/parser_c.ml"
               : 'cpp_other))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'identifier) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'argument_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2350 "parsing_c/parser_c.mly"
     ( Declaration
	 (MacroDecl
           ((NoSto, fst _1, _3, Ast_c.noattr, false),
            [snd _1;_2;_4;fakeInfo()])) )
# 7922 "parsing_c/parser_c.ml"
               : 'cpp_other))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'identifier) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2356 "parsing_c/parser_c.mly"
                      ( EmptyDef [snd _1;_2] )
# 7930 "parsing_c/parser_c.ml"
               : 'cpp_other))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'function_definition) in
    Obj.repr(
# 2365 "parsing_c/parser_c.mly"
                                     ( Definition _1 )
# 7937 "parsing_c/parser_c.ml"
               : 'external_declaration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl) in
    Obj.repr(
# 2366 "parsing_c/parser_c.mly"
                                     ( Declaration (_1 Ast_c.NotLocalDecl) )
# 7944 "parsing_c/parser_c.ml"
               : 'external_declaration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : string * Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'translation_unit) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2371 "parsing_c/parser_c.mly"
     ( !LP._lexer_hint.context_stack <- [LP.InTopLevel];
       Namespace (_4, [_1; snd _2; _3; _5]) )
# 7956 "parsing_c/parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'external_declaration) in
    Obj.repr(
# 2374 "parsing_c/parser_c.mly"
                                                ( _1 )
# 7963 "parsing_c/parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.cpp_directive) in
    Obj.repr(
# 2378 "parsing_c/parser_c.mly"
     ( CppTop _1 )
# 7970 "parsing_c/parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_other) in
    Obj.repr(
# 2380 "parsing_c/parser_c.mly"
     ( _1 )
# 7977 "parsing_c/parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_directive) in
    Obj.repr(
# 2382 "parsing_c/parser_c.mly"
     ( IfdefTop _1 )
# 7984 "parsing_c/parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'asmbody) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2385 "parsing_c/parser_c.mly"
                                                ( EmptyDef [_1;_2;_4;_5] )
# 7995 "parsing_c/parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2392 "parsing_c/parser_c.mly"
              ( EmptyDef [_1] )
# 8002 "parsing_c/parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2395 "parsing_c/parser_c.mly"
              ( FinalDef _1 )
# 8009 "parsing_c/parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2404 "parsing_c/parser_c.mly"
                  ( LP.push_context LP.InFunction; LP.new_scope (); _1 )
# 8016 "parsing_c/parser_c.ml"
               : 'tobrace))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2405 "parsing_c/parser_c.mly"
                  ( LP.pop_context();              LP.del_scope (); _1 )
# 8023 "parsing_c/parser_c.ml"
               : 'tcbrace))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2407 "parsing_c/parser_c.mly"
                      ( LP.push_context LP.InEnum; _1 )
# 8030 "parsing_c/parser_c.ml"
               : 'tobrace_enum))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2408 "parsing_c/parser_c.mly"
                      ( LP.pop_context (); _1 )
# 8037 "parsing_c/parser_c.ml"
               : 'tcbrace_enum))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2410 "parsing_c/parser_c.mly"
                     ( LP.push_context LP.InInitializer; _1 )
# 8044 "parsing_c/parser_c.ml"
               : 'tobrace_ini))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2411 "parsing_c/parser_c.mly"
                     ( LP.pop_context (); _1 )
# 8051 "parsing_c/parser_c.ml"
               : 'tcbrace_ini))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2413 "parsing_c/parser_c.mly"
                        ( LP.push_context LP.InStruct; _1)
# 8058 "parsing_c/parser_c.ml"
               : 'tobrace_struct))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2414 "parsing_c/parser_c.mly"
                        ( LP.pop_context (); _1 )
# 8065 "parsing_c/parser_c.ml"
               : 'tcbrace_struct))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2420 "parsing_c/parser_c.mly"
     ( LP.new_scope ();et "topar" ();
       LP.push_context LP.InParameter;
       _1
     )
# 8075 "parsing_c/parser_c.ml"
               : 'topar))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2425 "parsing_c/parser_c.mly"
     ( LP.del_scope ();dt "tcpar" ();
       LP.pop_context ();
       _1
     )
# 8085 "parsing_c/parser_c.ml"
               : 'tcpar))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2431 "parsing_c/parser_c.mly"
                                   ( LP.push_context LP.InGccAttribute; [_1;_2] )
# 8093 "parsing_c/parser_c.ml"
               : 'tdouble_opar_gcc_attr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2432 "parsing_c/parser_c.mly"
                                   ( LP.pop_context (); [_1;_2] )
# 8101 "parsing_c/parser_c.ml"
               : 'tdouble_cpar_gcc_attr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'string_elem) in
    Obj.repr(
# 2466 "parsing_c/parser_c.mly"
               ( _1 )
# 8108 "parsing_c/parser_c.ml"
               : 'string_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'string_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'string_elem) in
    Obj.repr(
# 2467 "parsing_c/parser_c.mly"
                           ( _1 @ _2 )
# 8116 "parsing_c/parser_c.ml"
               : 'string_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'colon_asm) in
    Obj.repr(
# 2470 "parsing_c/parser_c.mly"
             ( [_1] )
# 8123 "parsing_c/parser_c.ml"
               : 'colon_asm_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'colon_asm_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'colon_asm) in
    Obj.repr(
# 2471 "parsing_c/parser_c.mly"
                             ( _1 @ [_2] )
# 8131 "parsing_c/parser_c.ml"
               : 'colon_asm_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'colon_option) in
    Obj.repr(
# 2474 "parsing_c/parser_c.mly"
                ( [_1, []] )
# 8138 "parsing_c/parser_c.ml"
               : 'colon_option_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'colon_option_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'colon_option) in
    Obj.repr(
# 2475 "parsing_c/parser_c.mly"
                                         ( _1 @ [_3, [_2]] )
# 8147 "parsing_c/parser_c.ml"
               : 'colon_option_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'argument_ne) in
    Obj.repr(
# 2479 "parsing_c/parser_c.mly"
                                         ( [_1, []] )
# 8154 "parsing_c/parser_c.ml"
               : 'argument_list_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list_ne) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'argument) in
    Obj.repr(
# 2480 "parsing_c/parser_c.mly"
                                    ( _1 @ [_3,    [_2]] )
# 8163 "parsing_c/parser_c.ml"
               : 'argument_list_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'argument) in
    Obj.repr(
# 2483 "parsing_c/parser_c.mly"
                                      ( [_1, []] )
# 8170 "parsing_c/parser_c.ml"
               : 'argument_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'argument) in
    Obj.repr(
# 2484 "parsing_c/parser_c.mly"
                                 ( _1 @ [_3,    [_2]] )
# 8179 "parsing_c/parser_c.ml"
               : 'argument_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'struct_decl) in
    Obj.repr(
# 2494 "parsing_c/parser_c.mly"
                                 ( [_1] )
# 8186 "parsing_c/parser_c.ml"
               : 'struct_decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'struct_decl_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'struct_decl) in
    Obj.repr(
# 2495 "parsing_c/parser_c.mly"
                                 ( _1 @ [_2] )
# 8194 "parsing_c/parser_c.ml"
               : 'struct_decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'struct_declarator) in
    Obj.repr(
# 2499 "parsing_c/parser_c.mly"
                                                   ( [_1,           []] )
# 8201 "parsing_c/parser_c.ml"
               : 'struct_declarator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'struct_declarator_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'cpp_directive_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'struct_declarator) in
    Obj.repr(
# 2501 "parsing_c/parser_c.mly"
     ( _1 @ [_4, [_2]] )
# 8211 "parsing_c/parser_c.ml"
               : 'struct_declarator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'struct_declarator_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'struct_declarator) in
    Obj.repr(
# 2502 "parsing_c/parser_c.mly"
                                                   ( _1 @ [_3,     [_2]] )
# 8220 "parsing_c/parser_c.ml"
               : 'struct_declarator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'enumerator) in
    Obj.repr(
# 2506 "parsing_c/parser_c.mly"
                                     ( [_1,          []]   )
# 8227 "parsing_c/parser_c.ml"
               : 'enumerator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'enumerator_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'cpp_directive_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'enumerator) in
    Obj.repr(
# 2508 "parsing_c/parser_c.mly"
     ( _1 @ [_4, [_2]] )
# 8237 "parsing_c/parser_c.ml"
               : 'enumerator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'enumerator_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'enumerator) in
    Obj.repr(
# 2509 "parsing_c/parser_c.mly"
                                     ( _1 @ [_3,    [_2]] )
# 8246 "parsing_c/parser_c.ml"
               : 'enumerator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'init_declarator) in
    Obj.repr(
# 2513 "parsing_c/parser_c.mly"
                                               ( [_1,   []] )
# 8253 "parsing_c/parser_c.ml"
               : 'init_declarator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'init_declarator_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'cpp_directive_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'init_declarator_attrs) in
    Obj.repr(
# 2515 "parsing_c/parser_c.mly"
     ( _1 @ [_4, [_2]] )
# 8263 "parsing_c/parser_c.ml"
               : 'init_declarator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'init_declarator_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'init_declarator_attrs) in
    Obj.repr(
# 2516 "parsing_c/parser_c.mly"
                                                     ( _1 @ [_3, [_2]] )
# 8272 "parsing_c/parser_c.ml"
               : 'init_declarator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_decl) in
    Obj.repr(
# 2520 "parsing_c/parser_c.mly"
                                        ( [_1, []] )
# 8279 "parsing_c/parser_c.ml"
               : 'parameter_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'parameter_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_decl) in
    Obj.repr(
# 2521 "parsing_c/parser_c.mly"
                                        ( _1 @ [_3,  [_2]] )
# 8288 "parsing_c/parser_c.ml"
               : 'parameter_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2524 "parsing_c/parser_c.mly"
                           ( [_1] )
# 8295 "parsing_c/parser_c.ml"
               : 'taction_list_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'taction_list_ne) in
    Obj.repr(
# 2525 "parsing_c/parser_c.mly"
                           ( _1 :: _2 )
# 8303 "parsing_c/parser_c.ml"
               : 'taction_list_ne))
; (fun __caml_parser_env ->
    Obj.repr(
# 2533 "parsing_c/parser_c.mly"
                        ( [] )
# 8309 "parsing_c/parser_c.ml"
               : 'taction_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'taction_list) in
    Obj.repr(
# 2534 "parsing_c/parser_c.mly"
                        ( _1 :: _2 )
# 8317 "parsing_c/parser_c.ml"
               : 'taction_list))
; (fun __caml_parser_env ->
    Obj.repr(
# 2537 "parsing_c/parser_c.mly"
                   ( [] )
# 8323 "parsing_c/parser_c.ml"
               : 'param_define_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'param_define) in
    Obj.repr(
# 2538 "parsing_c/parser_c.mly"
                                          ( [_1, []] )
# 8330 "parsing_c/parser_c.ml"
               : 'param_define_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'param_define_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'param_define) in
    Obj.repr(
# 2539 "parsing_c/parser_c.mly"
                                          ( _1 @ [_3, [_2]] )
# 8339 "parsing_c/parser_c.ml"
               : 'param_define_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'designator) in
    Obj.repr(
# 2542 "parsing_c/parser_c.mly"
              ( [_1] )
# 8346 "parsing_c/parser_c.ml"
               : 'designator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'designator_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'designator) in
    Obj.repr(
# 2543 "parsing_c/parser_c.mly"
                              ( _1 @ [_2] )
# 8354 "parsing_c/parser_c.ml"
               : 'designator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'attribute) in
    Obj.repr(
# 2546 "parsing_c/parser_c.mly"
             ( [_1] )
# 8361 "parsing_c/parser_c.ml"
               : 'attribute_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'attribute_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attribute) in
    Obj.repr(
# 2547 "parsing_c/parser_c.mly"
                            ( _1 @ [_2] )
# 8369 "parsing_c/parser_c.ml"
               : 'attribute_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'attribute_list) in
    Obj.repr(
# 2549 "parsing_c/parser_c.mly"
                           ( _1 )
# 8376 "parsing_c/parser_c.ml"
               : 'attributes))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 2552 "parsing_c/parser_c.mly"
                 ( MacroAttr (fst _1), [snd _1] )
# 8383 "parsing_c/parser_c.ml"
               : 'end_attr_arg))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : (string * Ast_c.info)) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'argument_list_ne) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2554 "parsing_c/parser_c.mly"
     ( MacroAttrArgs (fst _1,_3),[snd _1;_2;_4] )
# 8393 "parsing_c/parser_c.ml"
               : 'end_attr_arg))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'tdouble_opar_gcc_attr) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'attr_arg_gcc) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tdouble_cpar_gcc_attr) in
    Obj.repr(
# 2557 "parsing_c/parser_c.mly"
                                                                             ( GccAttribute _3, [_1]@_2@_4 )
# 8403 "parsing_c/parser_c.ml"
               : 'end_attribute_gcc))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'end_attribute_gcc) in
    Obj.repr(
# 2560 "parsing_c/parser_c.mly"
                     ( [_1] )
# 8410 "parsing_c/parser_c.ml"
               : 'end_attribute_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'end_attr_arg) in
    Obj.repr(
# 2561 "parsing_c/parser_c.mly"
                ( [Attribute _1, []] )
# 8417 "parsing_c/parser_c.ml"
               : 'end_attribute_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'end_attribute_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'end_attribute_gcc) in
    Obj.repr(
# 2562 "parsing_c/parser_c.mly"
                                        ( _1 @ [_2] )
# 8425 "parsing_c/parser_c.ml"
               : 'end_attribute_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'end_attribute_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'end_attr_arg) in
    Obj.repr(
# 2563 "parsing_c/parser_c.mly"
                                   ( _1 @ [Attribute _2, []] )
# 8433 "parsing_c/parser_c.ml"
               : 'end_attribute_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'end_attribute_list) in
    Obj.repr(
# 2565 "parsing_c/parser_c.mly"
                                   ( _1 )
# 8440 "parsing_c/parser_c.ml"
               : 'end_attributes))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'end_attributes) in
    Obj.repr(
# 2568 "parsing_c/parser_c.mly"
                  ( _1 )
# 8447 "parsing_c/parser_c.ml"
               : 'end_attributes_opt))
; (fun __caml_parser_env ->
    Obj.repr(
# 2569 "parsing_c/parser_c.mly"
                   ( [] )
# 8453 "parsing_c/parser_c.ml"
               : 'end_attributes_opt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2572 "parsing_c/parser_c.mly"
          (  [_1] )
# 8460 "parsing_c/parser_c.ml"
               : 'comma_opt))
; (fun __caml_parser_env ->
    Obj.repr(
# 2573 "parsing_c/parser_c.mly"
                    (  []  )
# 8466 "parsing_c/parser_c.ml"
               : 'comma_opt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.expression) in
    Obj.repr(
# 2582 "parsing_c/parser_c.mly"
               ( Some _1 )
# 8473 "parsing_c/parser_c.ml"
               : 'gcc_opt_expr))
; (fun __caml_parser_env ->
    Obj.repr(
# 2583 "parsing_c/parser_c.mly"
                   ( None  )
# 8479 "parsing_c/parser_c.ml"
               : 'gcc_opt_expr))
(* Entry main *)
; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
(* Entry celem *)
; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
(* Entry statement *)
; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
(* Entry expr *)
; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
(* Entry type_name *)
; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
(* Entry cpp_directive *)
; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
(* Entry iteration *)
; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
|]
let yytables =
  { Parsing.actions=yyact;
    Parsing.transl_const=yytransl_const;
    Parsing.transl_block=yytransl_block;
    Parsing.lhs=yylhs;
    Parsing.len=yylen;
    Parsing.defred=yydefred;
    Parsing.dgoto=yydgoto;
    Parsing.sindex=yysindex;
    Parsing.rindex=yyrindex;
    Parsing.gindex=yygindex;
    Parsing.tablesize=yytablesize;
    Parsing.table=yytable;
    Parsing.check=yycheck;
    Parsing.error_function=parse_error;
    Parsing.names_const=yynames_const;
    Parsing.names_block=yynames_block }
let main (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (Parsing.yyparse yytables 1 lexfun lexbuf : Ast_c.program)
let celem (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (Parsing.yyparse yytables 2 lexfun lexbuf : Ast_c.toplevel)
let statement (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (Parsing.yyparse yytables 3 lexfun lexbuf : Ast_c.statement)
let expr (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (Parsing.yyparse yytables 4 lexfun lexbuf : Ast_c.expression)
let type_name (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (Parsing.yyparse yytables 5 lexfun lexbuf : Ast_c.attribute list * Ast_c.fullType)
let cpp_directive (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (Parsing.yyparse yytables 6 lexfun lexbuf : Ast_c.cpp_directive)
let iteration (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (Parsing.yyparse yytables 7 lexfun lexbuf : Ast_c.iteration * Ast_c.info list)
